import React from "react";
import {
  BrowserRouter as Router,
  Routes ,
  Route
} from "react-router-dom";

import Profile from "./pages/Profile";
import ForgotPassword from "./pages/ForgotPassword";
import ResetPassword from "./pages/ResetPassword";
import Login from "./pages/Login";

import StudentsList from "./pages/StudentsList";
import NavigationOptions from "./pages/NavigationOptions";
import Websites from "./pages/Websites";
import CoursesCategories from "./pages/CoursesCategories";
import Courses from "./pages/Courses";
import TreeviewSync from "./pages/TreeviewSync";
import Academy from "./pages/Academy";
import Subjects from "./pages/Subjects";
import Payments from "./pages/Payments";
import Promocodes from "./pages/Promocodes";
import Users from "./pages/Users";
import Roles from "./pages/Roles";
import SmartLearningTopic from "./pages/SmartLearningTopic";
import SmartLearningKeyword from "./pages/SmartLearningKeyword";
import Reports from "./pages/Reports";
import Teachers from "./pages/Teachers";
import Parents from "./pages/Parents";

const getBasename = () => {
  ///return '/'+process.env.PUBLIC_URL.split('/').pop();
  ///return "/reacteasetolearn";
  return "";
};

function App() {

  return (
    <Router basename={getBasename()} >
      <div>
        {/* A <Switch> looks through its children <Route>s and
            renders the first one that matches the current URL. */}
        <Routes> 
          
          <Route exact path="/navigationoptions" element={<NavigationOptions/>} />
          <Route exact path="/students" element={<StudentsList/>} />
          <Route exact path="/websites" element={<Websites/>} />
          <Route exact path="/coursescategories" element={<CoursesCategories/>} />
          <Route exact path="/courses" element={<Courses/>} />
          <Route exact path="/treeviewsync" element={<TreeviewSync/>} />
          <Route exact path="/academy" element={<Academy/>} />
          <Route exact path="/subjects" element={<Subjects/>} />
          <Route exact path="/payments" element={<Payments/>} />
          <Route exact path="/promocodes" element={<Promocodes/>} />
          <Route exact path="/smartlearning" element={<SmartLearningTopic/>} />
          <Route exact path="/keywordcontent" element={<SmartLearningKeyword/>} />
          <Route exact path="/users" element={<Users/>} />
          <Route exact path="/roles" element={<Roles/>} />
          <Route exact path="/datareports" element={<Reports/>} />
          <Route exact path="/teachers" element={<Teachers/>} />
          <Route exact path="/parents" element={<Parents/>} />

          <Route exact path="/forgotpassword" element={<ForgotPassword/>} />
          <Route exact path="/resetpassword" element={<ResetPassword/>} />  
          <Route exact path="/profile" element={<Profile/>} />  

          
          <Route exact path="/login" element={<Login />} />  
          <Route exact path="/" element={<Login />} />  
          
          
        </Routes >
      </div>
    </Router>
  );
}

export default App;
