import * as React from 'react';
import TextField from '@mui/material/TextField';
import Autocomplete from '@mui/material/Autocomplete';
import CircularProgress from '@mui/material/CircularProgress';
import { makeStyles } from "@material-ui/core/styles";
import axios from 'axios';
import {API_URL} from '../utils/EnvVars';


const useStyles = makeStyles({
    paper: {
      fontSize: '12px !important',    
    }
  });

function sleep(delay = 0) {
  return new Promise((resolve) => {
    setTimeout(resolve, delay);
  });
}

export default function Asynchronous(props) {
  const classes = useStyles();
  const [open, setOpen] = React.useState(false);
  const [options, setOptions] = React.useState([]);
  const loading = open && options.length === 0;
  const [inputVal, setInputVal] = React.useState("");
  
  React.useEffect(() => {
    let active = true;

    if (!loading) {
      return undefined;
    }

    (async () => {
      await sleep(1e3); 
      if (active) {
        //setOptions([...topFilms]);
        axios.get(API_URL+'/admin-keywords')
			   .then(response => {
			 	///console.log("Just Checking >> "+response.data);  
                if(response.data && response.data.responseTxt==='success'){ 
                 setOptions(response.data.list);   
                }               			 				
		})
      }
    })();

    return () => {
      active = false;
    };
  }, [props.templateId,loading]);

  React.useEffect(() => { //setApiData
    if (!open) {
      setOptions([]);
    }
  }, [open]);

  function selectedValue(obj){
    if(obj){
        props.toCallParentMethod(obj);
    }    
  }

  return (
    <>
    <Autocomplete 
      value={{ title: props.title }}
      id="search-input-topicbox"
      freeSolo={false}
      classes={{ paper: classes.paper }}
      sx={{ width: '99%' }}
      open={open}
      onOpen={() => {
        setOpen(true);
      }}
      onClose={() => {
        setOpen(false);
      }}
      isOptionEqualToValue={(option, value) => option.title === value.title}
      getOptionLabel={(option) => ((option && option.title)?option.title:'')}
      options={options}
      loading={loading}
      onChange={(event, myObj) => selectedValue(myObj)}
      // onInputChange={(event, newInput) => {
      //   setInputVal(newInput);
      // }}     
      size="small"
      renderInput={(params) => (
        <TextField           
          {...params}
          label={'Keyword'}           
          InputProps={{
            ...params.InputProps,
            endAdornment: (
              <React.Fragment>
                {loading ? <CircularProgress color="inherit" size={20} /> : null}
                {params.InputProps.endAdornment}
              </React.Fragment>
            ),
          }}
          
        />
      )}
    />


    
    </>
  );
}

