import * as React from 'react';
import TextField from '@mui/material/TextField';
import Autocomplete from '@mui/material/Autocomplete';
import CircularProgress from '@mui/material/CircularProgress';
import { makeStyles } from "@material-ui/core/styles";
import axios from 'axios';
import { useSelector } from 'react-redux';
import {API_URL} from '../utils/EnvVars';


const useStyles = makeStyles({
    paper: {
      fontSize: '12px !important',    
    }
  });

function sleep(delay = 0) {
  return new Promise((resolve) => {
    setTimeout(resolve, delay);
  });
}

export default function Asynchronous(props) {
  const userObj = useSelector(state => state.userDetails);
  const classes = useStyles();
  const [open, setOpen] = React.useState(false);
  const [options, setOptions] = React.useState([]);
  const loading = open && options.length === 0;

  React.useEffect(() => {
    let active = true;

    if (!loading) {
      return undefined;
    }

    (async () => {
      await sleep(1e3); 
      if (active) {
        //setOptions([...topFilms]);
        axios.get(props.flag=='Topic'?API_URL+'/coursestopics?templateId='+userObj.templateId:API_URL+'/courseskeywords?templateId='+userObj.templateId)
			   .then(response => {
			 	///console.log("Just Checking >> "+response.data);  
				 ///setTreeViewData(response.data);	
                 setOptions(response.data);                 			 				
		})
      }
    })();

    return () => {
      active = false;
    };
  }, [userObj,loading]);

  React.useEffect(() => { //setApiData
    if (!open) {
      setOptions([]);
    }
  }, [open]);

  function selectedValue(obj){
    if(obj){
        props.toCallParentMethod(props.flag,obj);
    }    
  }

  return (
    <>    
    <Autocomplete
      id="search-input-topicbox"
      freeSolo
      classes={{ paper: classes.paper }}
      sx={{ width: 300 }}
      open={open}
      onOpen={() => {
        setOpen(true);
      }}
      onClose={() => {
        setOpen(false);
      }}
      isOptionEqualToValue={(option, value) => option.title === value.title}
      getOptionLabel={(option) => option.title}
      options={options}
      loading={loading}
      onChange={(event, myObj) => selectedValue(myObj)}          
      renderInput={(params) => (
        <TextField 
          {...params}
          label={props.label} 
          InputProps={{
            ...params.InputProps,
            endAdornment: (
              <React.Fragment>
                {loading ? <CircularProgress color="inherit" size={20} /> : null}
                {params.InputProps.endAdornment}
              </React.Fragment>
            ),
          }}
          
        />
      )}
    />
    </>
  );
}

