import React from 'react';
import {Box, Container, Grid } from '@material-ui/core';
import Highcharts from 'highcharts';
import HighchartsReact from 'highcharts-react-official';
import LinearProgress from '@mui/material/LinearProgress';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import Cookies from 'js-cookie';
import moment from 'moment';
import { useSelector } from 'react-redux';
import {API_URL} from '../utils/EnvVars';
import Header from "./HeaderMy";
import 'font-awesome/css/font-awesome.min.css';
import '../styles/bizofficer-a.css';



  export default function Execute() {
	const userObj = useSelector(state => state.userDetails);	
	const isloggedin = Cookies.get('isloggedin');
	const [redirect, setRedirect] = React.useState(false);
	const [selfTestData, setSelfTestData] = React.useState([]);
	const [topicTestData, setTopicTestData] = React.useState([]);
	const [mockTestData, setMockTestData] = React.useState([]);
	const [classTestData, setClassTestData] = React.useState([]);
	const [clasTestList, setClasTestList] = React.useState([]);

	const [chartSelfAssessorOneData, setChartSelfAssessorOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartSelfAssessorTwoData, setChartSelfAssessorTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartSelfAssessorThreeData, setChartSelfAssessorThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	const [chartTopicTestOneData, setChartTopicTestOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartTopicTestTwoData, setChartTopicTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartTopicTestThreeData, setChartTopicTestThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	const [chartMockTestOneData, setChartMockTestOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: ' '},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartMockTestTwoData, setChartMockTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartMockTestThreeData, setChartMockTestThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	const [chartClassTestOneData, setChartClassTestOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: ' '},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartClassTestTwoData, setChartClassTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartClassTestThreeData, setChartClassTestThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	////console.log("AA studentName >>> "+userObj.studentName);
	// check if logged in
	React.useEffect(() => {
		if(!isloggedin){
			window.location.href='login';
		}else if(redirect){
			window.location.href='selfassessor';
		}
	}, [isloggedin,redirect]); 

	React.useEffect(() => {
		if(userObj && userObj.organisationId){
			getApiData(userObj.organisationId,userObj.studentId);	
		}
		if(userObj && userObj!=null && userObj.schools!=null && userObj.schools[0]!=null && userObj.schools[0].schoolId>0){
			getApiDataClassTest(userObj.schools[0].schoolId,userObj.schools[0].className,userObj.schools[0].subjects);	
		}
	}, [userObj]); 
	
	async function getApiData(organisationId,studentId){
		if(organisationId && studentId){
			try {
				axios.get(API_URL+'/dashboard?organisationId='+organisationId+'&studentId='+studentId) ///dashboard?organisationId=71&studentId=iit_demot
					.then(response => {
						
					if(response && response.data!=null && response.data[0]!=null){	

						if(response.data[0]!=null && response.data[0].testType && response.data[0].testLastReport!=null){
							setSelfTestData(response.data[0]);
							setChartSelfAssessorOneData({ series: [{ data: response.data[0].testLastReport }] });
							setChartSelfAssessorOneData({ subtitle: { text: response.data[0].testLastTopic } });
							setChartSelfAssessorTwoData({ xAxis: [{ categories: response.data[0].testLastTestsX }] });
							setChartSelfAssessorTwoData({ series: [{ data: response.data[0].testLastTestsY }] });
							setChartSelfAssessorTwoData({ title: { text: response.data[0].lastPerformance } });
							setChartSelfAssessorThreeData({ series: [{ data: response.data[0].testAccuracy }] });
							setChartSelfAssessorThreeData({ subtitle: { text: response.data[0].testLastTopic } });
						}

						if(response.data[1]!=null && response.data[1].testType && response.data[1].testLastReport!=null){
							setTopicTestData(response.data[1]);
							setChartTopicTestOneData({ series: [{ data: response.data[1].testLastReport }] });
							setChartTopicTestOneData({ subtitle: { text: response.data[1].testLastTopic } });
							setChartTopicTestTwoData({ xAxis: [{ categories: response.data[1].testLastTestsX }] });
							setChartTopicTestTwoData({ series: [{ data: response.data[1].testLastTestsY }] });
							setChartTopicTestTwoData({ title: { text: response.data[1].lastPerformance } });
							setChartTopicTestThreeData({ series: [{ data: response.data[1].testAccuracy }] });
							setChartTopicTestThreeData({ subtitle: { text: response.data[1].testLastTopic } });
						}

						if(response.data[2]!=null && response.data[2].testType && response.data[2].testLastReport!=null){
							setMockTestData(response.data[2]);
							setChartMockTestOneData({ series: [{ data: response.data[2].testLastReport }] });
							setChartMockTestOneData({ subtitle: { text: response.data[2].testLastTopic } });
							setChartMockTestTwoData({ xAxis: [{ categories: response.data[2].testLastTestsX }] });
							setChartMockTestTwoData({ series: [{ data: response.data[2].testLastTestsY }] });
							setChartMockTestTwoData({ title: { text: response.data[2].lastPerformance } });
							setChartMockTestThreeData({ series: [{ data: response.data[2].testAccuracy }] });
							setChartMockTestThreeData({ subtitle: { text: response.data[2].testLastTopic } });
						}

						if(response.data[3]!=null && response.data[3].testType && response.data[3].testLastReport!=null){
							setClassTestData(response.data[3]);
							setChartClassTestOneData({ series: [{ data: response.data[3].testLastReport }] });
							setChartClassTestOneData({ subtitle: { text: response.data[3].testLastTopic } });
							setChartClassTestTwoData({ xAxis: [{ categories: response.data[3].testLastTestsX }] });
							setChartClassTestTwoData({ series: [{ data: response.data[3].testLastTestsY }] });
							setChartClassTestTwoData({ title: { text: response.data[3].lastPerformance } });
							setChartClassTestThreeData({ series: [{ data: response.data[3].testAccuracy }] });
							setChartClassTestThreeData({ subtitle: { text: response.data[3].testLastTopic } });
						}
						

					}else{
						setRedirect(true);
						///setMessage("No data available");
					}

				})
			} catch (error) {
				const { response } = error;
				const { request, ...errorObject } = response; // take everything but 'request'
				console.log(errorObject);
			}
		}	
	}

	async function getApiDataClassTest(schoolId,className,subjectList){
		axios.get(API_URL+'/classtestlist?schoolId='+schoolId+'&className='+className+'&subjectList='+subjectList)
			   .then(response => {
			 	///console.log("Just Checking >> "+response.data);  
				 setClasTestList(response.data);				 				
		})
	}
	
	function goToClassTest(){
		window.location.href='selectclasstest';
	}

		return (
			<div> 
				<MetaTags>
            		<title>Dashboard</title>
          		</MetaTags>				
				<Header />
				{(document.readyState!="complete")?<LinearProgress />:null}
				<Container style={{marginBottom:100}}>		
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12}>
								<h3 className="heading" >Dashboard</h3>
							</Grid>
						</Grid>
				</Box>				

			{(clasTestList && clasTestList!=null)?
				<Box mt={1}>
						<Grid container spacing={1} >
						{clasTestList.map((myCT,index)=>(	
							<Grid key={'lt'+index} item md={12} xs={12} onClick={()=>{goToClassTest()}} >
								<div className='dasbordlive'>
									<div className='colone'><i className='fa fa-play-circle' /></div>
									<div className='coltwo'>									
										<h3>LIVE: {myCT.testTitle}</h3>
										<p>
											Subject: {myCT.subject}, Time: {moment(myCT.testDateTime).format('DD-MM-YYYY HH:mm')}, Duration: {myCT.totalTime} min
										</p>
									</div>
								</div>
							</Grid>
						))}
						</Grid>
				</Box>
  			:null}	

			{(selfTestData && selfTestData!=null && selfTestData.testType!=null)?
				<>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >Self Assessor</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>												
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSelfAssessorOneData}
								/>								
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSelfAssessorTwoData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSelfAssessorThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}	



			{(topicTestData && topicTestData!=null && topicTestData.testType!=null)?
				<>  
				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >Topic Test</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartTopicTestOneData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartTopicTestTwoData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartTopicTestThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}		


			{(mockTestData && mockTestData!=null && mockTestData.testType!=null)?
				<>  
				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >Mock Test</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartMockTestOneData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartMockTestTwoData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartMockTestThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}	



			{(classTestData && classTestData!=null && classTestData.testType!=null)?
				<>  
				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >Class Test</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartClassTestOneData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartClassTestTwoData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartClassTestThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}	


				</Container>
				
				

			</div>
		);
 
}