import React from 'react';
import {Box, Container, Grid } from '@material-ui/core';
import Highcharts from 'highcharts';
import HighchartsReact from 'highcharts-react-official';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import Header from "./HeaderMy";
import '../styles/bizofficer-a.css';

/*
const chartOne = {
	credits: false,
	chart: {
		type: 'pie'
	},
	title: {
	  text: 'My Last Report'
	},
	subtitle: {
		text: 'ATOMIC STRUCTURE'
	},
	caption: {
		text: 'This section allows you to view the statistics of the assessment given most recently.'
	  },
	tooltip: {
        valueSuffix: ' %'
    },
	plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.name}'}}},
	series: [{
		showInLegend: false,	
		name: '',
		data: []
	}]
	
  }
  */

  const chartTwo = {
	credits: false,
	chart: {
		type: 'column'
	},
	title: {
	  text: 'My Last 5 Performance'
	},
	caption: {
		text: 'This section allows you to view the statistics of 5 assessments given most recently.'
	  },
	tooltip: {
        valueSuffix: ' %'
    },
	xAxis: {
		categories: ['ALGEBRA', 'COMPLEX NUMBERS AND QUADRATIC EQUATIONS', 'THEORY OF EQUATIONS', 'COMPLEX NUMBERS', 'DE MOIVRES THEOREM'],
	},
	yAxis: {
		title: {
			text: ''
		  },		  
	},
	plotOptions:{
		column: 
		{	
			threshold: 0,
			dataLabels: {
				enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}
			}
		}
	},
	series: [{
		showInLegend: false,	
		name: 'Marks',
		title:null,
	  data: [
		{
			"y": 90,		
			"color": "#FF0000"
		},
		{
			"y": 30,		
			"color": "#FF0000"
		},
		{
			"y": 50,		
			"color": "#FF0000"
		},
		{
			"y": 70,		
			"color": "#FF0000"
		},
		{
			"y": 20,		
			"color": "#FF0000"
		}
		]
	}]	
  }

  const chartThree = {
	credits: false,
	chart: {
		type: 'pie'
	},
	title: {
	  text: 'Accuracy'
	},
	caption: {
		text: 'This section allows you to view your accuracy in answering questions considering the time taken to do so.'
	},
	tooltip: {
        valueSuffix: ' %'
    },
	plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.name}'}}},
	series: [{
		showInLegend: false,	
		name: '',
		data: [{
			y: 10,
			name: "Not Answer",
			color: "#0000FF"
		}, {
			y: 50,
			name: "Correct",
			color: "#00FF00"
		}, {
			y: 40,
			name: "Incorrect",
			color: "#FF0000"
		}
		]
	}]
	 	
  }


  const chartFour = {
	credits: false,
	chart: {
		type: 'pie'
	},
	title: {
	  text: 'My Last Report'
	},
	subtitle: {
		text: 'IITJEE 2020 PHYSICS P1 MOCK TEST 1'
	},
	caption: {
		text: 'This section allows you to view the statistics of the mock test given most recently.'
	  },
	tooltip: {
        valueSuffix: ' %'
    },
	plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.name}'}}},
	series: [{
		showInLegend: false,	
		name: '',
		data: [{
			y: 20,
			name: "Not Answer",
			color: "#4198d7"
		}, {
			y: 60,
			name: "Correct",
			color: "#46d39a"
		}, {
			y: 20,
			name: "Incorrect",
			color: "#e55759"
		}
		]
	}]
	 	
  }


  const chartFive = {
	credits: false,
	chart: {
		type: 'column'
	},
	title: {
	  text: 'My Last 5 Performance'
	},
	caption: {
		text: 'This section allows you to view the statistics of 5 mock tests given most recently.'
	  },
	tooltip: {
        valueSuffix: ' %'
    },
	xAxis: {
		categories: ['ALGEBRA', 'COMPLEX NUMBERS AND QUADRATIC EQUATIONS', 'THEORY OF EQUATIONS', 'COMPLEX NUMBERS', 'DE MOIVRES THEOREM'],
	},
	yAxis: {
		title: {
			text: ''
		  },		  
	},
	plotOptions:{
		column: 
		{	
			threshold: 0,
			dataLabels: {
				enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}
			}
		}
	},
	series: [{
		showInLegend: false,	
		name: 'Marks',
		title:null,
	  data: [
		{
			y: 90,			
			color: "#1572e8"
		},
		{
			y: 30,
			color: "#1572e8"
		},
		{
			y: 50,
			color: "#1572e8"
		},
		{
			y: 70,
			color: "#1572e8"
		},
		{
			y: 20,
			color: "#1572e8"
		}
		]
	}]	
  }

  const chartSix = {
	credits: false,
	chart: {
		type: 'pie'
	},
	title: {
	  text: 'Accuracy'
	},
	caption: {
		text: 'This section allows you to view your accuracy in answering questions considering the time taken to do so.'
	},
	tooltip: {
        valueSuffix: ' %'
    },
	plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.name}'}}},
	series: [{
		showInLegend: false,	
		name: '',
		data: [{
			y: 25,
			name: "Not Answer",
			color: "#fe9d52"
		}, {
			y: 25,
			name: "Correct",
			color: "#216d41"
		}, {
			y: 50,
			name: "Incorrect",
			color: "#f17853"
		}
		]
	}]
	 	
  }


  export default function Execute() {
	const [chartOneData, setChartOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'My Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: 'This section allows you to view the statistics of the assessment given most recently.'},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.name}'}}},series: [{showInLegend: false,name: '',data: []}]});
	const [chartThreeData, setChartThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy'},subtitle: {text: ''},caption: {text: 'This section allows you to view the statistics of the assessment given most recently.'},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.name}'}}},series: [{showInLegend: false,name: '',data: []}]});


	React.useEffect(() => {
		///alert('ss');
		getApiData();	
	}, []); 

	async function getApiData(){
			 axios.get('http://localhost/testing/dashboard.php') ///dashboard.php 
			    .then(response => {
				setChartOneData({ series: [{ data: response.data[0].selfAssessorLastReport }] });
				setChartOneData({ subtitle: { text: response.data[0].selfAssessorLastTopic } });
				setChartThreeData({ series: [{ data: response.data[0].selfAssessorAccuracy }] });
			 })

			// axios.all([
			// 	axios.get(env.API_URL+"/api/specialities?maxrows=10"), 
			// 	axios.get(env.API_URL+"/api/healthissues?maxrows=10")
			//   ]).then(axios.spread((specialitiesObj, healthissuesObj) => {
			// 	if(specialitiesObj.data.length>0){
			// 		setDataSpeciality(specialitiesObj.data);
			// 		setSPMsg("Found");
			// 	}else{
			// 		setSPMsg("Data not found");   
			// 	}
			// 	if(healthissuesObj.data.length>0){
			// 		setDataHealthissue(healthissuesObj.data);
			// 		setHIMsg("Found");
			// 	}else{
			// 		setHIMsg("Data not found");   
			// 	}
				
			//   })).catch(error => console.error(error));
	}
	
		return (
			<div> 
				<MetaTags>
            		<title>Dashboard</title>
          		</MetaTags>
				
				<Header />
				<Container style={{marginBottom:100}}>		

				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12}>
								<h3 className="heading" >Dashboard</h3>
							</Grid>
						</Grid>
				</Box>				

				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >Self Assessor</h3>
							</Grid>
						</Grid>
				</Box>				

				<Box mt={1}>
						<Grid container spacing={2}>												
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartOneData}
								/>								
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartTwo}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartThreeData}
								/>
							</Grid>

						</Grid>
				</Box>

				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >Mock Test</h3>
							</Grid>
						</Grid>
				</Box>				

				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartFour}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartFive}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSix}
								/>
							</Grid>

						</Grid>
				</Box>
					



				</Container>
				
				

			</div>
		);
 
}