import React from 'react';
import { makeStyles } from '@material-ui/core/styles';
import {Container, Grid, Link} from '@material-ui/core';
import Copyright from "./Copyright";

import '../styles/bizofficer.css';

const useStyles = makeStyles((theme) => ({
	sectionDesktop: {
	  display: 'none',
	  [theme.breakpoints.up('md')]: {
		display: 'flex',
	  },
	},
	sectionMobile: {
	  display: 'flex',
	  [theme.breakpoints.up('md')]: {
		display: 'none',
	  },
	},
  }));

  
export default function Footer() {

    const classes = useStyles();

  return (
    <div className="footer-box">
        <Container className={classes.sectionDesktop} > 
            <Grid container spacing={3}>
                <Grid item md={3} xs={12}>
                    <h2>Information</h2>
                    <ul>   
                        <li><Link href="#" >About Us</Link></li>
                        <li><Link href="#" >Blogs</Link></li>
                        <li><Link href="#" >Terms &amp; Policy</Link></li>
                        <li><Link href="#" >Contact Us</Link></li>
                    </ul>  
                </Grid>
                <Grid item md={3} xs={12}>
                    <h2>For patients</h2>
                    <ul>   
                        <li><Link href="#" >Search for doctors</Link></li>
                        <li><Link href="#" >Search for clinics</Link></li>
                        <li><Link href="#" >Search for hospitals</Link></li>
                        <li><Link href="#" >Health App</Link></li>
                    </ul>  
                </Grid>
                <Grid item md={3} xs={12}>
                    <h2>For professionals</h2>
                    <ul>   
                        <li><Link href="#" >Doctor Profile</Link></li>
                        <li><Link href="#" >Hospital Profile</Link></li>
                        <li><Link href="#" >Clinic Profile</Link></li>
                        <li><Link href="#" >Testing Labs</Link></li>
                    </ul>  
                </Grid>
                <Grid item md={3} xs={12}>
                    <h2>Social</h2>
                    <ul>   
                        <li><Link href="#" >Facebook</Link></li>
                        <li><Link href="#" >Twitter</Link></li>
                        <li><Link href="#" >LinkedIn</Link></li>
                        <li><Link href="#" >Youtube</Link></li>
                    </ul>  
                </Grid>
            </Grid>
        </Container>
      <Copyright/>
    </div>
  );
}



