import React from 'react';
import { DataGrid } from '@mui/x-data-grid';
import {Box, Container, Grid} from '@material-ui/core';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import {API_URL} from '../utils/EnvVars';
import Header from "./HeaderMy";
import '../styles/bizofficer-a.css';
///import 'font-awesome/css/font-awesome.min.css';

  
  
const columns = [
	{ field: 'id', headerName: 'No.', type: 'number', width: 40 },
	{ field: 'orderId', headerName: 'Order Id', type: 'number', width: 140 },
	{ field: 'subsriptionType', headerName: 'Subsription Type', width: 330 },
	{ field: 'course', headerName: 'Course', width: 130 },
	{ field: 'paidAmount', headerName: 'Paid Amount', type: 'number', width: 165 },
	{ field: 'submitDateTime', headerName: 'Date', width: 160 },
	{ field: 'subsriptionType', headerName: 'Subsription Type', width: 145 },
	{ field: 'paymentStatus', headerName: 'Payment Status', width: 145 },
	{ field: 'validTill', headerName: 'Valid Till', width: 145 },
	{ field: 'txnId', headerName: 'Txn Id', width: 145 }
	/*
	{
	  field: 'age',
	  headerName: 'Age',
	  type: 'number',
	  width: 130,
	},
	{
	  field: 'fullName',
	  headerName: 'Full name',
	  description: 'This column has a value getter and is not sortable.',
	  sortable: false,
	  width: 160,
	  valueGetter: (params) =>
		`${params.getValue(params.id, 'firstName') || ''} ${
		  params.getValue(params.id, 'lastName') || ''
		}`,
	},
	*/
  ];
  
  export default function Execute() {
	const [rows, setRows] = React.useState([]);

	React.useEffect(() => {
		///alert('ss');
		getApiData();	
	}, []); // testId currentQuestion (Math.floor(Math.random() * 10) + 1)

	async function getApiData(){
			axios.get(API_URL+'/orders.php')
			   .then(response => {
			 	///console.log("Just Checking >> "+response.data);  
				 setRows(response.data);				 				
			})
	}

	function goToDetail(obj){
		if(obj && rows[obj.id-1]){
			///window.location.href="testsimulator?testId="+rows[obj.id-1].testSessionId;
		}
	}

	return (
		<div> 
				<MetaTags>
            		<title>Orders</title>
          		</MetaTags>
				
				<Header />
				<Container>	

					<Box mt={1}>
							<Grid container spacing={2}>
								<Grid item md={12} xs={12}>
									<h3 className="heading" >Orders</h3>
									<h4 style={{color:'#f50057'}}>Click on any row to go Mock Test</h4>
								</Grid>
							</Grid>
					</Box>

					<div className="tblReport" style={{height: '70vh', width: '100%' }}>
						<DataGrid
							rows={rows}
							columns={columns}
							pageSize={50}
							rowsPerPageOptions={[50]}
							ActionsComponent={()=>{alert('Hello')}}		
							style={{fontSize:12}}	
							onRowClick={itm => goToDetail(itm)}			
						/>
					</div>

				</Container>

		</div>	
	);
  }