package com.bizofficer.admin.keywordcontent;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class ContentAdKeyController {
	
	private static final Logger logger = Logger.getLogger(ContentAdKeyController.class);
	
	@Autowired
	private ContentAdKeyService serviceObj;
	
	@RequestMapping(value = {"/admin-keywordcontents"}, method = {RequestMethod.GET})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")ContentAdKeyBean objBean) {
		
		try {
			
			ContentAdKeyResponseBean tsrbObj = (ContentAdKeyResponseBean) (Object) serviceObj.execute(objBean);
			
			logger.info("ResponseTxt >> " + tsrbObj.getResponseTxt() );
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
