package com.bizofficer.admin.keywords;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class KeywordAdController {
	
	private static final Logger logger = Logger.getLogger(KeywordAdController.class);
	
	@Autowired
	private KeywordAdService cclsObj;

	@RequestMapping(value = {"/admin-keywords"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")AKeywordReqAdBean objBean) {
		
		try {
			
			KeywordAdResponseBean respObj = (KeywordAdResponseBean) (Object) cclsObj.doExecute(objBean);
			
			logger.info("ResponseTxt >> " + respObj.getResponseTxt() );
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(respObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
