package com.bizofficer.admin.school;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;
import com.bizofficer.module.util.PrivilegesBeans;
import com.bizofficer.module.util.PrivilegesUtil;
import com.bizofficer.module.util.RoleModules;
import com.bizofficer.system.util.General;


@Service
public class UserSchoolUpdateAdminService{
	
	private static final Logger logger = Logger.getLogger(UserSchoolUpdateAdminService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	PgprepSchoolUsersRepository stRepo;
	
	public Object execute(AdminSchoolBean objBean){
		SchoolAdminResponseBean responseObj = new SchoolAdminResponseBean();
		
		try {
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			
			logger.info("Email Id >> " + objBean.getEmailId() );
			logger.info("FullName >> " + objBean.getFullName() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				return responseObj;
			}
			logger.info("Verify >> " + adminObj.getId() );
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getAcademy() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj==null || (prvgbnObj!=null && (prvgbnObj.getUpdate()==null || prvgbnObj.getUpdate()==0))) {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}
			
			PgprepSchoolUsers scObj = stRepo.findIdByEmailIdAndIdNot(objBean.getEmailId(),objBean.getId());
			logger.info("Existing >> " + scObj );
			if(scObj!=null && scObj.getSchoolId()>0) {
				responseObj.setResponseTxt("AlreadyExistsError");
				return responseObj;
			}			
			
			General gen = new General();
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			PgprepSchoolUsers findObj = (PgprepSchoolUsers)entityManager.find(PgprepSchoolUsers.class ,objBean.getId());
			findObj.setFullName(objBean.getFullName());
			findObj.setEmailId(objBean.getEmailId());
			
			if(objBean.getNewPassword()!=null && objBean.getNewPassword().length()>1) {
				findObj.setPassword(gen.getMD5Hashing(objBean.getNewPassword()));
			}
			
			entityManager.getTransaction().commit();
			entityManager.close();

			
			responseObj.setResponseTxt("success");
				
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
