package com.bizofficer.admin.school;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.module.util.PrivilegesBeans;
import com.bizofficer.module.util.PrivilegesUtil;
import com.bizofficer.module.util.RoleModules;


@Service
public class UsersSchoolAdminService{
	
	private static final Logger logger = Logger.getLogger(UsersSchoolAdminService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		AdminSchoolBean objBean = (AdminSchoolBean) obj;
		SchoolAdminResponseBean responseObj = new SchoolAdminResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );			
			logger.info("SchoolId >> " + objBean.getSchoolId() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				return responseObj;
			}
			logger.info("Verify >> " + adminObj.getId() );
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getAcademy() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj!=null && prvgbnObj.getView()!=null && prvgbnObj.getView()==1) {					
					responseObj.setPrivileges(prvgbnObj);
				}else {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}else {
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.fullPrivileges();
				responseObj.setPrivileges(prvgbnObj);
			}
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			List<SchoolUsersBean> mylist = new ArrayList<SchoolUsersBean>();
			
			TypedQuery<PgprepSchoolUsers> query = (TypedQuery<PgprepSchoolUsers>) entityManager.createQuery("from "+PgprepSchoolUsers.class.getName()+" WHERE schoolId=:schoolId order by fullName ", PgprepSchoolUsers.class);
			query.setParameter("schoolId", objBean.getSchoolId());
			query.setFirstResult(0);
			query.setMaxResults(50);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();	
			SchoolUsersBean clsObj;
			int i=1;
			while(iteratorCat.hasNext()){
				PgprepSchoolUsers myObj = (PgprepSchoolUsers)iteratorCat.next();		
				
				clsObj = new SchoolUsersBean();
				
				clsObj.setId(i);
				clsObj.setAutoId(myObj.getId());	
				clsObj.setSchoolId(myObj.getSchoolId());
				clsObj.setSchoolName(myObj.getSchoolName());
				clsObj.setEmailId(myObj.getEmailId());
				clsObj.setFullName(myObj.getFullName());
				
				mylist.add(clsObj);
				i++;
			}

			responseObj.setList(mylist);
			responseObj.setResponseTxt("success");
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
