package com.bizofficer.admin.subjects;



import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.PgprepSubjects;
import com.bizofficer.hibernate.repository.OrganisationTemplateAssociationRepository;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.hibernate.repository.PgprepSubjectsRepository;
import com.bizofficer.module.util.PrivilegesBeans;
import com.bizofficer.module.util.PrivilegesUtil;
import com.bizofficer.module.util.RoleModules;


@Service
public class SubjectUpdateAdminService{
	
	private static final Logger logger = Logger.getLogger(SubjectUpdateAdminService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	PgprepSubjectsRepository stRepo;
	
	@Autowired
	OrganisationTemplateAssociationRepository otaRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		SubjectAdminBean objBean = (SubjectAdminBean) obj;
		SubjectAdminResponseBean responseObj = new SubjectAdminResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("getLoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );

			logger.info("Auto Id >> " + objBean.getId() );
			logger.info("OrganisationId >> " + objBean.getOrganisationId() );
			logger.info("Subject >> " + objBean.getSubject() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				return responseObj;
			}			

			logger.info("Verify >> " + adminObj.getId() );
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getSubjects() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj==null || (prvgbnObj!=null && (prvgbnObj.getUpdate()==null || prvgbnObj.getUpdate()==0))) {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}

			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();

			TypedQuery<PgprepSubjects> query = (TypedQuery<PgprepSubjects>) entityManager.createQuery("from "+PgprepSubjects.class.getName()+" WHERE id!=:id AND subject=:subject ", PgprepSubjects.class);
			query.setParameter("id", objBean.getId());
			query.setParameter("subject", objBean.getSubject());
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();	
			if(iteratorCat.hasNext()){
				logger.info("AlreadyExistsError");
				responseObj.setResponseTxt("AlreadyExistsError");
				return responseObj;
			}			

			
			PgprepSubjects findObj = (PgprepSubjects)entityManager.find(PgprepSubjects.class ,objBean.getId());
			findObj.setSubject(objBean.getSubject());

			responseObj.setResponseTxt("success");
				
			
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
