package com.bizofficer.admin.subscription;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.SubscriptionWebsites;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.hibernate.repository.SubscriptionWebsitesRepository;
import com.bizofficer.module.util.PrivilegesBeans;
import com.bizofficer.module.util.PrivilegesUtil;
import com.bizofficer.module.util.RoleModules;


@Service
public class WebsiteUpdateAdminService{
	
	private static final Logger logger = Logger.getLogger(WebsiteUpdateAdminService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	SubscriptionWebsitesRepository stRepo;
	
	public Object execute(AdminSubscriptionBean objBean) throws NotFoundException{
		SubscriptionResponseBean responseObj = new SubscriptionResponseBean();
		
		try {
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			
			logger.info("Title >> " + objBean.getTitle() );
			logger.info("Phone >> " + objBean.getPhone() );
			logger.info("Email >> " + objBean.getEmail() );
			logger.info("Address >> " + objBean.getAddress() );
			logger.info("WebUrl >> " + objBean.getWebUrl() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				return responseObj;
			}			

			logger.info("Verify >> " + adminObj.getId() );
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getWebsites() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj==null || (prvgbnObj!=null && (prvgbnObj.getUpdate()==null || prvgbnObj.getUpdate()==0))) {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}
			
			SubscriptionWebsites webObj = stRepo.findIdByWebUrlAndIdNot(objBean.getWebUrl(),objBean.getId());
			logger.info("Existing >> " + webObj );
			if(webObj!=null && webObj.getId()>0) {
				responseObj.setResponseTxt("AlreadyExistsError");
				return responseObj;
			}			
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			SubscriptionWebsites findObj = (SubscriptionWebsites)entityManager.find(SubscriptionWebsites.class ,objBean.getId());
			findObj.setTitle(objBean.getTitle());
			findObj.setPhone(objBean.getPhone());
			findObj.setEmail(objBean.getEmail());
			findObj.setAddress(objBean.getAddress());
			findObj.setWebUrl(objBean.getWebUrl());
			
			entityManager.getTransaction().commit();
			entityManager.close();

			
			responseObj.setResponseTxt("success");
				
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
