package com.bizofficer.admin.users;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.module.util.PrivilegesBeans;
import com.bizofficer.module.util.PrivilegesUtil;
import com.bizofficer.module.util.RoleModules;
import com.bizofficer.system.util.MakeDate;


@Service
public class UsrListAdmService{
	
	private static final Logger logger = Logger.getLogger(UsrListAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		AdminUsrBean objBean = (AdminUsrBean) obj;
		AdminUsrResponseBean responseObj = new AdminUsrResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			logger.info("Keyword >> " + objBean.getKeyword() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				return responseObj;
			}
			logger.info("Verify >> " + adminObj.getId() );
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getUsers() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj!=null && prvgbnObj.getView()!=null && prvgbnObj.getView()==1) {					
					responseObj.setPrivileges(prvgbnObj);
				}else {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}else {
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.fullPrivileges();
				responseObj.setPrivileges(prvgbnObj);
			}
			
			List<UserAdmBeans> subsList = new ArrayList<UserAdmBeans>();
			
			MakeDate mkdate = new MakeDate(); 
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			String whereQry =" WHERE 1=1 ";			
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) { 
				whereQry +=" AND (fullName LIKE :keyword OR emailId LIKE :keyword OR roleName LIKE :keyword) ";
			}
			
			TypedQuery<PgprepAdministrator> query = (TypedQuery<PgprepAdministrator>) entityManager.createQuery("from "+PgprepAdministrator.class.getName()+whereQry+" order by id desc ", PgprepAdministrator.class);
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				query.setParameter("keyword", "%"+objBean.getKeyword()+"%");
			}
			query.setFirstResult(0);
			query.setMaxResults(500);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();	
			UserAdmBeans subObj;
			int i=1;
			while(iteratorCat.hasNext()){
				PgprepAdministrator myObj = (PgprepAdministrator)iteratorCat.next();		
				
				subObj = new UserAdmBeans();
				
				subObj.setId(i);
				subObj.setAutoId(myObj.getId());
				subObj.setEmailId(myObj.getEmailId());
				subObj.setFullName(myObj.getFullName());
				
				subObj.setRoleId(myObj.getRoleId());
				subObj.setCurrentRoleId(myObj.getRoleId());
				subObj.setRoleName(myObj.getRoleName());	
				
				if(myObj.getUserType()!=null && myObj.getUserType()==1) {
					subObj.setUserType("Admin");
				}else {
					subObj.setUserType("User");
				}
				
				if(myObj.getStatus()!=null && myObj.getStatus()==1) {
					subObj.setStatus("Active");
				}else {
					subObj.setStatus("Inactive");
				}
				
				subObj.setLastModifiedBy(myObj.getLastModifiedBy());
				if(myObj.getLastModifiedDateTime()!=null) {
					subObj.setLastModifiedDateTime(mkdate.changeDateTimeFormat(myObj.getLastModifiedDateTime(), "dd-MM-yyyy HH:mm:ss"));
				}
				
				subsList.add(subObj);
				i++;
			}

			responseObj.setList(subsList);			
				
			entityManager.getTransaction().commit();
			entityManager.close();
			
			responseObj.setResponseTxt("success");
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
