package com.bizofficer.apiweb.reports;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.hibernate.entity.PgprepTestSummary;
import com.bizofficer.system.util.MakeDate;


@Service
public class ReportsService{
	
	private static final Logger logger = Logger.getLogger(ReportsService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@SuppressWarnings("deprecation")
	public List<?> doExecute(Object obj) throws NotFoundException{
		BeanReport objBean = (BeanReport) obj; 	
		List<ReportsBean> dataList = new ArrayList<ReportsBean>();
		
		try {

			logger.info("Panel >>> " +  objBean.getPanel() );
			logger.info("StudentId >>> " +  objBean.getStudentId() );
			logger.info("OrganisationId >>> " +  objBean.getOrganisationId() );
			logger.info("StudentIdForTeacher >>> " +  objBean.getStudentIdForTeacher() );
			
			if(objBean.getStudentId()==null && objBean.getOrganisationId()==null && objBean.getStudentIdForTeacher()==null  ) {
				return dataList;
			}
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			MakeDate mkdateObj = new MakeDate();
			
			ReportsBean serviceObj;
			
			if(objBean.getStudentIdForTeacher()!=null && objBean.getStudentIdForTeacher().length()>4) {
				logger.info("FIND ORG AND STUDENT ID");
				TypedQuery<PgprepStudentDetails> query = (TypedQuery<PgprepStudentDetails>) entityManager.createQuery("from "+PgprepStudentDetails.class.getName()+" where id=:id ", PgprepStudentDetails.class);
				query.setParameter("id", Integer.valueOf(objBean.getStudentIdForTeacher().substring(0, objBean.getStudentIdForTeacher().length()-4)) );
				query.setFirstResult(0);
				query.setMaxResults(1);
				List<?> resultListCat = query.getResultList();
				Iterator<?> iteratorCat=resultListCat.iterator();
				if(iteratorCat.hasNext()){
					PgprepStudentDetails myObj = (PgprepStudentDetails)iteratorCat.next();

//					System.out.println( "ReportsService OrganisationId >>> " +  myObj.getOrganisationId() );
					System.out.println( "ReportsService StudentId >>> " +  myObj.getStudentId() );
					
					///objBean.setOrganisationId(myObj.getOrganisationId());
					objBean.setStudentId(myObj.getStudentId());
				}
			}
			
			String whereQry="";
			if(objBean.getOrganisationId()!=null && objBean.getOrganisationId()>0 && objBean.getPanel()!=null && objBean.getPanel().equals("student") ) {
				whereQry=" AND organisationId=:organisationId ";
			}			
			TypedQuery<PgprepTestSummary> query = (TypedQuery<PgprepTestSummary>) entityManager.createQuery("from "+PgprepTestSummary.class.getName()+" where testStatus=1 AND studentId=:studentId "+whereQry+" order by id desc ", PgprepTestSummary.class);
			query.setParameter("studentId", objBean.getStudentId());
			if(objBean.getOrganisationId()!=null && objBean.getOrganisationId()>0 && objBean.getPanel()!=null && objBean.getPanel().equals("student") ) {
				query.setParameter("organisationId", objBean.getOrganisationId());
			}
			query.setFirstResult(0);
			query.setMaxResults(200);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();
			int i = 1;
			while(iteratorCat.hasNext()){
				PgprepTestSummary myObj = (PgprepTestSummary)iteratorCat.next();
				
				serviceObj = new ReportsBean();
				serviceObj.setId(i);
				serviceObj.setTotalQuestions(myObj.getTotalQuestion());
				
				if(myObj.getFullMarks()!=null) {
					BigDecimal fullMarks = new BigDecimal(myObj.getFullMarks().toString());
					fullMarks = fullMarks.setScale(2, BigDecimal.ROUND_HALF_EVEN);
					serviceObj.setFullMarks(fullMarks);
				}
				
				serviceObj.setMarksObtain(myObj.getMarksObtain());
				serviceObj.setTimeSpent(this.convertSecondsToTimeLabel(myObj.getTimeSpent()));
				serviceObj.setTestSession(myObj.getTestSession());
				serviceObj.setMockTestName(myObj.getTestTitle());
				serviceObj.setTestTypeId(myObj.getTestType());
				
				if (myObj.getTestType()!=null && myObj.getTestType() == 1) {
					serviceObj.setTestType("Self Test");
                } else if (myObj.getTestType()!=null && myObj.getTestType() == 2) {
                	serviceObj.setTestType("Topic Test");
                } else if (myObj.getTestType()!=null && myObj.getTestType() == 3) {
                	serviceObj.setTestType("Mock Test");
                } else if (myObj.getTestType()!=null && myObj.getTestType() == 4) {
                	serviceObj.setTestType("Class Test");
                }
				
				serviceObj.setSubmitDateTime(mkdateObj.changeDateTimeFormat(myObj.getStartDate(), "dd-MM-yyyy"));
				
				dataList.add(serviceObj);
				
				i++;	
			}
			entityManager.getTransaction().commit();
			entityManager.close();
			
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		///System.out.println( "dataList >>> " +  dataList );
			
		return dataList;
	}
	
	
	private String convertSecondsToTimeLabel(Integer time) {
		String hourStr="00", minsStr="00", secsStr="00";
		
		if(time>0) {
			Integer hours = time/3600; 
			if(hours<10){
				hourStr="0"+hours;
			}else {
				hourStr= String.valueOf(hours);
			}
			
			Integer mins = time % 3600 / 60; 
			if(mins<10){
				minsStr="0"+mins;
			}else {
				minsStr= String.valueOf(mins);
			} 
			
			Integer secs = time % 3600 % 60; 
			if(secs<10){
				secsStr="0"+secs;
			}else {
				secsStr= String.valueOf(secs);
			} 
		}
		return hourStr+':'+minsStr+':'+secsStr; 
	}

	

	
}
