package com.bizofficer.apiweb.testdetail;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.databind.ObjectMapper;

@RestController
@Service
public class TestDetailExistingController {
	
	@Autowired
	private TestDetailExistingService testDetailExistingServiceObj;
	
	
	////testdetailexisting?testSession=8b0bdcb3-d9ba-4cba-9555-c9728739725e&organisationId=71&studentId=iit_demot
	@RequestMapping(value = {"/testdetailexisting"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanTesting objBean) {
		
		try {
			
			System.out.println("TestDetailExistingController Test Id: "+objBean.getTestSession() );
			System.out.println("TestDetailExistingController Organisation Id: "+objBean.getOrganisationId() );
			System.out.println("TestDetailExistingController Student Id: "+objBean.getStudentId() );
			
			BeanTesting beanTestingObj = (BeanTesting) (Object) testDetailExistingServiceObj.execute(objBean);
			
			List<TestingPageBean> list = new ArrayList<TestingPageBean>();
			if(beanTestingObj.getTestDetail()!=null && beanTestingObj.getTestDetail().length()>0) {
				ObjectMapper objectMapper = new ObjectMapper();
				/////System.out.println("TestDetail: "+beanTestingObj.getTestDetail() );
				TestingPageBean testingPageBean = objectMapper.readValue(beanTestingObj.getTestDetail(), TestingPageBean.class);
				list.add(testingPageBean);
			}
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(list);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
