package com.bizofficer.apiweb.testdetail;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class TestingPageController {
	
	@Autowired
	private MockTestAPIService mockTestAPIServiceObj;
	
	@Autowired
	private SelfTestAPIService selfTestAPIServiceObj;

	@Autowired
	private TopicTestAPIService topicTestAPIServiceObj;

	@Autowired
	private ClassTestAPIService classTestAPIServiceObj;
	
	////testdetails?testId=151&testType=3
	@SuppressWarnings("unchecked")
	@RequestMapping(value = {"/testdetails"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanTesting objBean) {
		
		try {
			
			List<TestingPageBean> list = new ArrayList<TestingPageBean>();
			
			System.out.println("TestingPageController Test Id: "+objBean.getTestId() );
			System.out.println("TestingPageController Test Type: "+objBean.getTestType() );

			// Self Test ************************************************	
			if(objBean.getTestType()!=null && objBean.getTestType()==1) {
				list = (List<TestingPageBean>) (Object) selfTestAPIServiceObj.doExecute(objBean);

			// Topic Test ***********************************************	
			}else if(objBean.getTestType()!=null && objBean.getTestType()==2) {
				list = (List<TestingPageBean>) (Object) topicTestAPIServiceObj.doExecute(objBean);
				
			// Mock Test ************************************************
			}else if(objBean.getTestType()!=null && objBean.getTestType()==3) {
				list = (List<TestingPageBean>) (Object) mockTestAPIServiceObj.doExecute(objBean);

			// Class Test ************************************************
			}else if(objBean.getTestType()!=null && objBean.getTestType()==4) {
				list = (List<TestingPageBean>) (Object) classTestAPIServiceObj.doExecute(objBean);
				
			}
			
			System.out.println("TestingPageController Responded "+list.size());
			
			if(list!=null && list.size()>0) {
				HttpHeaders headers = new HttpHeaders();
		        ////headers.add("Responded", "UserController");
				return ResponseEntity.ok().headers(headers).body(list);
			}else {
				return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
