package com.bizofficer.apiweb.topictestlist;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class TopicTestListController {
	
	@Autowired
	private TopicTestListService cclsObj;

	@Value("${rowsInPage}")
	private Integer rowsInPage;
	
	//// topictestlist?templateId=40&topicName=a&topicId=31,33,34
	@SuppressWarnings("unchecked")
	@RequestMapping(value = {"/topictestlist"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanTop objBean) {
		
		try {
			
        	System.out.println("TopicTestListController TemplateId: "+objBean.getTemplateId());
        	System.out.println("TopicTestListController TopicId: "+objBean.getTopicId());
        	System.out.println("TopicTestListController TopicName: "+objBean.getTopicName());

			List<TestListBean> list = (List<TestListBean>) (Object) cclsObj.doExecute(objBean);
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(list);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
