package com.bizofficer.apiweb.topictestlist;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;
import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.AssessmentTreeview;
import com.bizofficer.module.util.MysqlTableNames;



@Service
public class TopicTestListService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;

	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps, psX;
    ResultSet rs, rsX;
	
	public List<?> doExecute(Object obj) throws NotFoundException{
		BeanTop objBean = (BeanTop) obj; 	
		List<TestListBean> dataList = new ArrayList<TestListBean>();
		
		
        try {

        	System.out.println("TopicTestListService TemplateId: "+objBean.getTemplateId());
        	System.out.println("TopicTestListService TopicId: "+objBean.getTopicId());
        	System.out.println("TopicTestListService TopicName: "+objBean.getTopicName());
        	
    		if(objBean.getTemplateId()==null || (objBean.getTopicId()==null && objBean.getTopicName()==null) ) {
    			return dataList;
    		}
        	
        	System.out.println("TemplateId: "+objBean.getTemplateId());
        	System.out.println("TopicId: "+objBean.getTopicId());
        	System.out.println("TopicName: "+objBean.getTopicName());
        	
        	EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
        	if((objBean.getTopicId()==null || objBean.getTopicId()<1) && objBean.getTopicName()!=null) {
        		TypedQuery<AssessmentTreeview> query = (TypedQuery<AssessmentTreeview>) entityManager.createQuery("from "+AssessmentTreeview.class.getName()+" where status='Active' and childnodeName=:childnodeName  ", AssessmentTreeview.class);
				query.setParameter("childnodeName", objBean.getTopicName());				
				query.setFirstResult(0);
				query.setMaxResults(1);				
				List<?> resultList = query.getResultList();
				Iterator<?> iterator=resultList.iterator();
				if(iterator.hasNext()){
					AssessmentTreeview myObj = (AssessmentTreeview)iterator.next();	
					objBean.setTopicId(myObj.getChildnodeId());
				}
        	}
        	
        	if(objBean.getTemplateId()==null || objBean.getTopicId()==null  || objBean.getTopicId()==0 ) {
    			return dataList;
    		}
        	
        	System.out.println("TopicId: "+objBean.getTopicId());
        	
        	TestListBean testListBeanObj = null;
        	PatternDetailsBean patternDetailsBeanObj = null;
    		///******************************************************************
        	 this.conn = this.appDataSource.getConnection();
             if (this.conn != null) {
//               this.ps = this.conn.prepareStatement("SELECT m.pattern_id,m.mocktest_title,m.mocktest_id FROM "+MysqlTableNames.getTopicPatternMocktestAssociation()+" m, "+MysqlTableNames.getTemplateTopicPatternAssociation()+" t where m.pattern_id=t.pattern_id LIMIT 100");

            	 this.ps = this.conn.prepareStatement("SELECT m.pattern_id,m.mocktest_title,m.mocktest_id FROM "+MysqlTableNames.getTopicPatternMocktestAssociation()+" m, "+MysqlTableNames.getTemplateTopicPatternAssociation()+" t where m.pattern_id=t.pattern_id AND t.template_id=? AND t.topic_id=? LIMIT 100");
                 this.ps.setInt(1, objBean.getTemplateId());
                 this.ps.setInt(2, objBean.getTopicId());

                 this.rs = this.ps.executeQuery();
                 while (this.rs.next()) {
                	 
                	 testListBeanObj = new TestListBean();
                	 
                     testListBeanObj.setPatternId(rs.getInt("pattern_id"));
                     testListBeanObj.setMockTestTitle(rs.getString("mocktest_title"));
                     testListBeanObj.setMockTestId(rs.getInt("mocktest_id"));
                     testListBeanObj.setTopicId(objBean.getTopicId());
                     
                     
                     this.psX = this.conn.prepareStatement("SELECT distinct t.pattern_id,m.no_of_question,t.question_type,t.total_time,t.marks_correct,t.marks_incorrect,t.marks_not_attempted,(marks_correct*no_of_question) total_mark FROM "+MysqlTableNames.getTopicPatternParameter()+" t, "+MysqlTableNames.getTopicPatternMocktestAssociation()+" m where t.pattern_id=m.pattern_id AND t.pattern_id=?");
                     this.psX.setInt(1, rs.getInt("pattern_id"));
                     this.rsX = this.psX.executeQuery();
                     if (this.rsX.next()) {
                    	 patternDetailsBeanObj = new PatternDetailsBean();
                    	 patternDetailsBeanObj.setTotalQuestion(rsX.getInt("no_of_question"));
                    	 patternDetailsBeanObj.setTotalTime(rsX.getInt("total_time"));
                    	 patternDetailsBeanObj.setTotalMark(rsX.getDouble("total_mark"));
                    	 patternDetailsBeanObj.setQuestionType(rsX.getString("question_type"));
                    	 patternDetailsBeanObj.setMarkCorrectAns(rsX.getDouble("marks_correct"));
                    	 patternDetailsBeanObj.setMarkIncorrectAns(rsX.getDouble("marks_incorrect"));
                    	 patternDetailsBeanObj.setMarkNotAttempt(rsX.getDouble("marks_not_attempted"));                         
                         testListBeanObj.setPatternDetails(patternDetailsBeanObj);
                     }
                     this.rsX.close();
                     this.psX.close();
                     
                     dataList.add(testListBeanObj);
                     
                 }
                 rs.close();
                 ps.close();
                 conn.close();
             }
             
             
             entityManager.getTransaction().commit();
 			 entityManager.close();
             
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
        return dataList;
    }
	
	
	

	

	
}
