package com.bizofficer.hibernate.entity;

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Cacheable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


@Entity
@Table(name = "pgprep_test_details")
@Cacheable
public class PgprepTestDetails {

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	@Column(name = "test_session")	
	private String testSession;
	
	@Column(name = "student_id")	
	private String studentId;
	
	@Column(name = "section_name")	
	private String sectionName;

	@Column(name = "assess_id")	
	private Integer assessId;

	@Column(name = "topic_id")	
	private Integer topicId;

	@Column(name = "correct_ans")	
	private String correctAns;
	
	@Column(name = "answer_given")	
	private String answerGiven; 
	
	@Column(name = "marks")	
	private BigDecimal marks;
	
	@Column(name = "total_marks")	
	private BigDecimal totalMarks;
	
	@Column(name = "answer_date")
	@Temporal(TemporalType.TIMESTAMP)
	private Date answerDate;

	@Column(name = "answer_time")
	private String answerTime;

	@Column(name = "status")	
	private String status;

	@Column(name = "item_id")	
	private Integer itemId;
	
	@Column(name = "time_spent")	
	private Integer timeSpent;

	
	
	
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getTestSession() {
		return testSession;
	}

	public void setTestSession(String testSession) {
		this.testSession = testSession;
	}

	public String getStudentId() {
		return studentId;
	}

	public void setStudentId(String studentId) {
		this.studentId = studentId;
	}

	public Integer getAssessId() {
		return assessId;
	}

	public void setAssessId(Integer assessId) {
		this.assessId = assessId;
	}

	public Integer getTopicId() {
		return topicId;
	}

	public void setTopicId(Integer topicId) {
		this.topicId = topicId;
	}

	public String getCorrectAns() {
		return correctAns;
	}

	public void setCorrectAns(String correctAns) {
		this.correctAns = correctAns;
	}

	public String getAnswerGiven() {
		return answerGiven;
	}

	public void setAnswerGiven(String answerGiven) {
		this.answerGiven = answerGiven;
	}

	public BigDecimal getMarks() {
		return marks;
	}

	public void setMarks(BigDecimal marks) {
		this.marks = marks;
	}

	public Date getAnswerDate() {
		return answerDate;
	}

	public void setAnswerDate(Date answerDate) {
		this.answerDate = answerDate;
	}

	public String getAnswerTime() {
		return answerTime;
	}

	public void setAnswerTime(String answerTime) {
		this.answerTime = answerTime;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public Integer getItemId() {
		return itemId;
	}

	public void setItemId(Integer itemId) {
		this.itemId = itemId;
	}

	public Integer getTimeSpent() {
		return timeSpent;
	}

	public void setTimeSpent(Integer timeSpent) {
		this.timeSpent = timeSpent;
	}

	public String getSectionName() {
		return sectionName;
	}

	public void setSectionName(String sectionName) {
		this.sectionName = sectionName;
	}

	public BigDecimal getTotalMarks() {
		return totalMarks;
	}

	public void setTotalMarks(BigDecimal totalMarks) {
		this.totalMarks = totalMarks;
	}
	
	
	
	
	
	

	

	
	

	



	


	
	
	
	

	
	
}
