package com.bizofficer.hibernate.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.bizofficer.hibernate.entity.PgprepSchools;


@Repository
public interface PgprepSchoolsRepository extends JpaRepository<PgprepSchools, Long> {

	PgprepSchools findIdBySchoolName(String schoolName);
	
	PgprepSchools findIdBySchoolNameAndSchoolIdNot(String schoolName, Integer schoolId);
	
	PgprepSchools findWebsiteIdBySchoolId(Integer schoolId);
	
	List<PgprepSchools> findByWebsiteId(Integer websiteId);
	
	@Transactional
	@Modifying
	void deleteBySchoolId(Integer id);
	
	
}
