package com.bizofficer.hibernate.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.bizofficer.hibernate.entity.SubscriptionCourses;


@Repository
public interface SubscriptionCoursesRepository extends JpaRepository<SubscriptionCourses, Long> {
	
	SubscriptionCourses findByCourseId(Integer courseId);
	
	SubscriptionCourses findIdByCourseTitleAndWebsiteIdAndCategoryId(String courseTitle, Integer websiteId, Integer categoryId);
	
	SubscriptionCourses findIdByCourseTitleAndWebsiteIdAndCategoryIdAndCourseIdNot(String courseTitle, Integer websiteId, Integer categoryId, Integer courseId);

	@Transactional
	@Modifying
	void deleteByCourseId(Integer courseId);
	
}
