package com.bizofficer.school.classes;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolClasses;
import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.repository.PgprepSchoolClassesRepository;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;


@Service
public class ClassesCreationService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	@Autowired
	PgprepSchoolClassesRepository clsRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		ClassesBean objBean = (ClassesBean) obj;
		ClassesSaveResponseBean responseListObj = new ClassesSaveResponseBean();
		
		try {
			
			System.out.println("ClassesCreationService LoginEmailId >> " + objBean.getLoginEmailId() );
			System.out.println("ClassesCreationService Token >> " + objBean.getToken() );
			System.out.println("ClassesCreationService ClassName >> " + objBean.getClassName() );
			System.out.println("ClassesCreationService Course Id >> " + objBean.getCourseId() );
			System.out.println("ClassesCreationService Course Title >> " + objBean.getCourseTitle() );
			System.out.println("ClassesCreationService Organisation Id >> " + objBean.getOrganisationId() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseListObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseListObj;
			}

			
			PgprepSchoolClasses clssObj = clsRepo.getIdBySchoolIdAndClassName(adminObj.getSchoolId(), objBean.getClassName());			
			if(clssObj!=null && clssObj.getId()>0) {
				System.out.println("Existing Class >> " + objBean.getClassName() );
				responseListObj.setResponseTxt("AlreadyExistsError");
				return responseListObj;
			}

				System.out.println("New Class Name >> " + objBean.getClassName() );
			
				EntityManager entityManager = entityManagerFactory.createEntityManager();
				entityManager.getTransaction().begin();
			
				PgprepSchoolClasses saveObj = new PgprepSchoolClasses();
				
				saveObj.setSchoolId(adminObj.getSchoolId());
				saveObj.setSchoolName(adminObj.getSchoolName());
				saveObj.setClassName(objBean.getClassName());
				saveObj.setCourseId(objBean.getCourseId());
				saveObj.setCourseTitle(objBean.getCourseTitle());
				saveObj.setOrganisationId(objBean.getOrganisationId());
				clsRepo.save(saveObj);
	
				responseListObj.setResponseTxt("OK");
				
				entityManager.getTransaction().commit();
				entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseListObj;
	}
	

	
	

	
	
}
