package com.bizofficer.school.classes;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolClasses;
import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;


@Service
public class ClassesService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		ClassesBean objBean = (ClassesBean) obj;
		List<ClassesResponseBean> responseListObj = new ArrayList<ClassesResponseBean>();
		
		try {
			
			System.out.println("ClassesService EmailId >> " + objBean.getEmailId() );
			System.out.println("ClassesService Token >> " + objBean.getToken() );
			System.out.println("ClassesService Keyword >> " + objBean.getKeyword() );
			
			if(objBean.getEmailId()==null || objBean.getToken()==null) {
				return responseListObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseListObj;
			}
			
			System.out.println("*********************Teachers******************************");
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			String whereQry =" WHERE schoolId="+adminObj.getSchoolId();				
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				whereQry +=" AND (className LIKE :keyword) ";
			}
			TypedQuery<PgprepSchoolClasses> query = (TypedQuery<PgprepSchoolClasses>) entityManager.createQuery("from "+PgprepSchoolClasses.class.getName()+whereQry+" order by className ", PgprepSchoolClasses.class);
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				query.setParameter("keyword", "%"+objBean.getKeyword()+"%");
			}
			query.setFirstResult(0);
			query.setMaxResults(500);
			List<?> resultList = query.getResultList();
			System.out.println("Classes resultList Count: "+resultList.size());
			Iterator<?> iterator=resultList.iterator();	
			ClassesResponseBean responseBeanObj;
			int i=1;
			while(iterator.hasNext()){
				PgprepSchoolClasses myObj = (PgprepSchoolClasses)iterator.next();		
				
				responseBeanObj = new ClassesResponseBean();
				responseBeanObj.setId(i);
				responseBeanObj.setAutoId(myObj.getId());
				responseBeanObj.setClassName(myObj.getClassName());
				responseBeanObj.setCourseId(myObj.getCourseId());
				responseBeanObj.setCourseTitle(myObj.getCourseTitle());
				responseBeanObj.setOrganisationId(myObj.getOrganisationId());
				
				responseListObj.add(responseBeanObj);
				i++;
			}

			System.out.println("Classes Count: "+responseListObj.size());
				
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseListObj;
	}
	

	
	

	
	
}
