package com.bizofficer.school.classes;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class ClassesUpdateController {
	
	@Autowired
	private ClassesUpdateService serviceObj;
	
	@RequestMapping(value = {"/classupdatesave"}, method = {RequestMethod.POST})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")ClassesBean objBean, @RequestHeader("token") String token, @RequestHeader("loginEmailId") String loginEmailId) {
		
		try {
			
			objBean.setToken(token);
			objBean.setLoginEmailId(loginEmailId);
			ClassesSaveResponseBean tsrbObj = (ClassesSaveResponseBean) (Object) serviceObj.execute(objBean);
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
