package com.bizofficer.school.classes;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolClasses;
import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.repository.OrganisationTemplateAssociationRepository;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;


@Service
public class ClassesUpdateService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	@Autowired
	OrganisationTemplateAssociationRepository otaRepo;
	
	@Autowired
    DataSource appDataSource;
	
	public Object execute(Object obj) throws NotFoundException{
		ClassesBean objBean = (ClassesBean) obj;
		ClassesSaveResponseBean responseListObj = new ClassesSaveResponseBean();
		
		try {
			
			System.out.println("ClassesUpdateService LoginEmailId >> " + objBean.getLoginEmailId() );
			System.out.println("ClassesUpdateService Token >> " + objBean.getToken() );
			System.out.println("ClassesUpdateService EmailId >> " + objBean.getEmailId() );
			System.out.println("ClassesUpdateService ClassName >> " + objBean.getClassName() );			
			System.out.println("ClassesUpdateService Course Id >> " + objBean.getCourseId() );
			System.out.println("ClassesUpdateService Course Title >> " + objBean.getCourseTitle() );
			System.out.println("ClassesUpdateService Organisation Id >> " + objBean.getOrganisationId() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null || objBean.getClassName()==null || objBean.getOrganisationId()==null) {
				return responseListObj;
			}
			
			PgprepSchoolUsers usrObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(usrObj==null) {
				return responseListObj;
			}
			System.out.println("Verify ID >> " + usrObj.getId() );
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			PgprepSchoolClasses findObj = (PgprepSchoolClasses)entityManager.find(PgprepSchoolClasses.class ,objBean.getId());
			findObj.setClassName(objBean.getClassName());
			findObj.setCourseId(objBean.getCourseId());
			findObj.setCourseTitle(objBean.getCourseTitle());
			findObj.setOrganisationId(objBean.getOrganisationId());	
			
			responseListObj.setResponseTxt("OK");			
			
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseListObj;
	}
	

	
	

	
	
}
