package com.bizofficer.school.students;



import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.entity.PgprepStudentCourses;
import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.hibernate.entity.SubscriptionCourses;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;
import com.bizofficer.hibernate.repository.PgprepStudentCoursesRepository;
import com.bizofficer.hibernate.repository.PgprepStudentDetailsRepository;
import com.bizofficer.system.util.General;
import com.bizofficer.system.util.MakeDate;


@Service
public class EditSchoolStudentService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	@Autowired
	PgprepStudentDetailsRepository techRepo;
	
	@Autowired
	PgprepStudentCoursesRepository corsRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		BeanStudents objBean = (BeanStudents) obj;
		SchoolStudentsResponseBean responseObj = new SchoolStudentsResponseBean();
		
		try {

			System.out.println("EditSchoolStudentService LoginEmailId >> " + objBean.getLoginEmailId() );
			System.out.println("EditSchoolStudentService Token >> " + objBean.getToken() );
			
			System.out.println("EditSchoolStudentService studentId >> " + objBean.getStudentId() );
			System.out.println("EditSchoolStudentService studentName >> " + objBean.getStudentName() );
			System.out.println("EditSchoolStudentService emailId >> " + objBean.getEmailId() );
			System.out.println("EditSchoolStudentService phone >> " + objBean.getPhone() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseObj;
			}

			
			PgprepStudentDetails studentObj = techRepo.findIdByIdNotAndStudentId(objBean.getAutoId(), objBean.getStudentId());			
			if(studentObj!=null && studentObj.getId()>0) {
				System.out.println("Existing Student Login Id >> " + objBean.getStudentId() );
				responseObj.setResponseTxt("AlreadyExistsError");
				return responseObj;
			}

				System.out.println("Edit Student LoginId >> " + objBean.getStudentId() );
				System.out.println("Edit Student AutoId >> " + objBean.getAutoId() );
			
				EntityManager entityManager = entityManagerFactory.createEntityManager();
				entityManager.getTransaction().begin();
				General gen = new General();
				
				PgprepStudentDetails saveObj = (PgprepStudentDetails)entityManager.find(PgprepStudentDetails.class ,objBean.getAutoId());
				
				saveObj.setStudentId(objBean.getStudentId());
				
				if(objBean.getNewPassword()!=null && objBean.getNewPassword().length()>2 ) {
					saveObj.setPassword(gen.getMD5Hashing(objBean.getNewPassword()));
				}

				saveObj.setSname(objBean.getStudentName());
				saveObj.setEmailId(objBean.getEmailId());				
				saveObj.setPhoneNo(objBean.getPhone());
				
				saveObj.setClassName(objBean.getClassName());
				saveObj.setAdmissionNumber(objBean.getAdmissionNumber());

				MakeDate dateObj = new MakeDate();
				///UPDATE STUDENT COURSES
				PgprepStudentCourses myCors = corsRepo.findIdBySid(objBean.getAutoId());
				
				PgprepStudentCourses saveCorsObj = (PgprepStudentCourses)entityManager.find(PgprepStudentCourses.class ,myCors.getId());
				saveCorsObj.setCourseId(objBean.getCourseId());
				saveCorsObj.setCourseTitle(objBean.getCourseTitle());
				saveCorsObj.setOrganisationId(objBean.getOrganisationId());
				saveCorsObj.setStudentId(objBean.getStudentId());
				
				TypedQuery<SubscriptionCourses> queryCors = (TypedQuery<SubscriptionCourses>) entityManager.createQuery("from "+SubscriptionCourses.class.getName()+" WHERE courseId=:courseId ", SubscriptionCourses.class);
				queryCors.setParameter("courseId", objBean.getCourseId() );			
				queryCors.setFirstResult(0);
				queryCors.setMaxResults(1);
				List<?> resultCors = queryCors.getResultList();
				Iterator<?> iteratorCors=resultCors.iterator();
				if(iteratorCors.hasNext()){
					SubscriptionCourses mySCors = (SubscriptionCourses)iteratorCors.next();
					if(mySCors.getValidityDate()!=null) {
						saveCorsObj.setValidTillDate(dateObj.getStringToDate(mySCors.getValidityDate().toString(), "yyyy-MM-dd"));
					}
				}	
				
				responseObj.setResponseTxt("success");
				
				entityManager.getTransaction().commit();
				entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
