package com.bizofficer.school.students;



import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.entity.PgprepStudentCourses;
import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.hibernate.entity.SubscriptionCourses;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;
import com.bizofficer.hibernate.repository.PgprepStudentCoursesRepository;
import com.bizofficer.hibernate.repository.PgprepStudentDetailsRepository;
import com.bizofficer.system.util.General;
import com.bizofficer.system.util.MakeDate;


@Service
public class NewSchoolStudentService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	@Autowired
	PgprepStudentDetailsRepository techRepo;
	
	@Autowired
	PgprepStudentCoursesRepository corsRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		BeanStudents objBean = (BeanStudents) obj;
		SchoolStudentsResponseBean responseObj = new SchoolStudentsResponseBean();
		
		try {
///			studentId, studentName, emailId, phone, newPassword
			System.out.println("NewSchoolStudentService LoginEmailId >> " + objBean.getLoginEmailId() );
			System.out.println("NewSchoolStudentService Token >> " + objBean.getToken() );
			
			System.out.println("NewSchoolStudentService studentId >> " + objBean.getStudentId() );
			System.out.println("NewSchoolStudentService studentName >> " + objBean.getStudentName() );
			System.out.println("NewSchoolStudentService emailId >> " + objBean.getEmailId() );
			System.out.println("NewSchoolStudentService phone >> " + objBean.getPhone() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseObj;
			}

			
			PgprepStudentDetails studentObj = techRepo.findIdByStudentId(objBean.getStudentId());			
			if(studentObj!=null && studentObj.getId()>0) {
				System.out.println("Existing Student Login Id >> " + objBean.getStudentId() );
				responseObj.setResponseTxt("AlreadyExistsError");
				return responseObj;
			}

				System.out.println("New Student LoginId >> " + objBean.getStudentId() );
			
				EntityManager entityManager = entityManagerFactory.createEntityManager();
				entityManager.getTransaction().begin();
				General gen = new General();
				MakeDate dateObj = new MakeDate();
				
				PgprepStudentDetails saveObj = new PgprepStudentDetails();
				
				saveObj.setSchoolId(adminObj.getSchoolId());
				saveObj.setSchoolName(adminObj.getSchoolName());
				
				saveObj.setStudentId(objBean.getStudentId());
				
				if(objBean.getNewPassword()!=null && objBean.getNewPassword().length()>2 ) {
					saveObj.setPassword(gen.getMD5Hashing(objBean.getNewPassword()));
				}

				saveObj.setSname(objBean.getStudentName());
				saveObj.setEmailId(objBean.getEmailId());
				saveObj.setPhoneNo(objBean.getPhone());
				
				saveObj.setOrganisationId(0);
				saveObj.setAccountType("");
				saveObj.setAccountStatus(1);
				saveObj.setRegistrationDate(dateObj.getCurrentTimeStamp());
				saveObj.setRegistrationValidTill(dateObj.getDateAfterYears(2));
				
				saveObj.setClassName(objBean.getClassName());
				saveObj.setAdmissionNumber(objBean.getAdmissionNumber());
				
				PgprepStudentDetails mySTD = techRepo.save(saveObj);
				
				PgprepStudentCourses corsObj = new PgprepStudentCourses();
				corsObj.setSid(mySTD.getId());
				corsObj.setCourseId(objBean.getCourseId());
				corsObj.setCourseTitle(objBean.getCourseTitle());
				corsObj.setOrganisationId(objBean.getOrganisationId());
				corsObj.setStudentId(objBean.getStudentId());
				
				TypedQuery<SubscriptionCourses> queryCors = (TypedQuery<SubscriptionCourses>) entityManager.createQuery("from "+SubscriptionCourses.class.getName()+" WHERE courseId=:courseId ", SubscriptionCourses.class);
				queryCors.setParameter("courseId", objBean.getCourseId() );			
				queryCors.setFirstResult(0);
				queryCors.setMaxResults(1);
				List<?> resultCors = queryCors.getResultList();
				Iterator<?> iteratorCors=resultCors.iterator();
				if(iteratorCors.hasNext()){
					SubscriptionCourses myCors = (SubscriptionCourses)iteratorCors.next();
					if(myCors.getValidityDate()!=null) {
						corsObj.setValidTillDate(dateObj.getStringToDate(myCors.getValidityDate().toString(), "yyyy-MM-dd"));
					}
				}	
				
				corsObj.setSubscriptionType("PAID");
				corsRepo.save(corsObj);
	
				responseObj.setResponseTxt("success");
				
				entityManager.getTransaction().commit();
				entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
