package com.bizofficer.school.students;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.school.classes.ClassesBean;
import com.bizofficer.school.classes.ClassesResponseBean;
import com.bizofficer.school.classes.ClassesService;

@RestController
@Service
public class SchoolStudentsController {
	
	@Autowired
	private SchoolStudentsService cclsObj;
	
	@Autowired
	private ClassesService classesServiceObj;

	@RequestMapping(value = {"/schoolstudents"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanStudents objBean) {
		
		try {
			
			SchoolStudentsResponseBean obj = (SchoolStudentsResponseBean) (Object) cclsObj.execute(objBean);
			
			ClassesBean clsBean = new ClassesBean();
			clsBean.setEmailId(objBean.getEmailId());
			clsBean.setToken(objBean.getToken());
			@SuppressWarnings("unchecked")
			List<ClassesResponseBean> classesObj = (List<ClassesResponseBean>) (Object) classesServiceObj.execute(clsBean);
			obj.setClasses(classesObj);
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(obj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
