package com.bizofficer.school.teachers;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.OrganisationTemplateAssociation;
import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.entity.PgprepTeacherAssociation;
import com.bizofficer.hibernate.repository.OrganisationTemplateAssociationRepository;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;
import com.bizofficer.hibernate.repository.PgprepTeacherAssociationRepository;
import com.bizofficer.system.util.MakeDate;


@Service
public class EditTeacherAssociationService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	@Autowired
	PgprepTeacherAssociationRepository techRepo;
	
	@Autowired
	OrganisationTemplateAssociationRepository otaRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		TeachBean objBean = (TeachBean) obj;
		TeachSaveResponseBean responseListObj = new TeachSaveResponseBean();
		
		try {
			
			System.out.println("EditTeacherAssociationService LoginEmailId >> " + objBean.getLoginEmailId() );
			System.out.println("EditTeacherAssociationService Token >> " + objBean.getToken() );
			
			System.out.println("EditTeacherAssociationService TeacherId >> " + objBean.getTeacherId() );
			System.out.println("EditTeacherAssociationService Batch >> " + objBean.getClassName() );
			System.out.println("EditTeacherAssociationService Subject >> " + objBean.getSubject() );
			System.out.println("EditTeacherAssociationService Organisation Id >> " + objBean.getOrganisationId() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null || objBean.getTeacherAssociationId()==null) {
				return responseListObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseListObj;
			}

			System.out.println("EditTeacherAssociationService Teacher Association Id >> " + objBean.getTeacherAssociationId() );
			
			PgprepTeacherAssociation teachObj = techRepo.findByIdNotAndSchoolIdAndTeacherIdAndClassNameAndOrganisationIdAndSubject(objBean.getTeacherAssociationId(), adminObj.getSchoolId(), objBean.getTeacherId(), objBean.getClassName(), objBean.getOrganisationId(), objBean.getSubject());			
			if(teachObj!=null && teachObj.getId()>0) {
				System.out.println("Existing Teacher Association >> ");
				responseListObj.setResponseTxt("AlreadyExistsError");
				return responseListObj;
			}

				Integer templateId = 0;
				
				if(objBean.getOrganisationId()!=null) {
					OrganisationTemplateAssociation myTemp = otaRepo.findTemplateIdByOrganisationId(String.valueOf(objBean.getOrganisationId()));
					templateId = myTemp.getTemplateId();
				}
			
				System.out.println("Edit Teacher Association");
			
				EntityManager entityManager = entityManagerFactory.createEntityManager();
				entityManager.getTransaction().begin();
				MakeDate dateObj = new MakeDate();
			
				PgprepTeacherAssociation findObj = (PgprepTeacherAssociation)entityManager.find(PgprepTeacherAssociation.class ,objBean.getTeacherAssociationId());
				findObj.setSchoolId(adminObj.getSchoolId());
				findObj.setSchoolName(adminObj.getSchoolName());
				findObj.setTeacherName(objBean.getTeacherName()); 
				findObj.setTeacherId(objBean.getTeacherId());
				findObj.setTeacherLoginId(objBean.getTeacherLoginId()); 
				findObj.setClassName(objBean.getClassName());
				findObj.setSubject(objBean.getSubject()); 
				findObj.setTemplateId(templateId);
				findObj.setOrganisationId(objBean.getOrganisationId());
				findObj.setUpdatedDateTime(dateObj.getCurrentTimeStamp());
	
				responseListObj.setResponseTxt("OK");
				
				entityManager.getTransaction().commit();
				entityManager.close();

				System.out.println("EDIT SAVED Teacher Association Id >> " + objBean.getTeacherAssociationId() );
				
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseListObj;
	}
	

	
	

	
	
}
