package com.bizofficer.school.teachers;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.OrganisationTemplateAssociation;
import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.entity.PgprepTeacherAssociation;
import com.bizofficer.hibernate.repository.OrganisationTemplateAssociationRepository;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;
import com.bizofficer.hibernate.repository.PgprepTeacherAssociationRepository;
import com.bizofficer.system.util.MakeDate;


@Service
public class NewTeacherAssociationService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	@Autowired
	PgprepTeacherAssociationRepository techRepo;
	
	@Autowired
	OrganisationTemplateAssociationRepository otaRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		TeachBean objBean = (TeachBean) obj;
		TeachSaveResponseBean responseListObj = new TeachSaveResponseBean();
		
		try {
			
			System.out.println("NewTeacherAssociationService LoginEmailId >> " + objBean.getLoginEmailId() );
			System.out.println("NewTeacherAssociationService Token >> " + objBean.getToken() );
			
			System.out.println("NewTeacherAssociationService TeacherId >> " + objBean.getTeacherId() );
			System.out.println("NewTeacherAssociationService Batch >> " + objBean.getClassName() );
			System.out.println("NewTeacherAssociationService Subject >> " + objBean.getSubject() );
			System.out.println("NewTeacherAssociationService Organisation Id >> " + objBean.getOrganisationId() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseListObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseListObj;
			}

			
			PgprepTeacherAssociation teachObj = techRepo.getIdBySchoolIdAndTeacherIdAndClassNameAndOrganisationIdAndSubject(adminObj.getSchoolId(), objBean.getTeacherId(), objBean.getClassName(), objBean.getOrganisationId(), objBean.getSubject());			
			if(teachObj!=null && teachObj.getId()>0) {
				System.out.println("Existing Teacher Association >> ");
				responseListObj.setResponseTxt("AlreadyExistsError");
				return responseListObj;
			}
			
				Integer templateId = 0;
				
				if(objBean.getOrganisationId()!=null) {
					OrganisationTemplateAssociation myTemp = otaRepo.findTemplateIdByOrganisationId(String.valueOf(objBean.getOrganisationId()));
					templateId = myTemp.getTemplateId();
				}

				System.out.println("Add New Teacher Association");
			
				EntityManager entityManager = entityManagerFactory.createEntityManager();
				entityManager.getTransaction().begin();
				MakeDate dateObj = new MakeDate();
			
				PgprepTeacherAssociation saveObj = new PgprepTeacherAssociation();
				
				saveObj.setSchoolId(adminObj.getSchoolId());
				saveObj.setSchoolName(adminObj.getSchoolName());
				saveObj.setTeacherName(objBean.getTeacherName());
				saveObj.setTeacherId(objBean.getTeacherId());
				saveObj.setTeacherLoginId(objBean.getTeacherLoginId());
				saveObj.setClassName(objBean.getClassName());
				saveObj.setSubject(objBean.getSubject());
				saveObj.setTemplateId(templateId);
				saveObj.setOrganisationId(objBean.getOrganisationId());
				saveObj.setUpdatedDateTime(dateObj.getCurrentTimeStamp());
				techRepo.save(saveObj);
	
				responseListObj.setResponseTxt("OK");
				
				entityManager.getTransaction().commit();
				entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseListObj;
	}
	

	
	

	
	
}
