package com.bizofficer.school.teachers;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.entity.PgprepTeachers;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;
import com.bizofficer.hibernate.repository.PgprepTeachersRepository;
import com.bizofficer.system.util.General;


@Service
public class TeachCreationService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	@Autowired
	PgprepTeachersRepository techRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		TeachBean objBean = (TeachBean) obj;
		TeachSaveResponseBean responseListObj = new TeachSaveResponseBean();
		
		try {
			
			System.out.println("TeachCreationService LoginEmailId >> " + objBean.getLoginEmailId() );
			System.out.println("TeachCreationService Token >> " + objBean.getToken() );
			System.out.println("TeachCreationService SchoolName >> " + objBean.getSchoolName() );
			System.out.println("TeachCreationService SchoolId >> " + objBean.getSchoolId() );
			System.out.println("TeachCreationService LoginId >> " + objBean.getLoginId() );
			System.out.println("TeachCreationService EmailId >> " + objBean.getEmailId() );
			System.out.println("TeachCreationService TeacherName >> " + objBean.getTeacherName() );			
			System.out.println("TeachCreationService AccountStatus >> " + objBean.getAccountStatus() );
			System.out.println("TeachCreationService Role >> " + objBean.getRole() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseListObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseListObj;
			}

			
			PgprepTeachers teachObj = techRepo.getIdByLoginId(objBean.getLoginId());			
			if(teachObj!=null && teachObj.getId()>0) {
				System.out.println("Existing Email >> " + teachObj.getEmailId() );
				responseListObj.setResponseTxt("AlreadyExistsError");
				return responseListObj;
			}

				System.out.println("No Existing LoginId >> " + objBean.getLoginId() );
			
				EntityManager entityManager = entityManagerFactory.createEntityManager();
				entityManager.getTransaction().begin();
				General gen = new General();
			
				PgprepTeachers saveObj = new PgprepTeachers();
				
				saveObj.setSchoolId(objBean.getSchoolId());
				saveObj.setSchoolName(objBean.getSchoolName());
				saveObj.setLoginId(objBean.getLoginId());
				
				if(objBean.getNewPassword()!=null && objBean.getNewPassword().length()>2 ) {
					saveObj.setPassword(gen.getMD5Hashing(objBean.getNewPassword()));
				}
				
				saveObj.setEmailId(objBean.getEmailId());
				saveObj.setTeacherName(objBean.getTeacherName());
				saveObj.setAccountStatus(1);
				saveObj.setRole(objBean.getRole());
				techRepo.save(saveObj);
	
				responseListObj.setResponseTxt("OK");
				
				entityManager.getTransaction().commit();
				entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseListObj;
	}
	

	
	

	
	
}
