package com.bizofficer.teacher.login;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.UUID;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepTeacherAssociation;
import com.bizofficer.hibernate.entity.PgprepTeachers;
import com.bizofficer.system.util.General;



@Service
public class LoginTeachService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	public Object execute(Object obj) throws NotFoundException{
		LoginTeachBean objBean = (LoginTeachBean) obj; 	
		LoginTeachResponseBean loginResponseBeanObj = new LoginTeachResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");
			
			if(objBean.getUserId()==null || objBean.getUserId()==null) {
				return loginResponseBeanObj;
			}

			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			General gen = new General();
			
			TypedQuery<PgprepTeachers> queryTeach = (TypedQuery<PgprepTeachers>) entityManager.createQuery("from "+PgprepTeachers.class.getName()+" where loginId=:loginId AND password=:password AND accountStatus=1 ", PgprepTeachers.class);
			queryTeach.setParameter("loginId", objBean.getUserId());
			queryTeach.setParameter("password", gen.getMD5Hashing(objBean.getPassword()));
			List<?> resultListTeach = queryTeach.getResultList();
			Iterator<?> iteratorTeach=resultListTeach.iterator();
			if(iteratorTeach.hasNext()){
				PgprepTeachers myObj = (PgprepTeachers)iteratorTeach.next();
			
				loginResponseBeanObj.setLoginId(myObj.getLoginId());
				loginResponseBeanObj.setSchoolId(myObj.getSchoolId());
				loginResponseBeanObj.setSchoolName(myObj.getSchoolName());

				loginResponseBeanObj.setEmailId(myObj.getEmailId());
            	loginResponseBeanObj.setTeacherName(myObj.getTeacherName());
            	loginResponseBeanObj.setRole(myObj.getRole());
            	
                loginResponseBeanObj.setToken(UUID.randomUUID().toString()+UUID.randomUUID().toString());
                
				if(myObj.getId()!=null && myObj.getId()>0) {
					PgprepTeachers ssaveObj = (PgprepTeachers)entityManager.find(PgprepTeachers.class ,myObj.getId());
					ssaveObj.setLoginToken(loginResponseBeanObj.getToken());
					entityManager.getTransaction().commit();
				}
				
				List<String> classesList = new ArrayList<String>();
				
				String whereSQL = "";
				if(myObj.getRole()!=null && myObj.getRole().equalsIgnoreCase("TEACHER") ) {
					whereSQL += " AND teacherLoginId=:teacherLoginId ";
				}else if(myObj.getRole()!=null && myObj.getRole().equalsIgnoreCase("PRINCIPAL") ) {
					whereSQL += " AND schoolId=:schoolId ";
				}
				
				TypedQuery<PgprepTeacherAssociation> queryAss = (TypedQuery<PgprepTeacherAssociation>) entityManager.createQuery("from "+PgprepTeacherAssociation.class.getName()+" where 1=1 "+whereSQL, PgprepTeacherAssociation.class);
				if(myObj.getRole()!=null && myObj.getRole().equalsIgnoreCase("TEACHER") ) {
					queryAss.setParameter("teacherLoginId", myObj.getLoginId());
				}else if(myObj.getRole()!=null && myObj.getRole().equalsIgnoreCase("PRINCIPAL") ) {
					queryAss.setParameter("schoolId", myObj.getSchoolId());
				}
				
				List<?> resultListAss = queryAss.getResultList();
				Iterator<?> iteratorAss=resultListAss.iterator();
				List<TeacherAssociationBean> teacherAssociationList = new ArrayList<TeacherAssociationBean>();
				TeacherAssociationBean teachAssObj = null;
				while(iteratorAss.hasNext()){
					PgprepTeacherAssociation myObjPTA = (PgprepTeacherAssociation)iteratorAss.next();
					teachAssObj = new TeacherAssociationBean();
					teachAssObj.setClassName(myObjPTA.getClassName());
					teachAssObj.setSubject(myObjPTA.getSubject());
					teachAssObj.setOrganisationId(myObjPTA.getOrganisationId());
					teachAssObj.setTemplateId(myObjPTA.getTemplateId());
					teacherAssociationList.add(teachAssObj);
					
					if(classesList.indexOf(myObjPTA.getClassName())==-1) {
						classesList.add(myObjPTA.getClassName());
					}
					
				}	
				
				loginResponseBeanObj.setTeacherAssociation(teacherAssociationList);
				loginResponseBeanObj.setClassList(classesList);
				
                loginResponseBeanObj.setResponseTxt("OK");

                System.out.println("**************************************************************");
				System.out.println("LoginTeachService successfully ("+myObj.getRole()+") Id: "+objBean.getUserId());
				System.out.println("**************************************************************");
                
			}	

			System.out.println("LoginTeachService UserId: "+objBean.getUserId() );
			
			
            entityManager.getTransaction().commit();
			entityManager.close();

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
