package com.bizofficer.admin.datareports;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


@RestController
@Service
public class DRController {
	
	private static final Logger logger = Logger.getLogger(DRController.class);
	
	@Autowired
	private DRService serviceObj;
	
	@RequestMapping(value = {"/admin-data-report-details"}, method = {RequestMethod.GET})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")DRBean objBean ) {
//		public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")DRBean objBean, @RequestHeader("token") String token, @RequestHeader("loginEmailId") String loginEmailId) {
		
		try {
			
//			objBean.setToken(token);
//			objBean.setLoginEmailId(loginEmailId);
			DRResponseBean tsrbObj = (DRResponseBean) (Object) serviceObj.execute(objBean);
			
			logger.info("ResponseTxt >> " + tsrbObj.getResponseTxt() );
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
