package com.bizofficer.admin.datareports;



import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.PgprepDataReports;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.hibernate.repository.PgprepDataReportsRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;


@Service
public class DRService{
	
	private static final Logger logger = Logger.getLogger(DRService.class);
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	PgprepDataReportsRepository myRepo;
	
	@Autowired
    DataSource appDataSource;
	
	@SuppressWarnings("unchecked")
	public Object execute(Object obj) throws NotFoundException{
		DRBean objBean = (DRBean) obj;
		DRResponseBean responseObj = new DRResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			logger.info("Keyword >> " + objBean.getKeyword() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null  || objBean.getId()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}			

			logger.info("Verify >> " + adminObj.getId() );
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getDataReports() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj!=null && prvgbnObj.getView()!=null && prvgbnObj.getView()==1) {					
					responseObj.setPrivileges(prvgbnObj);
				}else {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}else {
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.fullPrivileges();
				responseObj.setPrivileges(prvgbnObj);
			}
			
			
			PgprepDataReports mySQL = myRepo.findById(objBean.getId());
			
			JSONArray jsonCol = new JSONArray();
			JSONObject jsonObjColA  = new JSONObject();
			jsonObjColA.put("field", "id");
			jsonObjColA.put("headerName", "Sr.No.");
			jsonObjColA.put("width", 200);
			jsonCol.add(jsonObjColA);

			JSONArray json = new JSONArray();
			Connection connn = this.appDataSource.getConnection();			
			PreparedStatement pss = connn.prepareStatement(mySQL.getSqlDetail());
            logger.info(pss);
            ResultSet rss = pss.executeQuery();
            ResultSetMetaData rsmdd = rss.getMetaData();
            int j=1;
            while(rss.next()) {
            	  int numColumns = rsmdd.getColumnCount();
            	  if(j==1) {
                	  for (int i=1; i<=numColumns; i++) {
                	    JSONObject jsonObjCol  = new JSONObject();
	            	    String column_name = rsmdd.getColumnName(i);
	            	    if(!("id").equalsIgnoreCase(column_name)) {
		            	    jsonObjCol.put("field", column_name);
		        			jsonObjCol.put("headerName", column_name);
		        			jsonObjCol.put("width", 200);
		        			jsonCol.add(jsonObjCol);
	            	    }
                	  }            		  
            	  }
            	  JSONObject jsonObj = new JSONObject();
            	  jsonObj.put("id", j);
            	  for (int i=1; i<=numColumns; i++) {
            	    String column_name = rsmdd.getColumnName(i);
            	    if(!("id").equalsIgnoreCase(column_name)) {
            	    	jsonObj.put(column_name, rss.getObject(column_name));
            	    }
            	  }
            	  json.add(jsonObj);    
            	  
            	j++;	  
            }
            rss.close();
            pss.close();            
            connn.close();

            
            
			responseObj.setColumns(jsonCol);

			responseObj.setList(json);
			
			
			responseObj.setResponseTxt("success");
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
