package com.bizofficer.admin.parents;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.PgprepParents;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;


@Service
public class ParentsAdmService{
	
	private static final Logger logger = Logger.getLogger(ParentsAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		ParentsAdmRequest objBean = (ParentsAdmRequest) obj;
		ParentsAdmResponse responseObj = new ParentsAdmResponse();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("EmailId >> " + objBean.getEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			logger.info("Keyword >> " + objBean.getKeyword() );
			
			if(objBean.getEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}			

			logger.info("Verify >> " + adminObj.getId() );
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getParents() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj!=null && prvgbnObj.getView()!=null && prvgbnObj.getView()==1) {					
					responseObj.setPrivileges(prvgbnObj);
				}else {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}else {
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.fullPrivileges();
				responseObj.setPrivileges(prvgbnObj);
			}
			
			List<ParentsAdmResponseBean> listObj = new ArrayList<ParentsAdmResponseBean>();
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			String whereQry =" WHERE 1=1 ";			
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				whereQry +=" AND (mobile LIKE :keyword OR emailId LIKE :keyword OR fullName LIKE :keyword ) "; 
			}
			
			TypedQuery<PgprepParents> query = (TypedQuery<PgprepParents>) entityManager.createQuery("from "+PgprepParents.class.getName()+whereQry+" order by parentId desc ", PgprepParents.class);
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				query.setParameter("keyword", "%"+objBean.getKeyword()+"%");
			}
			query.setFirstResult(0);
			query.setMaxResults(500);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();	
			ParentsAdmResponseBean responseBeanObj;
			int i=1;
			while(iteratorCat.hasNext()){
				PgprepParents myObj = (PgprepParents)iteratorCat.next();		
				
				responseBeanObj = new ParentsAdmResponseBean();
				
				responseBeanObj.setId(i);
				responseBeanObj.setAutoId(myObj.getParentId());
				responseBeanObj.setMobile(myObj.getMobile());
				responseBeanObj.setEmailId(myObj.getEmailId());
				responseBeanObj.setFullName(myObj.getFullName());
				
				if(myObj.getAccountStatus()==1) {
					responseBeanObj.setAccountStatus("Active");
				}else {
					responseBeanObj.setAccountStatus("Inactive");
				}
				
				listObj.add(responseBeanObj);
				i++;
			}
			
			responseObj.setList(listObj);

			responseObj.setResponseTxt("success");
				
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
