package com.bizofficer.admin.parents;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.PgprepParentsChildren;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;


@Service
public class ParentsChildrenAdmService{
	
	private static final Logger logger = Logger.getLogger(ParentsChildrenAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		ParentsAdmRequest objBean = (ParentsAdmRequest) obj;
		ParentsAdmResponse responseObj = new ParentsAdmResponse();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("EmailId >> " + objBean.getEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			logger.info("ParentId >> " + objBean.getParentId() );
			
			if(objBean.getEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}			

			logger.info("Verify >> " + adminObj.getId() );
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getParents() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj!=null && prvgbnObj.getView()!=null && prvgbnObj.getView()==1) {					
					responseObj.setPrivileges(prvgbnObj);
				}else {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}else {
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.fullPrivileges();
				responseObj.setPrivileges(prvgbnObj);
			}
			
			List<ParentsChildrenABeans> listObj = new ArrayList<ParentsChildrenABeans>();
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			TypedQuery<PgprepParentsChildren> query = (TypedQuery<PgprepParentsChildren>) entityManager.createQuery("from "+PgprepParentsChildren.class.getName()+" WHERE parentId=:parentId order by fullName ", PgprepParentsChildren.class);
			query.setParameter("parentId", objBean.getParentId());
			query.setFirstResult(0);
			query.setMaxResults(15);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();	
			ParentsChildrenABeans responseBeanObj;
			int i=1;
			while(iteratorCat.hasNext()){
				PgprepParentsChildren myObj = (PgprepParentsChildren)iteratorCat.next();		
				
				responseBeanObj = new ParentsChildrenABeans();
				
				responseBeanObj.setId(i);
				responseBeanObj.setAutoId(myObj.getId());
				responseBeanObj.setStudentId(myObj.getStudentId());
				responseBeanObj.setFullName(myObj.getFullName());
				
				listObj.add(responseBeanObj);
				i++;
			}
			
			responseObj.setList(listObj);

			responseObj.setResponseTxt("success");
				
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
