package com.bizofficer.admin.parents;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.PgprepParents;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.hibernate.repository.PgprepParentsRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;
import com.bizofficer.util.system.General;


@Service
public class ParentsCreationAdmService{
	
	private static final Logger logger = Logger.getLogger(ParentsCreationAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	PgprepParentsRepository stRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		ParentsAdmRequest objBean = (ParentsAdmRequest) obj;
		ParentsAdmResponse responseObj = new ParentsAdmResponse();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			
			logger.info("fullName >> " + objBean.getFullName() );
			logger.info("EmailId >> " + objBean.getEmailId() );
			logger.info("LoginId >> " + objBean.getLoginId() );
			logger.info("Mobile >> " + objBean.getMobile() );
			logger.info("AccountStatus >> " + objBean.getAccountStatus() );
			
			if(objBean.getFullName()==null || objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getParents() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj==null || (prvgbnObj!=null && (prvgbnObj.getCreate()==null || prvgbnObj.getCreate()==0))) {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}

			PgprepParents techObj = stRepo.findByMobile(objBean.getMobile());
			logger.info("Existing techObj >> " + techObj );
			if(techObj!=null) {
				responseObj.setResponseTxt("AlreadyExistsErrorMobile");
				return responseObj;
			}

			if(objBean.getEmailId()!=null && objBean.getEmailId().length()>2) {
				PgprepParents techObj2 = stRepo.findByEmailId(objBean.getEmailId());
				logger.info("Existing techObj >> " + techObj2 );
				if(techObj2!=null) {
					responseObj.setResponseTxt("AlreadyExistsErrorEmailId");
					return responseObj;
				}
			}
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			General gen = new General();
			
			PgprepParents saveObj = new PgprepParents();
			saveObj.setMobile(objBean.getMobile());
			saveObj.setEmailId(objBean.getEmailId());
			saveObj.setFullName(objBean.getFullName());
			saveObj.setAccountStatus(objBean.getAccountStatus());

			if(objBean.getNewPassword()!=null && objBean.getNewPassword().length()>2 ) {
				saveObj.setPassword(gen.getMD5Hashing(objBean.getNewPassword()));
			}
			
			stRepo.save(saveObj);
			
			responseObj.setResponseTxt("success");
			
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
