package com.bizofficer.admin.roles;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdminRoles;
import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.repository.PgprepAdminRolesRepository;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;
import com.bizofficer.util.system.MakeDate;


@Service
public class RolesCreationAdmService{
	
	private static final Logger logger = Logger.getLogger(RolesCreationAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	PgprepAdminRolesRepository stRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		AdminRoleBean objBean = (AdminRoleBean) obj;
		AdminRoleResponseBean responseObj = new AdminRoleResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			logger.info("RoleName >> " + objBean.getRoleName() );
			logger.info("Description >> " + objBean.getDescription() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null || objBean.getRoleName()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}			

			logger.info("Verify >> " + adminObj.getId() );
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getRoles() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj==null || (prvgbnObj!=null && (prvgbnObj.getCreate()==null || prvgbnObj.getCreate()==0))) {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}

			PgprepAdminRoles existObj = stRepo.getRoleIdByRoleName(objBean.getRoleName());
			logger.info("AlreadyExistsError");
			logger.info("Existing >> " + existObj );
			if(existObj!=null && existObj.getRoleId()>0) {
				responseObj.setResponseTxt("AlreadyExistsError");
				return responseObj;
			}
			
			MakeDate mkdate = new MakeDate(); 
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			PgprepAdminRoles saveObj = new PgprepAdminRoles();
			
			saveObj.setRoleName(objBean.getRoleName());
			saveObj.setDescription(objBean.getDescription());
			saveObj.setPrivileges(objBean.getPrivileges());
			saveObj.setCreatedBy(adminObj.getEmailId());
			saveObj.setCreatedDateTime(mkdate.getCurrentTimeStamp());
			saveObj.setLastModifiedBy(adminObj.getEmailId());
			saveObj.setLastModifiedDateTime(mkdate.getCurrentTimeStamp());
			
			stRepo.save(saveObj);
			
			responseObj.setResponseTxt("success");
			
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
