package com.bizofficer.admin.roles;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class RolesListAdmController {
	
	private static final Logger logger = Logger.getLogger(RolesListAdmController.class);
	
	@Autowired
	private RolesListAdmService loginServiceObj;
	
	@RequestMapping(value = {"/admin-list-role"}, method = {RequestMethod.GET})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")AdminRoleBean objBean) {
		
		try {
			
			AdminRoleResponseBean tsrbObj = (AdminRoleResponseBean) (Object) loginServiceObj.execute(objBean);
			
			logger.info("ResponseTxt: "+tsrbObj.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
