package com.bizofficer.admin.roles;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdminRoles;
import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;
import com.bizofficer.util.system.MakeDate;


@Service
public class RolesListAdmService{
	
	private static final Logger logger = Logger.getLogger(RolesListAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		AdminRoleBean objBean = (AdminRoleBean) obj;
		AdminRoleResponseBean responseObj = new AdminRoleResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			logger.info("Keyword >> " + objBean.getKeyword() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}			

			logger.info("Verify >> " + adminObj.getId() );
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getRoles() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj!=null && prvgbnObj.getView()!=null && prvgbnObj.getView()==1) {					
					responseObj.setPrivileges(prvgbnObj);
				}else {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}else {
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.fullPrivileges();
				responseObj.setPrivileges(prvgbnObj);
			}
			
			List<RolesAdmBean> subsList = new ArrayList<RolesAdmBean>();
			
			MakeDate mkdate = new MakeDate(); 
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			String whereQry =" WHERE 1=1 ";			
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				whereQry +=" AND (roleName LIKE :keyword) ";
			}
			
			TypedQuery<PgprepAdminRoles > query = (TypedQuery<PgprepAdminRoles>) entityManager.createQuery("from "+PgprepAdminRoles.class.getName()+whereQry+" order by roleName ", PgprepAdminRoles.class);
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				query.setParameter("keyword", "%"+objBean.getKeyword()+"%");
			}
			query.setFirstResult(0);
			query.setMaxResults(500);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();	
			RolesAdmBean subObj;
			int i=1;
			while(iteratorCat.hasNext()){
				PgprepAdminRoles myObj = (PgprepAdminRoles)iteratorCat.next();		
				
				subObj = new RolesAdmBean();
				
				subObj.setId(i);
				subObj.setAutoId(myObj.getRoleId());
				subObj.setRoleName(myObj.getRoleName());
				subObj.setCurrentRoleName(myObj.getRoleName());
				subObj.setDescription(myObj.getDescription());
				subObj.setPrivileges(myObj.getPrivileges());
				subObj.setCreatedBy(myObj.getCreatedBy());				
				subObj.setLastModifiedBy(myObj.getLastModifiedBy());
				
				if(myObj.getCreatedDateTime()!=null) {
					subObj.setCreatedDateTime(mkdate.changeDateTimeFormat(myObj.getCreatedDateTime(), "yyyy-MM-dd HH:mm:ss"));
				}
				
				if(myObj.getLastModifiedDateTime()!=null) {
					subObj.setLastModifiedDateTime(mkdate.changeDateTimeFormat(myObj.getLastModifiedDateTime(), "yyyy-MM-dd HH:mm:ss"));
				}
				
				
				subsList.add(subObj);
				i++;
			}

			responseObj.setList(subsList);			
				
			entityManager.getTransaction().commit();
			entityManager.close();
			
			responseObj.setResponseTxt("success");
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
