package com.bizofficer.admin.roles;



import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdminRoles;
import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.repository.OrganisationTemplateAssociationRepository;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.hibernate.repository.PgprepSubjectsRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;
import com.bizofficer.util.system.MakeDate;


@Service
public class RolesUpdateAdmService{
	
	private static final Logger logger = Logger.getLogger(RolesUpdateAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	PgprepSubjectsRepository stRepo;
	
	@Autowired
	OrganisationTemplateAssociationRepository otaRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		AdminRoleBean objBean = (AdminRoleBean) obj;
		AdminRoleResponseBean responseObj = new AdminRoleResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			logger.info("RoleName >> " + objBean.getRoleName() );
			logger.info("CurrentRoleName >> " + objBean.getCurrentRoleName() );
			logger.info("Description >> " + objBean.getDescription() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}			
			logger.info("Verify >> " + adminObj.getId() );			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getRoles() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj==null || (prvgbnObj!=null && (prvgbnObj.getUpdate()==null || prvgbnObj.getUpdate()==0))) {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}

			MakeDate mkdate = new MakeDate();
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();

			TypedQuery<PgprepAdminRoles> query = (TypedQuery<PgprepAdminRoles>) entityManager.createQuery("from "+PgprepAdminRoles.class.getName()+" WHERE roleId!=:roleId AND roleName=:roleName ", PgprepAdminRoles.class);
			query.setParameter("roleId", objBean.getId());
			query.setParameter("roleName", objBean.getRoleName());
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();	
			if(iteratorCat.hasNext()){
				logger.info("AlreadyExistsError");
				responseObj.setResponseTxt("AlreadyExistsError");
				return responseObj;
			}			

			logger.info("UPDATE ROLE");
			
			PgprepAdminRoles saveObj = (PgprepAdminRoles)entityManager.find(PgprepAdminRoles.class ,objBean.getId());
			saveObj.setRoleName(objBean.getRoleName());
			saveObj.setDescription(objBean.getDescription());
			saveObj.setPrivileges(objBean.getPrivileges());
			saveObj.setLastModifiedBy(adminObj.getEmailId());
			saveObj.setLastModifiedDateTime(mkdate.getCurrentTimeStamp());
			
			entityManager.getTransaction().commit();
			entityManager.close();
			
			logger.info("START-UPDATE ROLENAME IN USERS");
			adminRepo.updateRoleName(objBean.getId(), objBean.getRoleName(), objBean.getPrivileges());
			logger.info("END-UPDATE ROLENAME IN USERS");

			responseObj.setResponseTxt("success");
				
			
			
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
