package com.bizofficer.admin.subjects;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


@RestController
@Service
public class SubjectAdminController {
	
	private static final Logger logger = Logger.getLogger(SubjectAdminController.class);
	
	@Autowired
	private SubjectAdminService loginServiceObj;
	
	@RequestMapping(value = {"/admin-subjects"}, method = {RequestMethod.GET})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")SubjectAdminBean objBean) {
		
		try {
			
			SubjectAdminResponseBean tsrbObj = (SubjectAdminResponseBean) (Object) loginServiceObj.execute(objBean);
			
			logger.info("ResponseTxt >> " + tsrbObj.getResponseTxt() );
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
