package com.bizofficer.admin.subjects;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class SubjectDeleteAdminController {
	
	private static final Logger logger = Logger.getLogger(SubjectDeleteAdminController.class);
	
	@Autowired
	private SubjectDeleteAdminService serviceObj;
	
	@RequestMapping(value = {"/admin-delete-subject"}, method = {RequestMethod.POST})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")SubjectAdminBean objBean, @RequestHeader("token") String token, @RequestHeader("loginEmailId") String loginEmailId) {
		
		try {
			
			objBean.setToken(token);
			objBean.setLoginEmailId(loginEmailId);
			SubjectAdminResponseBean tsrbObj = (SubjectAdminResponseBean) (Object) serviceObj.execute(objBean);
			
			logger.info("ResponseTxt >> " + tsrbObj.getResponseTxt() );
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
