package com.bizofficer.admin.teachers;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.entity.PgprepTeachers;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.hibernate.repository.PgprepTeachersRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;
import com.bizofficer.util.system.General;


@Service
public class TeachersUpdateAdmService{
	
	private static final Logger logger = Logger.getLogger(TeachersUpdateAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	PgprepTeachersRepository stRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		TeachersAdmRequest objBean = (TeachersAdmRequest) obj;
		TeachersAdmResponse responseObj = new TeachersAdmResponse();
		
		try {
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			logger.info("TeacherName >> " + objBean.getTeacherName() );
			logger.info("EmailId >> " + objBean.getEmailId() );
			logger.info("LoginId >> " + objBean.getLoginId() );
			logger.info("SchoolName >> " + objBean.getSchoolName() );
			logger.info("SchoolId >> " + objBean.getSchoolId() );
			logger.info("AccountStatus >> " + objBean.getAccountStatus() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null || objBean.getLoginId()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}
			logger.info("Verify >> " + adminObj.getId() );
			
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getTeachers() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj==null || (prvgbnObj!=null && (prvgbnObj.getUpdate()==null || prvgbnObj.getUpdate()==0))) {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}
			
			PgprepTeachers techObj = stRepo.getIdByLoginIdAndIdNot(objBean.getLoginId(), objBean.getId());
			logger.info("Existing techObj >> " + techObj );
			if(techObj!=null) {
				responseObj.setResponseTxt("AlreadyExistsErrorLoginId");
				return responseObj;
			}
			
			PgprepTeachers techObj2 = stRepo.findByEmailIdAndIdNot(objBean.getEmailId(), objBean.getId());
			logger.info("Existing techObj >> " + techObj2 );
			if(techObj2!=null) {
				responseObj.setResponseTxt("AlreadyExistsErrorEmailId");
				return responseObj;
			}
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			General gen = new General();
			
			PgprepTeachers findObj = (PgprepTeachers)entityManager.find(PgprepTeachers.class, objBean.getId());
			
			findObj.setTeacherName(objBean.getTeacherName());
			findObj.setEmailId(objBean.getEmailId());
			findObj.setLoginId(objBean.getLoginId());
			findObj.setAccountStatus(objBean.getAccountStatus());

			if(objBean.getNewPassword()!=null && objBean.getNewPassword().length()>2 ) {
				findObj.setPassword(gen.getMD5Hashing(objBean.getNewPassword()));
			}
			
			if(objBean.getSchoolId()!=null && objBean.getSchoolId()>0 && objBean.getSchoolName()!=null && objBean.getSchoolName().length()>0 ) {
				findObj.setSchoolId(objBean.getSchoolId());
				findObj.setSchoolName(objBean.getSchoolName());
			}else {
				findObj.setSchoolId(null);
				findObj.setSchoolName(null);
			}

			responseObj.setResponseTxt("OK");
				
			
			
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
