package com.bizofficer.admin.users;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdminRoles;
import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.hibernate.repository.PgprepAdminRolesRepository;
import com.bizofficer.hibernate.repository.PgprepAdministratorRepository;
import com.bizofficer.util.module.PrivilegesBeans;
import com.bizofficer.util.module.PrivilegesUtil;
import com.bizofficer.util.module.RoleModules;
import com.bizofficer.util.system.General;
import com.bizofficer.util.system.MakeDate;


@Service
public class UsrCreationAdmService{
	
	private static final Logger logger = Logger.getLogger(UsrCreationAdmService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepAdministratorRepository adminRepo;
	
	@Autowired
	PgprepAdminRolesRepository releRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		AdminUsrBean objBean = (AdminUsrBean) obj;
		AdminUsrResponseBean responseObj = new AdminUsrResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("LoginEmailId >> " + objBean.getLoginEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			
			logger.info("EmailId >> " + objBean.getEmailId() );
			logger.info("FullName >> " + objBean.getFullName() );
			logger.info("Status >> " + objBean.getStatus() );
			logger.info("UserType >> " + objBean.getUserType() );
			logger.info("RoleId >> " + objBean.getRoleId() );
			logger.info("RoleName >> " + objBean.getRoleName() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null || objBean.getEmailId()==null) {
				return responseObj;
			}
			
			PgprepAdministrator adminObj = (PgprepAdministrator) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			if(adminObj==null) {
				logger.info("InvalidToken");
				responseObj.setResponseTxt("InvalidToken");
				return responseObj;
			}
			logger.info("Verify >> " + adminObj.getId() );
			if(adminObj.getUserType()==0 && adminObj.getRoleId()!=null && adminObj.getPrivileges()!=null){				
				PrivilegesUtil	myPgUtil = new PrivilegesUtil();
				PrivilegesBeans prvgbnObj = myPgUtil.authPrivileges(adminObj.getPrivileges(), RoleModules.getUsers() );
				logger.info(prvgbnObj.toString());
				if(prvgbnObj==null || (prvgbnObj!=null && (prvgbnObj.getCreate()==null || prvgbnObj.getCreate()==0))) {
					logger.info("NoAuthorization");
					responseObj.setResponseTxt("NoAuthorization");
					return responseObj;
				}
			}

			PgprepAdministrator existObj = adminRepo.findByEmailId(objBean.getEmailId());
			System.out.println("AlreadyExistsError");
			System.out.println("Existing >> " + existObj );
			if(existObj!=null && existObj.getRoleId()>0) {
				responseObj.setResponseTxt("AlreadyExistsError");
				return responseObj;
			}
			
			MakeDate mkdate = new MakeDate(); 
			General gen = new General();
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			PgprepAdministrator saveObj = new PgprepAdministrator();

			saveObj.setEmailId(objBean.getEmailId() );
			saveObj.setFullName(objBean.getFullName() );
			saveObj.setStatus(objBean.getStatus() );
			saveObj.setUserType(objBean.getUserType() );
			saveObj.setRoleId(objBean.getRoleId() );
			saveObj.setRoleName(objBean.getRoleName() );
			
			if(objBean.getRoleId()!=null && objBean.getRoleId()>0) {
				PgprepAdminRoles myRole = releRepo.findByRoleId(objBean.getRoleId());
				saveObj.setPrivileges(myRole.getPrivileges());
			}
			
			if(objBean.getPassword()!=null && objBean.getPassword().length()>0) {
				saveObj.setPassword(gen.getMD5Hashing(objBean.getPassword()));
			}else {
				saveObj.setPassword(gen.getMD5Hashing("123456"));
			}
			
			saveObj.setCreatedBy(adminObj.getEmailId());
			saveObj.setCreatedDateTime(mkdate.getCurrentTimeStamp());
			saveObj.setLastModifiedBy(adminObj.getEmailId());
			saveObj.setLastModifiedDateTime(mkdate.getCurrentTimeStamp());
			
			adminRepo.save(saveObj);
			
			responseObj.setResponseTxt("success");
			
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
