package com.bizofficer.apiweb.classtestlist;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepScheduleClassTest;
import com.bizofficer.pojo.response.ListResponsePojo;
import com.bizofficer.util.system.MakeDate;


@Service
public class ClassTestService{
	
	private static final Logger logger = Logger.getLogger(ClassTestService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	public Object doExecute(Object obj) throws NotFoundException{
		BeanClassTest objBean = (BeanClassTest) obj; 	
		ListResponsePojo responseObj = new ListResponsePojo();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info( "ClassTestService schoolId >>> " +  objBean.getSchoolId() );
			logger.info( "ClassTestService Class >>> " +  objBean.getClassName() );
		
			if(objBean.getSchoolId()==null || objBean.getClassName()==null) {
				return responseObj;
			}
			
			List<ClassTestResponseBean> dataList = new ArrayList<ClassTestResponseBean>();
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			ClassTestResponseBean serviceObj;
			MakeDate mkdate = new MakeDate();

			TypedQuery<PgprepScheduleClassTest> query = (TypedQuery<PgprepScheduleClassTest>) entityManager.createQuery("from "+PgprepScheduleClassTest.class.getName()+" where date(testDateTime)=CURDATE() AND time(testDateTime)<=CURTIME() AND ((TIME_TO_SEC(CURTIME()) - TIME_TO_SEC(testDateTime))/60)<=totalTime AND schoolId=?1 AND className=?2 order by id asc ", PgprepScheduleClassTest.class);
			query.setParameter(1, objBean.getSchoolId());
			query.setParameter(2, objBean.getClassName()  );
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();
			int i=1;
			while(iteratorCat.hasNext()){
				PgprepScheduleClassTest myObj = (PgprepScheduleClassTest)iteratorCat.next();
				
				serviceObj = new ClassTestResponseBean();
				serviceObj.setId(i);
				serviceObj.setAutoId(myObj.getId());
				serviceObj.setScheduleId(myObj.getScheduleId());
				serviceObj.setTestTitle(myObj.getTestTitle());
				serviceObj.setQuestionType(myObj.getQuestionType());
				
				serviceObj.setSchoolId(myObj.getSchoolId());
				serviceObj.setSchoolName(myObj.getSchoolName());
				
				serviceObj.setClassName(myObj.getClassName());				
				serviceObj.setSubject(myObj.getSubject());
								
				if(myObj.getTestDateTime()!=null) {
					serviceObj.setTestDateTime(mkdate.changeDateTimeFormat(myObj.getTestDateTime(), "yyyy-MM-dd HH:mm:ss"));
				}
				
				serviceObj.setTopicTestId(myObj.getTopicTestId());
				serviceObj.setTotalQuestion(myObj.getTotalQuestion());
				serviceObj.setTotalTime(myObj.getTotalTime());
				serviceObj.setTotalMark(myObj.getTotalMark());
				serviceObj.setMarkCorrectAns(myObj.getMarkCorrectAns());
				serviceObj.setMarkIncorrectAns(myObj.getMarkIncorrectAns());
				serviceObj.setMarkNotAttempt(myObj.getMarkNotAttempt());
								
				dataList.add(serviceObj);
				i++;
				
			}
			entityManager.getTransaction().commit();
			entityManager.close();
			
			responseObj.setList(dataList);
			
			responseObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		///logger.info( "dataList >>> " +  dataList );
			
		return responseObj;
	}
	
	
	
}
