package com.bizofficer.apiweb.feedback;



import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.env.Environment;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.util.module.MysqlTableNames;
import com.bizofficer.util.system.SendGridMail;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;


@Service
public class FBService{
	
	private static final Logger logger = Logger.getLogger(FBService.class);
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
    @Autowired
	private Environment env;
    
	public Object execute(Object obj) throws NotFoundException{
		FBBean objBean = (FBBean) obj; 	
		FBResponseBean responseBeanObj = new FBResponseBean();
		
		try {
			responseBeanObj.setResponseTxt("failed");
			
			if(objBean.getStudentId()==null) {
				return responseBeanObj;
			}

			logger.info("Feedback Service StudentId: "+objBean.getStudentId() );
			
	            this.conn = this.appDataSource.getConnection();
	            if (this.conn != null) {
	                this.ps = this.conn.prepareStatement("SELECT sname,student_id,phone_no,email_id FROM "+MysqlTableNames.getPgprepStudentDetails()+" WHERE student_id=? ");
	                this.ps.setString(1, objBean.getStudentId());
	                logger.info("Forgot Password Service query: " + this.ps);
	                this.rs = this.ps.executeQuery();
	                if (this.rs.next()) {
	                	
	                	logger.info("Student Id: "+rs.getString("student_id") );
	                	logger.info("Student Name: "+rs.getString("sname") );
	                	logger.info("Student Phone: "+rs.getString("phone_no") );
	                	logger.info("Student email: "+rs.getString("email_id") );
	                	
	                	logger.info("Feedback Service QuestionId: "+objBean.getQuestionId() );
	                	logger.info("Feedback Service Feedback: "+objBean.getFeedback() );
	                	
	                	logger.info("Feedback Service OrganisationName: "+objBean.getOrganisationName() );
	
	                    ///General gen = new General();
	                    SendGridMail mailObj = new SendGridMail();				
						///String[] emailsToArr = {"info@easetolearn.com","jai.prakash@easetolearn.com"};
	                    ///String[] emailsToArr = {"ramesh.piwania@gmail.com"};
	                    String[] emailsToArr = {env.getProperty("feedbackEmailId")};
	                    
	                    
						String subject = "Feedback on Question: "+objBean.getQuestionId();
						String messageBody = "<div style='text-align:center; width:100%; padding:15px; background-color:#07449f; color:#FFF;'>"
								+ "<h1>EaseToLearn</h1>"
								+ "</div><br/><br/>";
						messageBody += "Dear Admin<br/><br/>";
						messageBody += "Student Name: "+rs.getString("sname")+"<br/>";
						messageBody += "Student ID: "+rs.getString("student_id")+"<br/>";
						messageBody += "Student Email: "+rs.getString("email_id")+"<br/>";
						messageBody += "Student Phone: "+rs.getString("phone_no")+"<br/>";
						messageBody += "Course: "+objBean.getOrganisationName()+"<br/>";
						messageBody += "Display Id: "+objBean.getQuestionId()+"<br/><br/>";
						messageBody += objBean.getFeedback();
						messageBody += "<br/><br/><br/>";
						
						
						logger.info("Mail Status: " + mailObj.send(emailsToArr, null, subject, messageBody));
	                	
						responseBeanObj.setResponseTxt("OK");
	                    
	    				logger.info("**************************************************************");
	    				logger.info("Successfully Feedback Service StudentId: "+objBean.getStudentId());
	    				logger.info("**************************************************************");
	                    
	                }
	                
	                this.rs.close();
	                this.ps.close();
	                this.conn.close();
            }

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseBeanObj;
	}
	
	
	
	
}
