package com.bizofficer.apiweb.feedbacktypes;



import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.env.Environment;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.hibernate.repository.PgprepFeedbackTypeRepository;
import com.bizofficer.hibernate.repository.PgprepStudentDetailsRepository;
import com.bizofficer.util.system.SendGridMail;



@Service
public class WebFBTService{
	
	
	@Autowired
	PgprepFeedbackTypeRepository myRepo;
    
	@Autowired
	PgprepStudentDetailsRepository stdRepo;
	
	@Autowired
	private Environment env;
	
	public Object execute(Object obj) throws NotFoundException{
		FBTBean objBean = (FBTBean) obj; 	
		FBTResponseBean responseBeanObj = new FBTResponseBean();
		
		try {
			
			responseBeanObj.setResponseTxt("failed");
			
			PgprepStudentDetails myStd = stdRepo.findIdByStudentId(objBean.getStudentId());
			
            SendGridMail mailObj = new SendGridMail();				
            String[] emailsToArr = {env.getProperty("feedbackEmailId")};
            ///String[] emailsToArr = {"ramesh.piwania@gmail.com"};
            
			String subject = objBean.getSubject()+" "+objBean.getType();
			String messageBody = "<div style='text-align:center; width:100%; padding:15px; background-color:#07449f; color:#FFF;'>"
					+ "<h1>EaseToLearn</h1>"
					+ "</div><br/><br/>";
			messageBody += "Dear Admin<br/><br/>";
			messageBody += "Student Name: "+myStd.getSname()+"<br/>";
			messageBody += "Student ID: "+myStd.getStudentId()+"<br/>";
			messageBody += "Student Email: "+myStd.getEmailId()+"<br/>";
			messageBody += "Student Phone: "+myStd.getPhoneNo()+"<br/><br/>";			
			messageBody += "Subject: "+objBean.getSubject()+"<br/>";
			messageBody += "Type: "+objBean.getType()+"<br/>";
			messageBody += objBean.getDetails();
			messageBody += "<br/><br/><br/>";			
			
			System.out.println("Mail Status: " + mailObj.send(emailsToArr, null, subject, messageBody));
			
			
			responseBeanObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseBeanObj;
	}
	
	
	
	
}
