package com.bizofficer.apiweb.forgotpassword;



import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.util.module.MysqlTableNames;
import com.bizofficer.util.module.SendSMS;
import com.bizofficer.util.module.SendSMSBean;
import com.bizofficer.util.system.General;
import com.bizofficer.util.system.SendGridMail;

import java.io.FileReader;
import java.net.URL;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.UUID;


@Service
public class MobileFPService{
	
	private static final Logger logger = Logger.getLogger(MobileFPService.class);
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
	public Object execute(Object obj) throws NotFoundException{
		FPBean objBean = (FPBean) obj; 	
		FPResponseBean loginResponseBeanObj = new FPResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");
			
			if(objBean.getUserId()==null) {
				return loginResponseBeanObj;
			}

			logger.info("Forgot Password Service UserId: "+objBean.getUserId() );
			
	            this.conn = this.appDataSource.getConnection();
	            if (this.conn != null) {
	                this.ps = this.conn.prepareStatement("SELECT student_id,email_id,phone_no FROM "+MysqlTableNames.getPgprepStudentDetails()+" WHERE (student_id=? OR email_id=? OR phone_no=?) AND account_status=1");
	                this.ps.setString(1, objBean.getUserId());
	                this.ps.setString(2, objBean.getUserId());
	                this.ps.setString(3, objBean.getUserId());
	                logger.info("Forgot Password Service query: " + this.ps);
	                this.rs = this.ps.executeQuery();
	                if (this.rs.next()) {
	
	                	String resetPasswordCode = UUID.randomUUID().toString().replaceAll("-", "");

	                    General gen = new General();

	                    Integer otpNumber =  gen.getRandomNumber(101914, 998765);
	                    	                    
	                	PreparedStatement psA = conn.prepareStatement("UPDATE "+MysqlTableNames.getPgprepStudentDetails()+" SET reset_pwd_code='"+resetPasswordCode+"',otp="+otpNumber+" WHERE student_id='"+rs.getString("student_id")+"' AND account_status=1 ");
	                    psA.executeUpdate();

	                    if(rs.getString("email_id")!=null && rs.getString("email_id").indexOf("@")>-1) {
	
		                    SendGridMail mailObj = new SendGridMail();				
							String[] emailsToArr = {rs.getString("email_id")};
							
							URL url = this.getClass().getResource("/resetpassword-otp.json");
							String absoluteDiskPath = url.getPath();
							JSONParser jsonParser = new JSONParser();
							FileReader reader = new FileReader(absoluteDiskPath);
							Object objJson = jsonParser.parse(reader);	
							JSONObject json = (JSONObject) objJson;
							String subject = (String) json.get("subject")+"........."+otpNumber;
							String messageBody = (String) json.get("message");
							
							messageBody = messageBody.replace("[RESETPASSWORDOTP]", otpNumber.toString() );
									
							logger.info("Mail Status: " + mailObj.send(emailsToArr, null, subject, messageBody));

							loginResponseBeanObj.setEmailId(rs.getString("email_id").replaceAll("\\S{1,5}@","*****@"));
	                    
	                    }

	                    if(rs.getString("phone_no")!=null && rs.getString("phone_no").length()>0) {
							SendSMSBean smsBean = new SendSMSBean();
				   			smsBean.setMobile(rs.getString("phone_no"));
					   		smsBean.setOtpNumber(otpNumber);
					   		smsBean.setWebsiteName("EaseToLearn");
				   			new SendSMS().OTP(smsBean);

	                    	loginResponseBeanObj.setMobile(rs.getString("phone_no").substring(0, 5)+"*****");
	                    }
	                	
	                    loginResponseBeanObj.setResponseTxt("OK");
	                    loginResponseBeanObj.setResetPasswordToken(resetPasswordCode);
	                    
	                    
	                    
	    				logger.info("**************************************************************");
	    				logger.info("Token: "+resetPasswordCode);
	    				logger.info("Mobile: "+rs.getString("phone_no"));
	    				logger.info("Successfully Forgot Password Service EmailId: "+rs.getString("email_id"));
	    				logger.info("**************************************************************");
	                    
	                }else {
	                	loginResponseBeanObj.setResponseTxt("InvalidUserId");
	                }
	                
	                this.rs.close();
	                this.ps.close();
	                this.conn.close();
            }

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
