package com.bizofficer.apiweb.keywords;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.repository.TopicKeywordRepository;
import com.bizofficer.util.module.MysqlTableNames;



@Service
public class LearningKeywordService{
	
	private static final Logger logger = Logger.getLogger(LearningKeywordService.class);
	
	@Autowired
	TopicKeywordRepository topicKeywordRepoObj;
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
    
    ///String contentSqlQry = " AND (SELECT 1 FROM "+MysqlTableNames.getPgprepAssessmentTreeview()+" x WHERE x.parentnode_name=a.childnode_name AND x.childnode_id IN (SELECT y.topicid FROM "+MysqlTableNames.getPgprepTopicContent()+" y) LIMIT 1)";
	
	public List<?> doExecute(Object obj) throws NotFoundException{
		KeywordBean objBean = (KeywordBean) obj; 	
		List<CoursesKeywordBean> dataList = new ArrayList<CoursesKeywordBean>();
		
		try {
		
			///String WhereQry=" and topicId IN (1000,1001,1002,1003) ";
			String WhereQry="";
			if(objBean.getTemplateId()!=null) {
				List<Integer> templateTopics = this.getTopicIds(objBean.getTemplateId());
				if(templateTopics.size()>0) {
					WhereQry=" and a.topic_id IN ("+templateTopics.toString().substring(1,templateTopics.toString().length()-1)+") ";
				}				
			}

			CoursesKeywordBean beanObj;
			List <String> keywordList = new ArrayList<String>();
        	conn = appDataSource.getConnection();
            if(conn != null)
            {
                ps = conn.prepareStatement("SELECT a.keyword_id,a.keyword,b.count1 FROM topic_keyword a LEFT JOIN "+MysqlTableNames.getQbKeyword()+" b ON a.keyword=b.keyword_name WHERE a.status='Active' and a.keyword is not null and LENGTH(a.keyword)>0 "+WhereQry+" order by a.keyword asc ");
                logger.info("topic main query: "+ps);
                rs = ps.executeQuery();
    			if(rs!=null) {
	                while(rs.next())
	                {
						if(keywordList.indexOf(rs.getString("keyword").toLowerCase())==-1) {
							beanObj = new CoursesKeywordBean();
							beanObj.setId(rs.getInt("keyword_id"));
							beanObj.setTitle(rs.getString("keyword").toLowerCase());
							beanObj.setQuestionCount(rs.getInt("count1"));
							keywordList.add(rs.getString("keyword").toLowerCase());
							dataList.add(beanObj);
						}
	                	
	                }
    			}else {
    				beanObj = new CoursesKeywordBean();
    				beanObj.setId(0);
    				beanObj.setTitle("Keyword Not Found");				
    				dataList.add(beanObj);
    			}

	            rs.close();
                ps.close();
                
            }
            conn.close();
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		////logger.info( "dataList >>> " +  dataList );
			
		return dataList;
	}
	

	
	public List<Integer> getTopicIds(Integer templateId)
    {
        List<Integer> topicList = new ArrayList<Integer>();
        
        try{
        	
        	conn = appDataSource.getConnection();
            if(conn != null)
            {
                ps = conn.prepareStatement("SELECT a.* FROM "+MysqlTableNames.getPgprepAssessmentTreeview()+" a LEFT JOIN "+MysqlTableNames.getTemplateAssessmentTreeview()+" b ON a.childnode_id=b.childnode_id WHERE b.template_id=? AND b.status='Active' AND a.parentnode_name=? "); //+contentSqlQry
                ps.setInt(1, templateId);
                ps.setString(2, "");
                logger.info("getTopicIds AAA: "+ps);
                rs = ps.executeQuery();
                while(rs.next())
                {
                	if(rs.getInt("childnode_id")>0) {
    					if(topicList.indexOf(rs.getInt("childnode_id"))==-1) {
    						topicList.add(rs.getInt("childnode_id"));

    						PreparedStatement preparedStatementAAA = conn.prepareStatement("SELECT a.* FROM "+MysqlTableNames.getPgprepAssessmentTreeview()+" a LEFT JOIN "+MysqlTableNames.getTemplateAssessmentTreeview()+" b ON a.childnode_id=b.childnode_id WHERE b.template_id=? AND b.status='Active' AND a.parentnode_name=? LIMIT 1 ");
    						preparedStatementAAA.setInt(1, templateId);
    						preparedStatementAAA.setString(2, rs.getString("childnode_name"));
    		                logger.info("getTopicIds BBB: "+preparedStatementAAA);
    		                ResultSet myRowAAA = preparedStatementAAA.executeQuery();
    		                if(myRowAAA.next()) {
    							//****************************************************************
    							topicList = this.subTopicsList(conn, topicList, rs.getString("childnode_name"), templateId);
    							//****************************************************************
    						} // close if(myObj
    						
    					}
    				}
                }
                rs.close();
                ps.close();
                conn.close();
        	
			logger.info( "KeywordService topicList >>>> " + topicList);
			
            }
			
  	    }catch(Exception ex){
    	   ex.printStackTrace();
   	    }

        
        return topicList;
        
  }


	private List<Integer> subTopicsList(Connection conn, List<Integer> topicList, String topicName, Integer templateId) {
		
        try{
		
			PreparedStatement preparedStatementCCC = conn.prepareStatement("SELECT a.* FROM "+MysqlTableNames.getPgprepAssessmentTreeview()+" a LEFT JOIN "+MysqlTableNames.getTemplateAssessmentTreeview()+" b ON a.childnode_id=b.childnode_id WHERE b.template_id=? AND b.status='Active' AND a.parentnode_name=? ");  //+contentSqlQry
			preparedStatementCCC.setInt(1, templateId);
			preparedStatementCCC.setString(2, topicName);
	        logger.info("subTopicsList CCC: "+preparedStatementCCC);
	        ResultSet myRowCCC = preparedStatementCCC.executeQuery();
	        while(myRowCCC.next()) {
				
				topicList.add(myRowCCC.getInt("childnode_id"));
				
				PreparedStatement preparedStatementDDD = conn.prepareStatement("SELECT a.* FROM "+MysqlTableNames.getPgprepAssessmentTreeview()+" a LEFT JOIN "+MysqlTableNames.getTemplateAssessmentTreeview()+" b ON a.childnode_id=b.childnode_id WHERE b.template_id=? AND b.status='Active' AND a.parentnode_name=? LIMIT 1 ");
				preparedStatementDDD.setInt(1, templateId);
				preparedStatementDDD.setString(2, myRowCCC.getString("childnode_name"));
	            logger.info("subTopicsList DDD: "+preparedStatementDDD);
	            ResultSet myRowDDD = preparedStatementDDD.executeQuery();
	            if(myRowDDD.next()) {
					//****************************************************************
				    
					this.subTopicsList(conn, topicList, myRowCCC.getString("childnode_name"), templateId);
					
					//****************************************************************
				} // close if(myObj
				
			} // close while(iterator

  	    }catch(Exception ex){
     	   ex.printStackTrace();
   	    }
        
		return topicList;

	} // makeTree Method close

	
	
	
	
	
	
	
}
