package com.bizofficer.apiweb.login;



import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.UUID;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;
import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepOrganisationMenu;
import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.util.module.MysqlTableNames;
import com.bizofficer.util.system.General;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;


@Service
public class LoginService{
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
    
    @Autowired
	EntityManagerFactory entityManagerFactory;
	
	public Object execute(Object obj) throws NotFoundException{
		LoginBean objBean = (LoginBean) obj; 	
		LoginResponseBean loginResponseBeanObj = new LoginResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");

			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			if(objBean.getPassword()!=null && objBean.getPassword().length()>0) {
				General gen = new General();
				objBean.setPassword(gen.getMD5Hashing(objBean.getPassword()));
			}
			
			if(objBean.getLoginKey()!=null && objBean.getLoginKey().length()>0 && objBean.getUserId()==null && objBean.getPassword()==null) {
				System.out.println("LoginService Login Key: "+objBean.getLoginKey() );
				TypedQuery<PgprepStudentDetails> query = (TypedQuery<PgprepStudentDetails>) entityManager.createQuery("from "+PgprepStudentDetails.class.getName()+" where loginKey=:loginKey ", PgprepStudentDetails.class);
				query.setParameter("loginKey", objBean.getLoginKey() );
				query.setFirstResult(0);
				query.setMaxResults(1);
				List<?> resultList = query.getResultList();
				Iterator<?> iterator=resultList.iterator();
				if(iterator.hasNext()){
					PgprepStudentDetails myObj = (PgprepStudentDetails)iterator.next();
					System.out.println("LoginService StudentId: "+myObj.getStudentId() );
					objBean.setUserId(myObj.getStudentId());
					objBean.setPassword(myObj.getPassword());
				}	
			}
			
			System.out.println("A LoginService UserId: "+objBean.getUserId() );
			
			if(objBean.getUserId()==null || objBean.getPassword()==null) {
				return loginResponseBeanObj;
			}
			
        	SimpleDateFormat dtformat = new SimpleDateFormat("yyyy-MM-dd");
            String today = dtformat.format(new Date());
			
			System.out.println("B LoginService UserId: "+objBean.getUserId() );
			
            this.conn = this.appDataSource.getConnection();
            if (this.conn != null && objBean.getUserId()!=null && objBean.getPassword()!=null) {
            	
                this.ps = this.conn.prepareStatement("SELECT s.*,o.organisation_name,ot.template_id FROM "+MysqlTableNames.getPgprepStudentDetails()+" s, "+MysqlTableNames.getOrganisationTemplateAssociation()+" ot, "+MysqlTableNames.getOrganisationInfo()+" o WHERE s.organisation_id=o.organisation_id AND s.organisation_id = ot.organisation_id AND s.student_id=? AND s.password=? AND account_status=1");
                this.ps.setString(1, objBean.getUserId());
                this.ps.setString(2, objBean.getPassword());
                System.out.println("LoginService query: " + this.ps);
                this.rs = this.ps.executeQuery();
                if (this.rs.next()) {
                	System.out.println("LoginService query executed ID: " + rs.getInt("id"));
                    Date validTill = dtformat.parse(rs.getString("registration_valid_till"));
                    Date now = dtformat.parse(today);
                    if (now.compareTo(validTill) > 0) {
                    	loginResponseBeanObj.setResponseTxt("ValidityFinished");
                    	
                    }else{
                    	
                    	loginResponseBeanObj.setStudentId(rs.getString("student_id"));
                    	loginResponseBeanObj.setEmailId(rs.getString("email_id"));
                        loginResponseBeanObj.setProfilePic(rs.getString("photo"));
                        loginResponseBeanObj.setStudentName(rs.getString("sname"));
                        loginResponseBeanObj.setOrganisationId(rs.getInt("organisation_id"));
                        loginResponseBeanObj.setTemplateId(rs.getInt("template_id"));
                        loginResponseBeanObj.setOrganisationName(rs.getString("organisation_name")); 
                        loginResponseBeanObj.setToken(UUID.randomUUID().toString()+UUID.randomUUID().toString());
                        loginResponseBeanObj.setPhoneNo(rs.getString("phone_no"));

                        if(rs.getInt("account_status")>0) {
                        	loginResponseBeanObj.setStatus("Active");
        				}else {
        					loginResponseBeanObj.setStatus("Inactive");
        				}
                        
                        PreparedStatement psA = conn.prepareStatement("UPDATE pgprep_student_details SET token='"+loginResponseBeanObj.getToken()+"' WHERE student_id='"+loginResponseBeanObj.getStudentId()+"' ");
                        psA.executeUpdate();
                        
                        loginResponseBeanObj.setTopicTest(0);
                        if(loginResponseBeanObj.getOrganisationId()!=null && loginResponseBeanObj.getOrganisationId()>0) {
                        	/// CHECK TEST AVAILABLE OR NOT                        	
                        	TypedQuery<PgprepOrganisationMenu> query = (TypedQuery<PgprepOrganisationMenu>) entityManager.createQuery("from "+PgprepOrganisationMenu.class.getName()+" where organisationId=:organisationId ", PgprepOrganisationMenu.class);
            				query.setParameter("organisationId", loginResponseBeanObj.getOrganisationId() );
            				query.setFirstResult(0);
            				query.setMaxResults(1);
            				List<?> resultListCat = query.getResultList();
            				Iterator<?> iteratorCat=resultListCat.iterator();
            				if(iteratorCat.hasNext()){
            					PgprepOrganisationMenu myObj = (PgprepOrganisationMenu)iteratorCat.next();
            					loginResponseBeanObj.setDashboard(myObj.getDashboard());
            					loginResponseBeanObj.setReport(myObj.getReport());
            					loginResponseBeanObj.setSmartLearning(myObj.getSmartLearning());
            					loginResponseBeanObj.setSelfTest(myObj.getSelfTest());
            					loginResponseBeanObj.setTopicTest(myObj.getTopicTest()); 
            					loginResponseBeanObj.setMockTest(myObj.getMockTest()); 
            					loginResponseBeanObj.setClassTest(myObj.getClassTest());
            				}
                        }
                        
                        if(rs.getInt("schoolId")>0) {
    						List<StudentSchoolBean> schools = new ArrayList<StudentSchoolBean>();
    						StudentSchoolBean schoolBeanObj;
    						
    						schoolBeanObj = new StudentSchoolBean();
    						schoolBeanObj.setSchoolId(rs.getInt("schoolId"));
    						schoolBeanObj.setSchoolName(rs.getString("schoolName"));
    						schoolBeanObj.setClassName(rs.getString("className"));
    						schoolBeanObj.setAdmissionNumber(rs.getString("admissionNumber"));
    						
    						schools.add(schoolBeanObj);

    						loginResponseBeanObj.setSchools(schools);	
                        }
                        
//        				if(loginResponseBeanObj.getStudentId()!=null) {
//        					TypedQuery<PgprepStudentAssociation> querySkool = (TypedQuery<PgprepStudentAssociation>) entityManager.createQuery("from "+PgprepStudentAssociation.class.getName()+" where studentId=:studentId ", PgprepStudentAssociation.class);
//        					querySkool.setParameter("studentId", loginResponseBeanObj.getStudentId());
//        					querySkool.setFirstResult(0);
//        					querySkool.setMaxResults(1);
//        					List<?> resultListSkool = querySkool.getResultList();
//        					Iterator<?> iteratorSkool=resultListSkool.iterator();
//        					List<StudentSchoolBean> schools = new ArrayList<StudentSchoolBean>();
//        					StudentSchoolBean schoolBeanObj;
//        					if(iteratorSkool.hasNext()){
//        						PgprepStudentAssociation myObjSkool = (PgprepStudentAssociation)iteratorSkool.next();	
//        						schoolBeanObj = new StudentSchoolBean();
//        						schoolBeanObj.setSchoolId(myObjSkool.getSchoolId());
//        						schoolBeanObj.setSchoolName(myObjSkool.getSchoolName());
//        						schoolBeanObj.setClassName(myObjSkool.getClassName());
//        						schoolBeanObj.setAdmissionNumber(myObjSkool.getAdmissionNumber());
//        						
//        							TypedQuery<PgprepStudentAssociation> queryClss = (TypedQuery<PgprepStudentAssociation>) entityManager.createQuery("from "+PgprepStudentAssociation.class.getName()+" where schoolId=:schoolId group by subject ", PgprepStudentAssociation.class);
//        							queryClss.setParameter("schoolId", myObjSkool.getSchoolId());
//        							List<?> resultListClss = queryClss.getResultList();
//        							Iterator<?> iteratorClss  =resultListClss.iterator();
//        							List<String> subjects = new ArrayList<String>();
//        							while(iteratorClss.hasNext()){
//        								PgprepStudentAssociation myClass = (PgprepStudentAssociation)iteratorClss.next();
//       									subjects.add(myClass.getSubject());
//        							}						
//        							schoolBeanObj.setSubjects(subjects);
//        							
//        						schools.add(schoolBeanObj);
//        					}	
//        					loginResponseBeanObj.setSchools(schools);					
//        				}

                        
                        loginResponseBeanObj.setResponseTxt("OK");
    					System.out.println("**************************************************************");
    					System.out.println("Login successfully Student Id: "+objBean.getUserId());
    					System.out.println("**************************************************************");
                        
                    }
                }
                
                this.rs.close();
                this.ps.close();
                this.conn.close();
            }

            entityManager.getTransaction().commit();
			entityManager.close();
			
		}catch(Exception e) {
			e.getStackTrace();			
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
