package com.bizofficer.apiweb.login;



import java.util.UUID;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.util.module.MysqlTableNames;
import com.bizofficer.util.system.General;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;


@Service
public class MobileLoginService{
	
	private static final Logger logger = Logger.getLogger(MobileLoginService.class);
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
    
    @Autowired
	EntityManagerFactory entityManagerFactory;
	
	public Object execute(Object obj) throws NotFoundException{
		LoginBean objBean = (LoginBean) obj; 	
		LoginResponseBean loginResponseBeanObj = new LoginResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");

			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			if(objBean.getPassword()!=null && objBean.getPassword().length()>0) {
				General gen = new General();
				objBean.setPassword(gen.getMD5Hashing(objBean.getPassword()));
			}
			
			logger.info("MobileLoginService UserId: "+objBean.getUserId() );
			
			if(objBean.getUserId()==null || objBean.getPassword()==null) {
				return loginResponseBeanObj;
			}
			
            this.conn = this.appDataSource.getConnection();
            if (this.conn != null && objBean.getUserId()!=null && objBean.getPassword()!=null) {
            	
                this.ps = this.conn.prepareStatement("SELECT * FROM "+MysqlTableNames.getPgprepStudentDetails()+" WHERE (student_id=? OR email_id=? OR phone_no=?) AND password=? AND account_status=1");
                this.ps.setString(1, objBean.getUserId());
                this.ps.setString(2, objBean.getUserId());
                this.ps.setString(3, objBean.getUserId());
                this.ps.setString(4, objBean.getPassword());
                logger.info("LoginService query: " + this.ps);
                this.rs = this.ps.executeQuery();
                if (this.rs.next()) {
                	
                	logger.info("MobileLoginService query executed ID: " + rs.getInt("id"));
                    logger.info("MobileLoginService student_id: " + rs.getString("student_id"));
                    	
                    
                        loginResponseBeanObj.setLoginKey(UUID.randomUUID().toString()+UUID.randomUUID().toString());

                        
                        PreparedStatement psA = conn.prepareStatement("UPDATE pgprep_student_details SET loginKey='"+loginResponseBeanObj.getLoginKey()+"' WHERE student_id='"+rs.getString("student_id")+"' ");
                        psA.executeUpdate();
                        
                        logger.info("MobileLoginService LoginKey: " + loginResponseBeanObj.getLoginKey());
                        
                        loginResponseBeanObj.setResponseTxt("OK");
    					logger.info("**************************************************************");
    					logger.info("MobileLoginService Login successfully Student Id: "+objBean.getUserId());
    					logger.info("**************************************************************");
                    
                }
                
                this.rs.close();
                this.ps.close();
                this.conn.close();
            }

            entityManager.getTransaction().commit();
			entityManager.close();
			
		}catch(Exception e) {
			e.getStackTrace();			
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
