package com.bizofficer.apiweb.login;



import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.hibernate.repository.PgprepStudentDetailsRepository;



@Service
public class TokenVerifyStudentService{
	
	private static final Logger logger = Logger.getLogger(TokenVerifyStudentService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepStudentDetailsRepository userRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		LoginBean objBean = (LoginBean) obj;
		TokenVerifyResponsePojo responseObj = new TokenVerifyResponsePojo();
		
		try {
			
			responseObj.setResponseTxt("failed");

			logger.info("VERIFY TOKEN START **********************************************************");
			logger.info("StudentId >> " + objBean.getStudentId() );
			logger.info("Token >> " + objBean.getToken() );
			
			if(objBean.getToken()==null || objBean.getStudentId()==null) {
				return responseObj;
			}
			
			PgprepStudentDetails studentObj = (PgprepStudentDetails) userRepo.findIdByStudentIdAndToken(objBean.getStudentId(), objBean.getToken());
			
			logger.info("studentObj >> " + studentObj);
			
			if(studentObj==null) {
				responseObj.setResponseTxt("unauthorized");
				return responseObj;
			}

			logger.info("Token Verified, Found Student Auto Id >> " + studentObj.getId() );

			logger.info("VERIFY TOKEN END **********************************************************");
			
			responseObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
