package com.bizofficer.apiweb.resetpassword;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


@RestController
@Service
public class ResetPasswordWebController {
	
	private static final Logger logger = Logger.getLogger(ResetPasswordWebController.class);
	
	@Autowired
	private ResetPasswordWebService loginServiceObj;
	
	@RequestMapping(value = {"/web-resetpassword"}, method = {RequestMethod.POST})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")ResetPwdBean objBean) {
		
		try {
			
			logger.info("ResetPwdController Token: "+objBean.getToken() );
			
			ResetPwdResponseBean tsrbObj = (ResetPwdResponseBean) (Object) loginServiceObj.execute(objBean);
			
			logger.info("ResetPwdController ResponseTxt: "+tsrbObj.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
