package com.bizofficer.apiweb.resetpassword;



import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.util.module.MysqlTableNames;
import com.bizofficer.util.system.General;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;


@Service
public class ResetPasswordWebService{
	
	private static final Logger logger = Logger.getLogger(ResetPasswordWebService.class);
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
	public Object execute(Object obj) throws NotFoundException{
		ResetPwdBean objBean = (ResetPwdBean) obj; 	
		ResetPwdResponseBean responseBeanObj = new ResetPwdResponseBean();
		
		try {
			responseBeanObj.setResponseTxt("failed");
			
			if(objBean.getNewPassword()==null || objBean.getToken()==null) {
				return responseBeanObj;
			}

			logger.info("ResetPwdService Token: "+objBean.getToken() );
			
	            this.conn = this.appDataSource.getConnection();
	            if (this.conn != null) {
	            	
	            	General gen = new General();
	            	
		                this.ps = this.conn.prepareStatement("SELECT id FROM "+MysqlTableNames.getPgprepStudentDetails()+" WHERE reset_pwd_code=? ");
		                this.ps.setString(1, objBean.getToken());
		                logger.info("ResetPwdService query: " + this.ps);
		                this.rs = this.ps.executeQuery();
		                if (this.rs.next()) {

		                	PreparedStatement psBB = conn.prepareStatement("SELECT 1 FROM "+MysqlTableNames.getPgprepStudentDetails()+" WHERE reset_pwd_code=? AND otp=? AND account_status=1");
		                	psBB.setString(1, objBean.getToken());
		                	psBB.setInt(2, objBean.getOtp());
			                logger.info("VerifyFPOtpService query: " + psBB);
			                ResultSet rsBB = psBB.executeQuery();
			                if (rsBB.next()) {
		                	
			                	PreparedStatement psA = conn.prepareStatement("UPDATE "+MysqlTableNames.getPgprepStudentDetails()+" SET password=?,reset_pwd_code=? WHERE id=?");
			                	psA.setString(1, gen.getMD5Hashing(objBean.getNewPassword()));
			                	psA.setString(2, "");
			                	psA.setInt(3, rs.getInt("id"));
			                	psA.executeUpdate();
			                	
								responseBeanObj.setResponseTxt("OK");
			                    
			    				logger.info("**************************************************************");
			    				logger.info("Successfully ResetPwdService ID: "+rs.getInt(0));
			    				logger.info("**************************************************************");
			    				
			    				psA.close();
			    				
			                }else {
			                	responseBeanObj.setResponseTxt("InvalidOTP");
			                }
	
		                }else {
		                	responseBeanObj.setResponseTxt("InvalidToken");
		                }
	                
	                
	                this.rs.close();
	                this.ps.close();
	                this.conn.close();
            }

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseBeanObj;
	}
	
	
	
	
}
