package com.bizofficer.apiweb.testdetail;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.apiweb.login.LoginBean;
import com.bizofficer.apiweb.login.TokenVerifyResponsePojo;
import com.bizofficer.apiweb.login.TokenVerifyStudentService;
import com.bizofficer.pojo.response.ListResponsePojo;

@RestController
@Service
public class TestingPageController {
	
	private static final Logger logger = Logger.getLogger(TestingPageController.class);
	
	@Autowired
	private MockTestAPIService mockTestAPIServiceObj;
	
	@Autowired
	private SelfTestAPIService selfTestAPIServiceObj;

	@Autowired
	private TopicTestAPIService topicTestAPIServiceObj;

	@Autowired
	private ClassTestAPIService classTestAPIServiceObj;
	
	@Autowired
	private TokenVerifyStudentService objTokenVerifyStudentService;
	
	@RequestMapping(value = {"/testdetails"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanTesting objBean, @RequestHeader("studentId") String studentId, @RequestHeader("token") String token) {
		
		try {
			
			LoginBean loginBean = new LoginBean();
			loginBean.setStudentId(studentId);
			loginBean.setToken(token);
			TokenVerifyResponsePojo objTokenVerifyResponse = (TokenVerifyResponsePojo) (Object) objTokenVerifyStudentService.execute(loginBean);
			
			if(objTokenVerifyResponse.getResponseTxt().equals("success")) {
			
				ListResponsePojo responseObj = new ListResponsePojo();
				
				logger.info("Test Id: "+objBean.getTestId() );
				logger.info("Test Type: "+objBean.getTestType() );
	
				// Self Test ************************************************	
				if(objBean.getTestType()!=null && objBean.getTestType()==1) {
					responseObj = (ListResponsePojo) (Object) selfTestAPIServiceObj.doExecute(objBean);
	
				// Topic Test ***********************************************	
				}else if(objBean.getTestType()!=null && objBean.getTestType()==2) {
					responseObj = (ListResponsePojo) (Object) topicTestAPIServiceObj.doExecute(objBean);
					
				// Mock Test ************************************************
				}else if(objBean.getTestType()!=null && objBean.getTestType()==3) {
					responseObj = (ListResponsePojo) (Object) mockTestAPIServiceObj.doExecute(objBean);
	
				// Class Test ************************************************
				}else if(objBean.getTestType()!=null && objBean.getTestType()==4) {
					responseObj = (ListResponsePojo) (Object) classTestAPIServiceObj.doExecute(objBean);
					
				}
				
				logger.info("Service ResponseTxt: "+responseObj.getResponseTxt());
				
				HttpHeaders headers = new HttpHeaders();
		        return ResponseEntity.ok().headers(headers).body(responseObj);
			
			}

			
			logger.info("Token Verify ResponseTxt: "+objTokenVerifyResponse.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        return ResponseEntity.ok().headers(headers).body(objTokenVerifyResponse);
			
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
