package com.bizofficer.apiweb.topictestlist;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.pojo.response.ListResponsePojo;

@RestController
@Service
public class TopicTestListController {
	
	private static final Logger logger = Logger.getLogger(TopicTestListController.class);
	
	@Autowired
	private TopicTestListService cclsObj;

	@RequestMapping(value = {"/topictestlist"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanTop objBean) {
		
		try {
			
        	System.out.println("TopicTestListController TemplateId: "+objBean.getTemplateId());
        	System.out.println("TopicTestListController TopicId: "+objBean.getTopicId());
        	System.out.println("TopicTestListController TopicName: "+objBean.getTopicName());

			ListResponsePojo responseObj = (ListResponsePojo) cclsObj.doExecute(objBean);
				
			logger.info("Service ResponseTxt: "+responseObj.getResponseTxt());
				
			HttpHeaders headers = new HttpHeaders();
	        return ResponseEntity.ok().headers(headers).body(responseObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
