package com.bizofficer.hibernate.entity;

import java.util.Date;

import javax.persistence.Cacheable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


@Entity
@Table(name = "model_test_management")
@Cacheable
public class ModelTestManagement {

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "model_test_id")
	private Integer modelTestId;

	@Column(name = "model_test_title")	
	private String modelTestTitle;
	
	@Column(name = "model_test_description")	
	private String modelTestDescription;
	
	@Column(name = "no_of_questions_per_page")	
	private Integer noOfQuestionsPerPage;

	@Column(name = "duration")	
	private Integer duration;
	
	@Column(name = "section_allow")	
	private Integer sectionAllow;

	@Column(name = "marks_correct_ans")	
	private Double marksCorrectAns;

	@Column(name = "marks_incorrect_ans")
	private Double marksIncorrectAns;
	
	@Column(name = "marks_not_ans")	
	private Double marksNotAns;
	
	@Column(name = "date")
	@Temporal(TemporalType.TIMESTAMP)
	private Date date;

	@Column(name = "created_by")	
	private String createdBy;
	
	@Column(name = "ismocktest")	
	private String ismocktest;

	@Column(name = "last_year_min")	
	private String lastYearMin;

	@Column(name = "last_year_max")	
	private String lastYearMax;

	@Column(name = "sme_benchmark_min")	
	private String smeBenchmarkMin;
	
	@Column(name = "sme_benchmark_max")	
	private String smeBenchmarkMax;

	@Column(name = "approx_benchmark_min")	
	private String approxBenchmarkMin;

	@Column(name = "approx_benchmark_max")	
	private String approxBenchmarkMax;

	
	
	
	public Integer getModelTestId() {
		return modelTestId;
	}

	public void setModelTestId(Integer modelTestId) {
		this.modelTestId = modelTestId;
	}

	public String getModelTestTitle() {
		return modelTestTitle;
	}

	public void setModelTestTitle(String modelTestTitle) {
		this.modelTestTitle = modelTestTitle;
	}

	public String getModelTestDescription() {
		return modelTestDescription;
	}

	public void setModelTestDescription(String modelTestDescription) {
		this.modelTestDescription = modelTestDescription;
	}

	public Integer getNoOfQuestionsPerPage() {
		return noOfQuestionsPerPage;
	}

	public void setNoOfQuestionsPerPage(Integer noOfQuestionsPerPage) {
		this.noOfQuestionsPerPage = noOfQuestionsPerPage;
	}

	public Integer getDuration() {
		return duration;
	}

	public void setDuration(Integer duration) {
		this.duration = duration;
	}

	public Integer getSectionAllow() {
		return sectionAllow;
	}

	public void setSectionAllow(Integer sectionAllow) {
		this.sectionAllow = sectionAllow;
	}

	public Double getMarksCorrectAns() {
		return marksCorrectAns;
	}

	public void setMarksCorrectAns(Double marksCorrectAns) {
		this.marksCorrectAns = marksCorrectAns;
	}

	public Double getMarksIncorrectAns() {
		return marksIncorrectAns;
	}

	public void setMarksIncorrectAns(Double marksIncorrectAns) {
		this.marksIncorrectAns = marksIncorrectAns;
	}

	public Double getMarksNotAns() {
		return marksNotAns;
	}

	public void setMarksNotAns(Double marksNotAns) {
		this.marksNotAns = marksNotAns;
	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public String getCreatedBy() {
		return createdBy;
	}

	public void setCreatedBy(String createdBy) {
		this.createdBy = createdBy;
	}

	public String getIsmocktest() {
		return ismocktest;
	}

	public void setIsmocktest(String ismocktest) {
		this.ismocktest = ismocktest;
	}

	public String getLastYearMin() {
		return lastYearMin;
	}

	public void setLastYearMin(String lastYearMin) {
		this.lastYearMin = lastYearMin;
	}

	public String getLastYearMax() {
		return lastYearMax;
	}

	public void setLastYearMax(String lastYearMax) {
		this.lastYearMax = lastYearMax;
	}

	public String getSmeBenchmarkMin() {
		return smeBenchmarkMin;
	}

	public void setSmeBenchmarkMin(String smeBenchmarkMin) {
		this.smeBenchmarkMin = smeBenchmarkMin;
	}

	public String getSmeBenchmarkMax() {
		return smeBenchmarkMax;
	}

	public void setSmeBenchmarkMax(String smeBenchmarkMax) {
		this.smeBenchmarkMax = smeBenchmarkMax;
	}

	public String getApproxBenchmarkMin() {
		return approxBenchmarkMin;
	}

	public void setApproxBenchmarkMin(String approxBenchmarkMin) {
		this.approxBenchmarkMin = approxBenchmarkMin;
	}

	public String getApproxBenchmarkMax() {
		return approxBenchmarkMax;
	}

	public void setApproxBenchmarkMax(String approxBenchmarkMax) {
		this.approxBenchmarkMax = approxBenchmarkMax;
	}

	
	
	
	
	
	
	
	

	
	
}
