package com.bizofficer.hibernate.entity;

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Cacheable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


@Entity
@Table(name = "pgprep_test_summary")
@Cacheable
public class PgprepTestSummary {

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	@Column(name = "organisation_id")	
	private Integer organisationId;
	
	@Column(name = "test_session")	
	private String testSession;
	
	@Column(name = "student_id")	
	private String studentId;

	@Column(name = "test_root_id")	
	private Integer testRootId;

	@Column(name = "test_node_id")	
	private Integer testNodeId;

	@Column(name = "test_type")	
	private Integer testType;
	
	@Column(name = "test_option")	
	private Integer testOption;
	
	@Column(name = "test_title")	
	private String testTitle;
	
	@Column(name = "total_question")	
	private Integer totalQuestion;
	
	@Column(name = "last_visited_question")	
	private Integer lastVisitedQuestion;
	
	@Column(name = "answer_division")	
	private String answerDivision;
	
	@Column(name = "total_time")	
	private Integer totalTime;
	
	@Column(name = "time_spent")	
	private Integer timeSpent;

	@Column(name = "marks_division")	
	private String marksDivision;
	
	@Column(name = "full_marks")	
	private BigDecimal fullMarks;
	
	@Column(name = "marks_obtain")	
	private BigDecimal marksObtain;
	
	@Column(name = "start_date")
	@Temporal(TemporalType.TIMESTAMP)
	private Date startDate;

	@Column(name = "end_date")
	@Temporal(TemporalType.TIMESTAMP)
	private Date endDate;
	
	@Column(name = "schoolName")	
	private String schoolName;

	@Column(name = "schoolId")	
	private Integer schoolId;

	@Column(name = "className")	
	private String className;

	@Column(name = "subject")	
	private String subject;

	@Column(name = "admissionNumber")	
	private String admissionNumber;
	
	@Column(name = "studentName")	
	private String studentName;

	@Column(name = "scheduleId")	
	private String scheduleId;

	@Column(name = "test_status")	
	private Integer testStatus;

	@Column(name = "test_detail")	
	private String testDetail;
	
	
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Integer getOrganisationId() {
		return organisationId;
	}

	public void setOrganisationId(Integer organisationId) {
		this.organisationId = organisationId;
	}

	public String getTestSession() {
		return testSession;
	}

	public void setTestSession(String testSession) {
		this.testSession = testSession;
	}

	public String getStudentId() {
		return studentId;
	}

	public void setStudentId(String studentId) {
		this.studentId = studentId;
	}

	public Integer getTestRootId() {
		return testRootId;
	}

	public void setTestRootId(Integer testRootId) {
		this.testRootId = testRootId;
	}

	public Integer getTestNodeId() {
		return testNodeId;
	}

	public void setTestNodeId(Integer testNodeId) {
		this.testNodeId = testNodeId;
	}

	public Integer getTestType() {
		return testType;
	}

	public void setTestType(Integer testType) {
		this.testType = testType;
	}

	public Integer getTestOption() {
		return testOption;
	}

	public void setTestOption(Integer testOption) {
		this.testOption = testOption;
	}

	public String getTestTitle() {
		return testTitle;
	}

	public void setTestTitle(String testTitle) {
		this.testTitle = testTitle;
	}

	public Integer getTotalQuestion() {
		return totalQuestion;
	}

	public void setTotalQuestion(Integer totalQuestion) {
		this.totalQuestion = totalQuestion;
	}

	public Integer getLastVisitedQuestion() {
		return lastVisitedQuestion;
	}

	public void setLastVisitedQuestion(Integer lastVisitedQuestion) {
		this.lastVisitedQuestion = lastVisitedQuestion;
	}

	public String getAnswerDivision() {
		return answerDivision;
	}

	public void setAnswerDivision(String answerDivision) {
		this.answerDivision = answerDivision;
	}

	public Integer getTotalTime() {
		return totalTime;
	}

	public void setTotalTime(Integer totalTime) {
		this.totalTime = totalTime;
	}

	public Integer getTimeSpent() {
		return timeSpent;
	}

	public void setTimeSpent(Integer timeSpent) {
		this.timeSpent = timeSpent;
	}

	public String getMarksDivision() {
		return marksDivision;
	}

	public void setMarksDivision(String marksDivision) {
		this.marksDivision = marksDivision;
	}

	public BigDecimal getFullMarks() {
		return fullMarks;
	}

	public void setFullMarks(BigDecimal fullMarks) {
		this.fullMarks = fullMarks;
	}

	public BigDecimal getMarksObtain() {
		return marksObtain;
	}

	public void setMarksObtain(BigDecimal marksObtain) {
		this.marksObtain = marksObtain;
	}

	public Date getStartDate() {
		return startDate;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	public Date getEndDate() {
		return endDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	public Integer getTestStatus() {
		return testStatus;
	}

	public void setTestStatus(Integer testStatus) {
		this.testStatus = testStatus;
	}

	public String getTestDetail() {
		return testDetail;
	}

	public void setTestDetail(String testDetail) {
		this.testDetail = testDetail;
	}

	public Integer getSchoolId() {
		return schoolId;
	}

	public void setSchoolId(Integer schoolId) {
		this.schoolId = schoolId;
	}

	public String getClassName() {
		return className;
	}

	public void setClassName(String className) {
		this.className = className;
	}

	public String getSubject() {
		return subject;
	}

	public void setSubject(String subject) {
		this.subject = subject;
	}

	public String getScheduleId() {
		return scheduleId;
	}

	public void setScheduleId(String scheduleId) {
		this.scheduleId = scheduleId;
	}

	public String getAdmissionNumber() {
		return admissionNumber;
	}

	public void setAdmissionNumber(String admissionNumber) {
		this.admissionNumber = admissionNumber;
	}

	public String getStudentName() {
		return studentName;
	}

	public void setStudentName(String studentName) {
		this.studentName = studentName;
	}

	public String getSchoolName() {
		return schoolName;
	}

	public void setSchoolName(String schoolName) {
		this.schoolName = schoolName;
	}

		
	
	
	
	

	

	
	

	



	


	
	
	
	

	
	
}
