package com.bizofficer.hibernate.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.bizofficer.hibernate.entity.PgprepParents;

@Repository
public interface PgprepParentsRepository extends JpaRepository<PgprepParents, Long> {

	PgprepParents findByLoginToken(String loginToken);
	
	PgprepParents findByMobile(String mobile);
	PgprepParents findByMobileAndParentIdNot(String mobile, Integer id);
	
	PgprepParents findByEmailId(String emailId);
	PgprepParents findByEmailIdAndParentIdNot(String emailId, Integer id);
	
	@Transactional
	@Modifying
	void deleteByParentId(Integer parentId);
	
}
