package com.bizofficer.hibernate.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.bizofficer.hibernate.entity.SubscriptionCoursesCategory;


@Repository
public interface SubscriptionCoursesCategoryRepository extends JpaRepository<SubscriptionCoursesCategory, Long> {

	SubscriptionCoursesCategory findIdByCategoryNameAndWebsiteId(String categoryName, Integer websiteId);
	
	SubscriptionCoursesCategory findIdByCategoryNameAndWebsiteIdAndCategoryIdNot(String categoryName, Integer websiteId, Integer categoryId);
	
	@Transactional
	@Modifying
	void deleteByCategoryId(Integer categoryId);
	
}
