package com.bizofficer.parents.web;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.UUID;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepParents;
import com.bizofficer.hibernate.entity.PgprepParentsChildren;
import com.bizofficer.hibernate.entity.PgprepStudentCourses;
import com.bizofficer.util.system.General;



@Service
public class ParentsLoginService{
	
	private static final Logger logger = Logger.getLogger(ParentsLoginService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	public Object execute(Object obj) throws NotFoundException{
		ParentsRequestBean objBean = (ParentsRequestBean) obj; 	
		ParentsResponse responseObj = new ParentsResponse();
		
		try {
			
			logger.info("UserId: "+objBean.getUserId() );

			responseObj.setResponseTxt("failed");
			
			if(objBean.getUserId()==null || objBean.getPassword()==null) {
				return responseObj;
			}

			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			General gen = new General();
			
			TypedQuery<PgprepParents> queryTeach = (TypedQuery<PgprepParents>) entityManager.createQuery("from "+PgprepParents.class.getName()+" where (mobile=:userId OR emailId=:userId) AND password=:password AND accountStatus=1 ", PgprepParents.class);
			queryTeach.setParameter("userId", objBean.getUserId());
			queryTeach.setParameter("password", gen.getMD5Hashing(objBean.getPassword()));
			List<?> resultListTeach = queryTeach.getResultList();
			Iterator<?> iteratorTeach=resultListTeach.iterator();
			if(iteratorTeach.hasNext()){
				PgprepParents myObj = (PgprepParents)iteratorTeach.next();
			
				LoginParentsBean beanLgnObj = new LoginParentsBean();
				
				beanLgnObj.setFullName(myObj.getFullName());
            	
				beanLgnObj.setToken(UUID.randomUUID().toString()+UUID.randomUUID().toString());
                
				PgprepParents ssaveObj = (PgprepParents)entityManager.find(PgprepParents.class ,myObj.getParentId());
				ssaveObj.setLoginToken(beanLgnObj.getToken());
				entityManager.getTransaction().commit();
				
				responseObj.setObj(beanLgnObj);
				
				
				List<ParentsChildrenBean> children = new ArrayList<ParentsChildrenBean>();
				ParentsChildrenBean beanChObj;
				StudentCoursePBean corsChObj;
						
				TypedQuery<PgprepParentsChildren> queryCh = (TypedQuery<PgprepParentsChildren>) entityManager.createQuery("from "+PgprepParentsChildren.class.getName()+" where parentId=:parentId ", PgprepParentsChildren.class);
				queryCh.setParameter("parentId", myObj.getParentId());
				queryCh.setFirstResult(0);
				queryCh.setMaxResults(10);
				List<?> resultCh = queryCh.getResultList();
				Iterator<?> iteratorCh = resultCh.iterator();
				int i=1;
				while(iteratorCh.hasNext()){
					PgprepParentsChildren myChObj = (PgprepParentsChildren)iteratorCh.next();
				
					beanChObj = new ParentsChildrenBean();
					beanChObj.setId(i);
					beanChObj.setStudentId(myChObj.getStudentId());
					beanChObj.setFullName(myChObj.getFullName());				

					List<StudentCoursePBean> studentCourses = new ArrayList<StudentCoursePBean>();										
					TypedQuery<PgprepStudentCourses> queryCors = (TypedQuery<PgprepStudentCourses>) entityManager.createQuery("from "+PgprepStudentCourses.class.getName()+" where studentId=:studentId ", PgprepStudentCourses.class);
					queryCors.setParameter("studentId", myChObj.getStudentId());
					queryCors.setFirstResult(0);
					queryCors.setMaxResults(20);
					List<?> resultCors = queryCors.getResultList();
					Iterator<?> iteratorCors = resultCors.iterator();
					while(iteratorCors.hasNext()){
						PgprepStudentCourses myCorsObj = (PgprepStudentCourses)iteratorCors.next();
						
						corsChObj = new StudentCoursePBean();
						corsChObj.setCourseId(myCorsObj.getCourseId());
						corsChObj.setCourseTitle(myCorsObj.getCourseTitle());
						corsChObj.setOrganisationId(myCorsObj.getOrganisationId()); 
						
						studentCourses.add(corsChObj);
					}
					
					beanChObj.setCourses(studentCourses);
					
					children.add(beanChObj);
					
	                i++;
				}	

				responseObj.setList(children);
				
				
				responseObj.setResponseTxt("success");

                logger.info("**************************************************************");
				logger.info("Login Successfully: "+objBean.getUserId());
				logger.info("**************************************************************");
                
			}	

			
			
            entityManager.getTransaction().commit();
			entityManager.close();

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	
	
	
	
}
