package com.bizofficer.parents.web;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


@RestController
@Service
public class ParentsStdReportsController {
	
	private static final Logger logger = Logger.getLogger(ParentsStdReportsController.class);

	@Autowired
	TokenVerifyParentsService objTokenVerifyParentsService;
	
	@Autowired
	private ParentsStdReportsService cclsObj;

	@RequestMapping(value = {"/parents-studentreports"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")ParentsRequestBean objBean, @RequestHeader("token") String token) {
		
		try {
			
			objBean.setToken(token);
			TokenVerifyParentsPojo objTokenVerifyResponse = (TokenVerifyParentsPojo) (Object) objTokenVerifyParentsService.execute(objBean);
			
			if(objTokenVerifyResponse.getResponseTxt().equals("success")) {
				objBean.setParentId(objTokenVerifyResponse.getParentId());
				ParentsResponse responseObj = (ParentsResponse) cclsObj.doExecute(objBean);
				
				logger.info("Service ResponseTxt: "+responseObj.getResponseTxt());
				
				HttpHeaders headers = new HttpHeaders();
		        return ResponseEntity.ok().headers(headers).body(responseObj);
			}
			
			logger.info("Token Verify ResponseTxt: "+objTokenVerifyResponse.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        return ResponseEntity.ok().headers(headers).body(objTokenVerifyResponse);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
