package com.bizofficer.parents.web;



import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepParents;
import com.bizofficer.hibernate.repository.PgprepParentsRepository;



@Service
public class TokenVerifyParentsService{
	
	private static final Logger logger = Logger.getLogger(TokenVerifyParentsService.class);
	
	@Autowired
	PgprepParentsRepository myRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		ParentsRequestBean objBean = (ParentsRequestBean) obj;
		TokenVerifyParentsPojo responseObj = new TokenVerifyParentsPojo();
		
		try {
			
			responseObj.setResponseTxt("failed");

			logger.info("VERIFY TOKEN START **********************************************************");
			logger.info("Token >> " + objBean.getToken() );
			
			if(objBean.getToken()==null) {
				logger.info("No Token Available");
				return responseObj;
			}
			
			PgprepParents myObj = (PgprepParents) myRepo.findByLoginToken(objBean.getToken());
			logger.info("myObj >> " + myObj);
			if(myObj==null) {
				logger.info("Invalid Token");
				responseObj.setResponseTxt("invalidToken");
				return responseObj;
			}

			responseObj.setParentId(myObj.getParentId());
			
			logger.info("Token Verified, Found Parent Auto Id >> " + myObj.getParentId() );

			responseObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
