package com.bizofficer.school.classes;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.school.sclogin.SchoolLoginBean;
import com.bizofficer.school.sclogin.TokenVerifyRespSchoolPojo;
import com.bizofficer.school.sclogin.TokenVerifySchoolService;

@RestController
@Service
public class ClassesController {
	
	private static final Logger logger = Logger.getLogger(ClassesController.class);
	
	@Autowired
	private ClassesService serviceObj;
	
	@Autowired
	private TokenVerifySchoolService objTokenVerifySchoolService;
	
	@RequestMapping(value = {"/classes"}, method = {RequestMethod.GET})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")ClassesBean objBean, @RequestHeader("emailId") String emailId, @RequestHeader("token") String token) {
		
		try {
			
			SchoolLoginBean loginBean = new SchoolLoginBean();
			loginBean.setEmailId(emailId);
			loginBean.setToken(token);
			TokenVerifyRespSchoolPojo objTokenVerifyResponse = (TokenVerifyRespSchoolPojo) (Object) objTokenVerifySchoolService.execute(loginBean);
			
			if(objTokenVerifyResponse.getResponseTxt().equals("success")) {
				objBean.setSchoolId(objTokenVerifyResponse.getSchoolId());
				SchoolClassesResponseBean tsrbObj = (SchoolClassesResponseBean) (Object) serviceObj.execute(objBean);
					
				HttpHeaders headers = new HttpHeaders();
		        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			        
			}
			
			logger.info("Token Verify ResponseTxt: "+objTokenVerifyResponse.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        return ResponseEntity.ok().headers(headers).body(objTokenVerifyResponse);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
