package com.bizofficer.school.sclogin;



import java.util.Iterator;
import java.util.List;
import java.util.UUID;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.entity.PgprepSchools;
import com.bizofficer.hibernate.repository.PgprepSchoolsRepository;
import com.bizofficer.util.system.General;



@Service
public class SchoolLoginService{
	
	private static final Logger logger = Logger.getLogger(SchoolLoginService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolsRepository scRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		SchoolLoginBean objBean = (SchoolLoginBean) obj; 	
		SchoolLoginResponseBean loginResponseBeanObj = new SchoolLoginResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");
			
			if(objBean.getUserId()==null || objBean.getPassword()==null) {
				return loginResponseBeanObj;
			}

			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			General gen = new General();
			
			TypedQuery<PgprepSchoolUsers> queryTeach = (TypedQuery<PgprepSchoolUsers>) entityManager.createQuery("from "+PgprepSchoolUsers.class.getName()+" where emailId=:emailId AND password=:password AND status=1 ", PgprepSchoolUsers.class);
			queryTeach.setParameter("emailId", objBean.getUserId());
			queryTeach.setParameter("password", gen.getMD5Hashing(objBean.getPassword()));
			List<?> resultListTeach = queryTeach.getResultList();
			Iterator<?> iteratorTeach=resultListTeach.iterator();
			if(iteratorTeach.hasNext()){
				PgprepSchoolUsers myObj = (PgprepSchoolUsers)iteratorTeach.next();
			
				loginResponseBeanObj.setEmailId(myObj.getEmailId());
            	loginResponseBeanObj.setFullName(myObj.getFullName());
            	loginResponseBeanObj.setRole(myObj.getRole());
            	loginResponseBeanObj.setSchoolId(myObj.getSchoolId());
            	loginResponseBeanObj.setSchoolName(myObj.getSchoolName());
            	
            	if(myObj.getSchoolId()!=null) {
            		PgprepSchools mySchool = scRepo.findWebsiteIdBySchoolId(myObj.getSchoolId());
    				loginResponseBeanObj.setWebsiteId(mySchool.getWebsiteId());
            	}
            	
                loginResponseBeanObj.setToken(UUID.randomUUID().toString()+UUID.randomUUID().toString());
                
				if(myObj.getId()!=null && myObj.getId()>0) {
					PgprepSchoolUsers ssaveObj = (PgprepSchoolUsers)entityManager.find(PgprepSchoolUsers.class ,myObj.getId());
					ssaveObj.setLoginToken(loginResponseBeanObj.getToken());
					entityManager.getTransaction().commit();
				}
				
				
                loginResponseBeanObj.setResponseTxt("OK");
				logger.info("**************************************************************");
				logger.info("SchoolLoginService successfully Login Id: "+objBean.getUserId());
				logger.info("**************************************************************");
                
			}	

			logger.info("SchoolLoginService UserId: "+objBean.getUserId() );
			
			
            entityManager.getTransaction().commit();
			entityManager.close();

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
