package com.bizofficer.school.sclogin;



import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;



@Service
public class TokenVerifySchoolService{
	
	private static final Logger logger = Logger.getLogger(TokenVerifySchoolService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository userRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		SchoolLoginBean objBean = (SchoolLoginBean) obj;
		TokenVerifyRespSchoolPojo responseObj = new TokenVerifyRespSchoolPojo();
		
		try {
			
			responseObj.setResponseTxt("failed");

			logger.info("VERIFY TOKEN START **********************************************************");
			logger.info("Email >> " + objBean.getEmailId() );
			logger.info("Token >> " + objBean.getToken() );
			
			if(objBean.getToken()==null || objBean.getEmailId()==null) {
				return responseObj;
			}
			
			PgprepSchoolUsers myObj = (PgprepSchoolUsers) userRepo.findByEmailIdAndLoginToken(objBean.getEmailId(), objBean.getToken());
			
			logger.info("PgprepSchoolUsers >> " + myObj);
			
			if(myObj==null) {
				responseObj.setResponseTxt("unauthorized");
				return responseObj;
			}
			
			responseObj.setSchoolId(myObj.getSchoolId());
			responseObj.setSchoolName(myObj.getSchoolName());

			logger.info("Token Verified, Found School User Auto Id >> " + myObj.getId() );

			logger.info("VERIFY TOKEN END **********************************************************");
			
			responseObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
