package com.bizofficer.school.students;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.school.classes.ClassesBean;
import com.bizofficer.school.classes.ClassesService;
import com.bizofficer.school.classes.SchoolClassesResponseBean;
import com.bizofficer.school.sclogin.SchoolLoginBean;
import com.bizofficer.school.sclogin.TokenVerifyRespSchoolPojo;
import com.bizofficer.school.sclogin.TokenVerifySchoolService;

@RestController
@Service
public class SchoolStudentsController {
	
	private static final Logger logger = Logger.getLogger(SchoolStudentsController.class);
	
	@Autowired
	private SchoolStudentsService cclsObj;
	
	@Autowired
	private ClassesService classesServiceObj;
	
	@Autowired
	private TokenVerifySchoolService objTokenVerifySchoolService;

	@RequestMapping(value = {"/schoolstudents"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanStudents objBean, @RequestHeader("emailId") String emailId, @RequestHeader("token") String token) {
		
		try {
			
			SchoolLoginBean loginBean = new SchoolLoginBean();
			loginBean.setEmailId(emailId);
			loginBean.setToken(token);
			TokenVerifyRespSchoolPojo objTokenVerifyResponse = (TokenVerifyRespSchoolPojo) (Object) objTokenVerifySchoolService.execute(loginBean);
			
			if(objTokenVerifyResponse.getResponseTxt().equals("success")) {
				objBean.setSchoolId(objTokenVerifyResponse.getSchoolId());
				SchoolStudentsResponseBean responseObj = (SchoolStudentsResponseBean) (Object) cclsObj.execute(objBean);
				
				logger.info("Service ResponseTxt: "+responseObj.getResponseTxt());
				
				ClassesBean clsBean = new ClassesBean();
				clsBean.setSchoolId(objTokenVerifyResponse.getSchoolId());
				SchoolClassesResponseBean classesObj = (SchoolClassesResponseBean) (Object) classesServiceObj.execute(clsBean);
				if(classesObj.getResponseTxt().equals("success")) {
					responseObj.setClasses(classesObj.getList());
				}
				
				HttpHeaders headers = new HttpHeaders();
		        return ResponseEntity.ok().headers(headers).body(responseObj);
			}
			
			logger.info("Token Verify ResponseTxt: "+objTokenVerifyResponse.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        return ResponseEntity.ok().headers(headers).body(objTokenVerifyResponse);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
