package com.bizofficer.school.teachers;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.school.sclogin.SchoolLoginBean;
import com.bizofficer.school.sclogin.TokenVerifyRespSchoolPojo;
import com.bizofficer.school.sclogin.TokenVerifySchoolService;

@RestController
@Service
public class TeachCreationController {
	
	private static final Logger logger = Logger.getLogger(TeachCreationController.class);
	
	@Autowired
	private TokenVerifySchoolService objTokenVerifySchoolService;
	
	@Autowired
	private TeachCreationService serviceObj;
	
	@RequestMapping(value = {"/newteachercreation"}, method = {RequestMethod.POST})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")TeachBean objBean, @RequestHeader("token") String token, @RequestHeader("emailId") String emailId) {
		
		try {
			
			SchoolLoginBean loginBean = new SchoolLoginBean();
			loginBean.setEmailId(emailId);
			loginBean.setToken(token);
			TokenVerifyRespSchoolPojo objTokenVerifyResponse = (TokenVerifyRespSchoolPojo) (Object) objTokenVerifySchoolService.execute(loginBean);
			
			if(objTokenVerifyResponse.getResponseTxt().equals("success")) {
				objBean.setSchoolId(objTokenVerifyResponse.getSchoolId());
				objBean.setSchoolName(objTokenVerifyResponse.getSchoolName());
				TeacherSchoolResponseBean tsrbObj = (TeacherSchoolResponseBean) (Object) serviceObj.execute(objBean);
					
				logger.info("Service ResponseTxt: "+tsrbObj.getResponseTxt());
				
				HttpHeaders headers = new HttpHeaders();
		        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			        
			}
			
			logger.info("Token Verify ResponseTxt: "+objTokenVerifyResponse.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        return ResponseEntity.ok().headers(headers).body(objTokenVerifyResponse);
			
//			objBean.setToken(token);
//			objBean.setLoginEmailId(loginEmailId);
//			TeacherSchoolResponseBean tsrbObj = (TeacherSchoolResponseBean) (Object) serviceObj.execute(objBean);
//			
//			HttpHeaders headers = new HttpHeaders();
//	        ////headers.add("Responded", "UserController");
//	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
