package com.bizofficer.teacher.classwisereports;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepTestSummary;
import com.bizofficer.pojo.response.ListResponsePojo;
import com.bizofficer.util.system.MakeDate;


@Service
public class ClassWiseReportsService{
	
	private static final Logger logger = Logger.getLogger(ClassWiseReportsService.class);

	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	public Object doExecute(Object obj) throws NotFoundException{
		BeanClassWiseReport objBean = (BeanClassWiseReport) obj; 	
		ListResponsePojo responseObj = new ListResponsePojo();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info( "SchoolId >>> " +  objBean.getSchoolId() );
			logger.info( "ClassName >>> " +  objBean.getClassName() );
			logger.info( "Subject >>> " +  objBean.getSubject() );
			logger.info( "FromDate >>> " +  objBean.getFromDate() );
			logger.info( "ToDate >>> " +  objBean.getToDate() );

			if(objBean.getSchoolId()==null || objBean.getClassName()==null) {
				return responseObj;
			}

			List<ClassWiseReportsResponseBean> dataList = new ArrayList<ClassWiseReportsResponseBean>();
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			MakeDate mkdateObj = new MakeDate();			
			ClassWiseReportsResponseBean serviceObj;
			String whereSql="";
			
			if(objBean.getSubject()!=null && objBean.getSubject().length()>0) {
				whereSql+=" AND subject=:subject ";
			}
			if(objBean.getFromDate()!=null && objBean.getFromDate().length()>0) {
				whereSql+=" AND date(startDate)>=:fromDate ";
			}
			if(objBean.getToDate()!=null && objBean.getToDate().length()>0) {
				whereSql+=" AND date(startDate)<=:toDate ";
			}
			
			TypedQuery<PgprepTestSummary> query = (TypedQuery<PgprepTestSummary>) entityManager.createQuery("from "+PgprepTestSummary.class.getName()+" where schoolId=:schoolId AND className=:className "+whereSql+" group by scheduleId order by id desc ", PgprepTestSummary.class);
			query.setParameter("schoolId", objBean.getSchoolId());
			query.setParameter("className", objBean.getClassName());
			
			if(objBean.getSubject()!=null && objBean.getSubject().length()>0) {
				query.setParameter("subject", objBean.getSubject());
			}
			if(objBean.getFromDate()!=null && objBean.getFromDate().length()>0) {
				query.setParameter("fromDate", mkdateObj.getStringToDate(objBean.getFromDate(), "yyyy-MM-dd") );
			}
			if(objBean.getToDate()!=null && objBean.getToDate().length()>0) {
				query.setParameter("toDate", mkdateObj.getStringToDate(objBean.getToDate(), "yyyy-MM-dd") );
			}
			query.setFirstResult(0);
			query.setMaxResults(500);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();
			int i = 1;
			while(iteratorCat.hasNext()){
				PgprepTestSummary myObj = (PgprepTestSummary)iteratorCat.next();

				serviceObj = new ClassWiseReportsResponseBean();
				serviceObj.setId(i);
				serviceObj.setScheduleId(myObj.getScheduleId());
				serviceObj.setTestTitle(myObj.getTestTitle());
				serviceObj.setClassName(myObj.getClassName());
				serviceObj.setSubject(myObj.getSubject());
				serviceObj.setTestDate(mkdateObj.changeDateTimeFormat(myObj.getStartDate(), "dd-MM-yyyy"));
				
				dataList.add(serviceObj);
				
				i++;	
			}
			
			responseObj.setList(dataList);
			
			entityManager.getTransaction().commit();
			entityManager.close();
			
			responseObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		///logger.info( "dataList >>> " +  dataList );
			
		return responseObj;
	}
	
	

	

	
}
