package com.bizofficer.teacher.courses;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.teacher.login.LoginTeachBean;
import com.bizofficer.teacher.login.TokenVerifyTeacherResponsePojo;
import com.bizofficer.teacher.login.TokenVerifyTeacherService;


@RestController
@Service
public class TeacherCoursesController {
	
	private static final Logger logger = Logger.getLogger(TeacherCoursesController.class);
	
	@Autowired
	private TeacherCoursesService serviceObj;
	
	@Autowired
	private TokenVerifyTeacherService objTokenVerifyTeacherService;
	
	@RequestMapping(value = {"/teacher-courses"}, method = {RequestMethod.GET})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")TeacherCoursesaRequests objBean, @RequestHeader("schoolId") Integer schoolId, @RequestHeader("userId") String userId, @RequestHeader("token") String token) {
		
		try {
			
			LoginTeachBean loginBean = new LoginTeachBean();
			loginBean.setSchoolId(schoolId);
			loginBean.setUserId(userId);
			loginBean.setToken(token);
			TokenVerifyTeacherResponsePojo objTokenVerifyResponse = (TokenVerifyTeacherResponsePojo) (Object) objTokenVerifyTeacherService.execute(loginBean);
			
			if(objTokenVerifyResponse.getResponseTxt().equals("success")) {
				TeacherCourseszResponse tsrbObj = (TeacherCourseszResponse) (Object) serviceObj.execute(objBean);
					
				HttpHeaders headers = new HttpHeaders();
		        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			        
			}
			
			logger.info("Token Verify ResponseTxt: "+objTokenVerifyResponse.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        return ResponseEntity.ok().headers(headers).body(objTokenVerifyResponse);
			
		} catch (Exception e) {
			e.printStackTrace();
			/////return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(e);
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
