package com.bizofficer.teacher.dashtables;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.hibernate.entity.PgprepTestSummary;
import com.bizofficer.util.system.MakeDate;


@Service
public class TestReportsTeachService{
	
	private static final Logger logger = Logger.getLogger(TestReportsTeachService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	private static final DecimalFormat df = new DecimalFormat("0.00");
	
	public Object doExecute(Object obj) throws NotFoundException{
		BeanTestReportsTeach objBean = (BeanTestReportsTeach) obj; 
		ListTestRResponse responseObj = new ListTestRResponse();
		
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info( "schoolId >>> " +  objBean.getSchoolId() );
			logger.info( "subject >>> " +  objBean.getSubject() );
			logger.info( "ClassName >>> " +  objBean.getClassName() );
			logger.info( "FilterDate >>> " +  objBean.getFilterDate() );
			logger.info( "Topic >>> " +  objBean.getTopic() );

			if(objBean.getSchoolId()==null || objBean.getSubject()==null || objBean.getClassName()==null) {
				return responseObj;
			}
			
			String filterDateQry="";
			String filterTopicQry="";
			if(objBean.getFilterDate()!=null) {
				filterDateQry=" AND startDate=:startDate ";
			}
			if(objBean.getTopic()!=null && objBean.getTopic().length()>0) {
				filterTopicQry=" AND testTitle LIKE :testTitle ";
			}
			
			List<TestReportsTeachRespBean> dataList = new ArrayList<TestReportsTeachRespBean>();
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			MakeDate dateObj = new MakeDate();			
			TestReportsTeachRespBean objData;			

			/// SELF TEST **********************************************			
			TypedQuery<PgprepStudentDetails> query = (TypedQuery<PgprepStudentDetails>) entityManager.createQuery("from "+PgprepStudentDetails.class.getName()+" where accountStatus=1 AND schoolId=?1 AND className=?2 order by sname ", PgprepStudentDetails.class); 
			query.setParameter(1, objBean.getSchoolId());
			query.setParameter(2, objBean.getClassName()  );
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();
			while(iteratorCat.hasNext()){
				PgprepStudentDetails myObj = (PgprepStudentDetails)iteratorCat.next();
				
				objData = new TestReportsTeachRespBean();
				objData.setStudentName(myObj.getSname());
				objData.setStudentId(myObj.getStudentId());
				objData.setGivenTest(0);
				TypedQuery<PgprepTestSummary> queryST = (TypedQuery<PgprepTestSummary>) entityManager.createQuery("from "+PgprepTestSummary.class.getName()+" where testStatus=1 AND testType=1 AND studentId=:studentId "+filterDateQry+" "+filterTopicQry+" order by id desc  ", PgprepTestSummary.class); 
				queryST.setParameter("studentId", myObj.getStudentId()); 
				if(objBean.getFilterDate()!=null && objBean.getFilterDate().length()>0 ) {
					queryST.setParameter("startDate", dateObj.getStringToDate(objBean.getFilterDate(), "yyyy-MM-dd"));
				}
				if(objBean.getTopic()!=null && objBean.getTopic().length()>0) {
					queryST.setParameter("testTitle", "%"+objBean.getTopic()+"%");
				}
				queryST.setFirstResult(0);
				queryST.setMaxResults(1);
				List<?> resultListST = queryST.getResultList();
				Iterator<?> iteratorST=resultListST.iterator();
				if(iteratorST.hasNext()){
					PgprepTestSummary myObjST = (PgprepTestSummary)iteratorST.next();
					objData.setGivenTest(1);
					objData.setTestId(myObjST.getTestSession());
					objData.setTestTitle(myObjST.getTestTitle());
					if(myObjST.getStartDate()!=null) {
						objData.setTestDate(dateObj.dateToString(myObjST.getStartDate(), "dd-MM-yyyy"));
					}
					objData.setScore(Double.valueOf(myObjST.getMarksObtain().toString()));
				
					objData.setPercentage(df.format((objData.getScore()*Double.valueOf(myObjST.getFullMarks().toString()))/100));				
				
				}
				dataList.add(objData);
			}	
			responseObj.setSelfTestList(dataList);
			
			/// CLASS TEST **********************************************
			dataList = new ArrayList<TestReportsTeachRespBean>();
			iteratorCat=resultListCat.iterator();
			while(iteratorCat.hasNext()){
				PgprepStudentDetails myObj = (PgprepStudentDetails)iteratorCat.next();
				
				objData = new TestReportsTeachRespBean();
				objData.setStudentName(myObj.getSname());	
				objData.setStudentId(myObj.getStudentId());
				objData.setGivenTest(0);
				TypedQuery<PgprepTestSummary> queryST = (TypedQuery<PgprepTestSummary>) entityManager.createQuery("from "+PgprepTestSummary.class.getName()+" where testStatus=1 AND testType=4 AND studentId=:studentId "+filterDateQry+" "+filterTopicQry+" order by id desc  ", PgprepTestSummary.class); 
				queryST.setParameter("studentId", myObj.getStudentId()); 
				if(objBean.getFilterDate()!=null && objBean.getFilterDate().length()>0 ) {
					queryST.setParameter("startDate", dateObj.getStringToDate(objBean.getFilterDate(), "yyyy-MM-dd"));
				}
				if(objBean.getTopic()!=null && objBean.getTopic().length()>0) {
					queryST.setParameter("testTitle", "%"+objBean.getTopic()+"%");
				}
				queryST.setFirstResult(0);
				queryST.setMaxResults(1);
				List<?> resultListST = queryST.getResultList();
				Iterator<?> iteratorST=resultListST.iterator();
				if(iteratorST.hasNext()){
					PgprepTestSummary myObjST = (PgprepTestSummary)iteratorST.next();
					objData.setGivenTest(1);
					objData.setTestTitle(myObjST.getTestTitle());
					objData.setTestId(myObjST.getTestSession());
					if(myObjST.getStartDate()!=null) {
						objData.setTestDate(dateObj.dateToString(myObjST.getStartDate(), "dd-MM-yyyy"));
					}
					objData.setScore(Double.valueOf(myObjST.getMarksObtain().toString()));
				
					objData.setPercentage(df.format((objData.getScore()*Double.valueOf(myObjST.getFullMarks().toString()))/100));				
				
				}
				dataList.add(objData);
				
			}	
			responseObj.setClassTestList(dataList);
			

			/// TOPIC TEST **********************************************
			dataList = new ArrayList<TestReportsTeachRespBean>();
			iteratorCat=resultListCat.iterator();
			while(iteratorCat.hasNext()){
				PgprepStudentDetails myObj = (PgprepStudentDetails)iteratorCat.next();
				
				objData = new TestReportsTeachRespBean();
				objData.setStudentName(myObj.getSname());			
				objData.setStudentId(myObj.getStudentId());
				objData.setGivenTest(0);
				TypedQuery<PgprepTestSummary> queryST = (TypedQuery<PgprepTestSummary>) entityManager.createQuery("from "+PgprepTestSummary.class.getName()+" where testStatus=1 AND testType=2 AND studentId=:studentId "+filterDateQry+" "+filterTopicQry+" order by id desc  ", PgprepTestSummary.class); 
				queryST.setParameter("studentId", myObj.getStudentId()); 
				if(objBean.getFilterDate()!=null && objBean.getFilterDate().length()>0 ) {
					queryST.setParameter("startDate", dateObj.getStringToDate(objBean.getFilterDate(), "yyyy-MM-dd"));
				}
				if(objBean.getTopic()!=null && objBean.getTopic().length()>0) {
					queryST.setParameter("testTitle", "%"+objBean.getTopic()+"%");
				}
				queryST.setFirstResult(0);
				queryST.setMaxResults(1);
				List<?> resultListST = queryST.getResultList();
				Iterator<?> iteratorST=resultListST.iterator();
				if(iteratorST.hasNext()){
					PgprepTestSummary myObjST = (PgprepTestSummary)iteratorST.next();
					objData.setGivenTest(1);
					objData.setTestTitle(myObjST.getTestTitle());
					objData.setTestId(myObjST.getTestSession());
					if(myObjST.getStartDate()!=null) {
						objData.setTestDate(dateObj.dateToString(myObjST.getStartDate(), "dd-MM-yyyy"));
					}
					objData.setScore(Double.valueOf(myObjST.getMarksObtain().toString()));
				
					objData.setPercentage(df.format((objData.getScore()*Double.valueOf(myObjST.getFullMarks().toString()))/100));				
				
				}
				dataList.add(objData);
				
			}	
			responseObj.setTopicTestList(dataList);
			

			/// MOCK TEST **********************************************
			dataList = new ArrayList<TestReportsTeachRespBean>();
			iteratorCat=resultListCat.iterator();
			while(iteratorCat.hasNext()){
				PgprepStudentDetails myObj = (PgprepStudentDetails)iteratorCat.next();
				
				objData = new TestReportsTeachRespBean();
				objData.setStudentName(myObj.getSname());	
				objData.setStudentId(myObj.getStudentId());
				objData.setGivenTest(0);
				TypedQuery<PgprepTestSummary> queryST = (TypedQuery<PgprepTestSummary>) entityManager.createQuery("from "+PgprepTestSummary.class.getName()+" where testStatus=1 AND testType=3 AND studentId=:studentId "+filterDateQry+" order by id desc  ", PgprepTestSummary.class); 
				queryST.setParameter("studentId", myObj.getStudentId()); 
				if(objBean.getFilterDate()!=null && objBean.getFilterDate().length()>0 ) {
					queryST.setParameter("startDate", dateObj.getStringToDate(objBean.getFilterDate(), "yyyy-MM-dd"));
				}
				queryST.setFirstResult(0);
				queryST.setMaxResults(1);
				List<?> resultListST = queryST.getResultList();
				Iterator<?> iteratorST=resultListST.iterator();
				if(iteratorST.hasNext()){
					PgprepTestSummary myObjST = (PgprepTestSummary)iteratorST.next();
					objData.setGivenTest(1);
					objData.setTestTitle(myObjST.getTestTitle());
					objData.setTestId(myObjST.getTestSession());
					if(myObjST.getStartDate()!=null) {
						objData.setTestDate(dateObj.dateToString(myObjST.getStartDate(), "dd-MM-yyyy"));
					}
					objData.setScore(Double.valueOf(myObjST.getMarksObtain().toString()));
				
					objData.setPercentage(df.format((objData.getScore()*Double.valueOf(myObjST.getFullMarks().toString()))/100));				
				
				}
				dataList.add(objData);
				
			}	
			responseObj.setMockTestList(dataList);

			

			
			
			entityManager.getTransaction().commit();
			entityManager.close();
			
			//responseObj.setList(dataList);
			
			responseObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		///logger.info( "dataList >>> " +  dataList );
			
		return responseObj;
	}
	
	
	
}
