package com.bizofficer.teacher.login;



import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepTeachers;
import com.bizofficer.hibernate.repository.PgprepTeachersRepository;



@Service
public class TokenVerifyTeacherService{
	
	private static final Logger logger = Logger.getLogger(TokenVerifyTeacherService.class);
	
	@Autowired
	PgprepTeachersRepository myRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		LoginTeachBean objBean = (LoginTeachBean) obj;
		TokenVerifyTeacherResponsePojo responseObj = new TokenVerifyTeacherResponsePojo();
		
		try {
			
			responseObj.setResponseTxt("failed");

			logger.info("VERIFY TOKEN START **********************************************************");
			logger.info("SchoolId >> " + objBean.getSchoolId() );
			logger.info("UserId >> " + objBean.getUserId() );
			logger.info("Token >> " + objBean.getToken() );
			
			if(objBean.getToken()==null || objBean.getUserId()==null || objBean.getSchoolId()==null) {
				return responseObj;
			}
			
			PgprepTeachers myObj = (PgprepTeachers) myRepo.getIdBySchoolIdAndLoginIdAndLoginToken(objBean.getSchoolId(), objBean.getUserId(), objBean.getToken());
			logger.info("myObj >> " + myObj);
			if(myObj==null) {
				responseObj.setResponseTxt("invalidToken");
				return responseObj;
			}

			responseObj.setSchoolId(myObj.getSchoolId());
			responseObj.setSchoolName(myObj.getSchoolName());

			responseObj.setTeacherId(myObj.getId());
			responseObj.setLoginId(myObj.getLoginId());
			responseObj.setTeacherName(myObj.getTeacherName());
			
			logger.info("Token Verified, Found Teacher Auto Id >> " + myObj.getId() );

			logger.info("VERIFY TOKEN END **********************************************************");
			
			responseObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
