package com.bizofficer.teacher.resetpassword;



import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.util.module.MysqlTableNames;
import com.bizofficer.util.system.General;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;


@Service
public class ResetPwdTeachService{
	
	private static final Logger logger = Logger.getLogger(ResetPwdTeachService.class);
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
	public Object execute(Object obj) throws NotFoundException{
		ResetPwdTeachBean objBean = (ResetPwdTeachBean) obj; 	
		ResetPwdTeachResponseBean responseBeanObj = new ResetPwdTeachResponseBean();
		
		try {
			responseBeanObj.setResponseTxt("failed");
			
			if(objBean.getNewPassword()==null || objBean.getToken()==null) {
				return responseBeanObj;
			}

			logger.info("ResetPwdService Token: "+objBean.getToken() );
			
	            this.conn = this.appDataSource.getConnection();
	            if (this.conn != null) {
	            	
	            	General gen = new General();
	            	
	                this.ps = this.conn.prepareStatement("SELECT id FROM "+MysqlTableNames.getPgprepTeachers()+" WHERE resetPasswordToken=? ");
	                this.ps.setString(1, objBean.getToken());
	                logger.info("ResetPwdService query: " + this.ps);
	                this.rs = this.ps.executeQuery();
	                if (this.rs.next()) {
	
	                	PreparedStatement psA = conn.prepareStatement("UPDATE "+MysqlTableNames.getPgprepTeachers()+" SET password=?,resetPasswordToken=? WHERE id=?");
	                	psA.setString(1, gen.getMD5Hashing(objBean.getNewPassword()));
	                	psA.setString(2, "");
	                	psA.setInt(3, rs.getInt("id"));
	                	psA.executeUpdate();
	                	
						responseBeanObj.setResponseTxt("OK");
	                    
	    				logger.info("**************************************************************");
	    				logger.info("Successfully ResetPwdService ID: "+rs.getInt(0));
	    				logger.info("**************************************************************");
	                    
	                }else {
	                	responseBeanObj.setResponseTxt("InvalidToken");
	                }
	                
	                this.rs.close();
	                this.ps.close();
	                this.conn.close();
            }

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseBeanObj;
	}
	
	
	
	
}
