package com.bizofficer.teacher.students;



import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.hibernate.repository.PgprepStudentDetailsRepository;


@Service
public class TeacherStudentNewService{
	
	private static final Logger logger = Logger.getLogger(TeacherStudentNewService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepStudentDetailsRepository stRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		BeanReqTeachStudents objBean = (BeanReqTeachStudents) obj;
		TeacherStudentsResponseBean responseObj = new TeacherStudentsResponseBean();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info("studentId >> " + objBean.getStudentId() );
			logger.info("ClassName >> " + objBean.getClassName() );
			
			if(objBean.getStudentId()==null || objBean.getClassName()==null) {
				return responseObj;
			}
			
				logger.info("Assign Batch to LoginId >> " + objBean.getStudentId() );
			
				EntityManager entityManager = entityManagerFactory.createEntityManager();
				entityManager.getTransaction().begin();
				
				
				TypedQuery<PgprepStudentDetails> query = (TypedQuery<PgprepStudentDetails>) entityManager.createQuery("from "+PgprepStudentDetails.class.getName()+" WHERE studentId=:studentId ", PgprepStudentDetails.class);
				query.setParameter("studentId", objBean.getStudentId());
				List<?> resultList = query.getResultList();
				Iterator<?> iterator=resultList.iterator();	
				if(iterator.hasNext()){
					PgprepStudentDetails myObj = (PgprepStudentDetails)iterator.next();		
				
					PgprepStudentDetails saveObj = (PgprepStudentDetails)entityManager.find(PgprepStudentDetails.class ,myObj.getId());
					saveObj.setSchoolId(objBean.getSchoolId());
					saveObj.setSchoolName(objBean.getSchoolName());
					saveObj.setClassName(objBean.getClassName());
					stRepo.save(saveObj);
					
					responseObj.setResponseTxt("success");
					
				}else {
					responseObj.setResponseTxt("InvalidStudentId");
					
				}
				
				entityManager.getTransaction().commit();
				entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseObj;
	}
	

	
	

	
	
}
