package com.bizofficer.teacher.studentswisereports;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.pojo.response.ListResponsePojo;


@Service
public class StudentsService{
	
	private static final Logger logger = Logger.getLogger(StudentsService.class);
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	public Object doExecute(Object obj) throws NotFoundException{
		BeanStudents objBean = (BeanStudents) obj; 	
		ListResponsePojo responseObj = new ListResponsePojo();
		
		try {
			
			responseObj.setResponseTxt("failed");
			
			logger.info( "schoolId >>> " +  objBean.getSchoolId() );
			logger.info( "className >>> " +  objBean.getClassName() );
			logger.info( "subject >>> " +  objBean.getSubject() );
			logger.info( "studentName >>> " +  objBean.getStudentName() );

			List<StudentsResponseBean> dataList = new ArrayList<StudentsResponseBean>();
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			StudentsResponseBean serviceObj;
			
			String whereSql="";
			
			if(objBean.getStudentName()!=null && objBean.getStudentName().length()>0) {
				whereSql+=" AND (sname like :keyword OR admissionNumber like :keyword OR emailId like :keyword OR phoneNo like :keyword OR studentId like :keyword) ";
			}
			
			TypedQuery<PgprepStudentDetails> query = (TypedQuery<PgprepStudentDetails>) entityManager.createQuery("from "+PgprepStudentDetails.class.getName()+" where schoolId=:schoolId AND className=:className "+whereSql+" order by sname ", PgprepStudentDetails.class);
			query.setParameter("schoolId", objBean.getSchoolId());
			query.setParameter("className", objBean.getClassName());
			
			if(objBean.getStudentName()!=null && objBean.getStudentName().length()>0) {
				query.setParameter("keyword", "%"+objBean.getStudentName()+"%" );
			}
			
			query.setFirstResult(0);
			query.setMaxResults(500);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();
			int i = 1;
			while(iteratorCat.hasNext()){
				PgprepStudentDetails myObj = (PgprepStudentDetails)iteratorCat.next();

				serviceObj = new StudentsResponseBean();
				serviceObj.setId(i);
				serviceObj.setStudentId(myObj.getStudentId());
				serviceObj.setStudentName(myObj.getSname());
				serviceObj.setClassName(myObj.getClassName());
				serviceObj.setAdmissionNumber(myObj.getAdmissionNumber());
				
				dataList.add(serviceObj);
				
				i++;	
			}
			entityManager.getTransaction().commit();
			entityManager.close();
			
			responseObj.setList(dataList);
			
			responseObj.setResponseTxt("success");
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		///logger.info( "dataList >>> " +  dataList );
			
		return responseObj;
	}
	
	

	

	
}
