package com.bizofficer.website.courses;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.pojo.response.ListResponsePojo;

@RestController
@Service
public class WebCourseDetailsController {

	private static final Logger logger = Logger.getLogger(WebCourseDetailsController.class);
	
	@Autowired
	private WebCourseDetailsService serviceObj;
	
	@RequestMapping(value = {"/website-course-details"}, method = {RequestMethod.GET})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")AWebCoursesBean objBean) {
		
		try {
			
				ListResponsePojo responseObj = (ListResponsePojo) serviceObj.execute(objBean);
				
				logger.info("Service ResponseTxt: "+responseObj.getResponseTxt());
				HttpHeaders headers = new HttpHeaders();
		        return ResponseEntity.ok().headers(headers).body(responseObj);
			
		} catch (Exception e) {
			e.printStackTrace();
			/////return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(e);
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
