package com.bizofficer.website.signup;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class NewStudentsRegistrationWebController {
	
	private static final Logger logger = Logger.getLogger(NewStudentsRegistrationWebController.class);
	
	@Autowired
	private NewStudentsRegistrationWebService serviceObj;
	
	@RequestMapping(value = {"/website-newstudentregistration"}, method = {RequestMethod.POST})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanWeb objBean) {
		
		try {
			
			logger.info("Name: "+objBean.getStudentName() );
			logger.info("Email: "+objBean.getEmail() );
			logger.info("Phone: "+objBean.getMobile() );
			logger.info("SubscriptionType: "+objBean.getSubscriptionType() );
			logger.info("CourseId: "+objBean.getCourseId());
			logger.info("WebsiteId: "+objBean.getWebsiteId());
			
			RegistrationResponseBean tsrbObj = (RegistrationResponseBean) (Object) serviceObj.execute(objBean);
			
			logger.info("ResponseTxt: "+tsrbObj.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
			/////return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(e);
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
