import React from "react";
import {
  BrowserRouter as Router,
  Switch,
  Route,
  Link
} from "react-router-dom";

import Profile from "./pages/Profile";
///import Orders from "./pages/Orders";
import ForgotPassword from "./pages/ForgotPassword";
import ResetPassword from "./pages/ResetPassword"; 
import Login from "./pages/Login";
import Logout from "./pages/Logout";
import LoginDirectPage from "./pages/LoginDirectPage";
import Dashboard from "./pages/Dashboard";
import StudyMaterials from "./pages/StudyMaterials";
import Report from "./pages/Report";
import Analytics from "./pages/Analytics";
import AnalyticsSelfTest from "./pages/AnalyticsSelfTest";
import SelfAssessor from "./pages/SelfAssessor";
import SelectMockTest from "./pages/SelectMockTest";
import SelectTopicTest from "./pages/SelectTopicTest";
import SelectClassTest from "./pages/SelectClassTest";
import TestSimulator from "./pages/TestSimulator";
import TestViewDetails from "./pages/TestViewDetails";
import SelectCoursePage from "./pages/SelectCoursePage";
import ValidityPage from "./pages/ValidityPage";
import Payments from "./pages/Payments";
import PGResponse from "./pages/PGResponse";
import PGCancelled from "./pages/PGCancelled";
import LiveClass from "./pages/LiveClass";
import Feedback from "./pages/Feedback";

// const getBasename = () => {
//   ///return '/'+process.env.PUBLIC_URL.split('/').pop();
//   ///return "/reacteasetolearn";
//   return "";
// };

function App() {

  return (
    <Router basename={'/student'} >
      <div>
        {/* A <Switch> looks through its children <Route>s and
            renders the first one that matches the current URL. */}
        <Switch> 
          <Route exact path="/testsimulator" component={TestSimulator} />
          <Route exact path="/testview" component={TestViewDetails} />  
          <Route exact path="/selectmocktest" component={SelectMockTest} />
          <Route exact path="/selecttopictest" component={SelectTopicTest} />
          <Route exact path="/selectclasstest" component={SelectClassTest} />          
          <Route exact path="/selfassessor" component={SelfAssessor} />
          <Route exact path="/report" component={Report} />
          <Route exact path="/analytics" component={Analytics} />
          <Route exact path="/testanalytics" component={AnalyticsSelfTest} />    
          <Route exact path="/studymaterials" component={StudyMaterials} />
          <Route exact path="/dashboard" component={Dashboard} />
          <Route exact path="/forgotpassword" component={ForgotPassword} />
          <Route exact path="/resetpassword" component={ResetPassword} />  
          <Route exact path="/payments" component={Payments} />
          <Route exact path="/profile" component={Profile} />  
          <Route exact path="/selectcourse" component={SelectCoursePage} />  
          <Route exact path="/validity" component={ValidityPage} />
          <Route exact path="/pgresponse" component={PGResponse} />
          <Route exact path="/pgcancelled" component={PGCancelled} />
          
          <Route exact path="/feedback" component={Feedback} />
          <Route exact path="/liveclass" component={LiveClass} />
          <Route exact path="/logindirect" component={LoginDirectPage} />
          <Route exact path="/login" component={Login} />
          <Route exact path="/logout" component={Logout} />  
          <Route exact path="/" component={Login} />  
          
          
        </Switch>
      </div>
    </Router>
  );
}

export default App;
