import React from 'react';
import {Box, Container, Grid} from '@material-ui/core';
import axios from 'axios';
import moment from 'moment';
import DialogClassTestDetails from './DialogClassTestDetails';
import DialogTestStart from './DialogTestStart';
import { useSelector } from 'react-redux';
import {API_URL} from '../utils/EnvVars';
import '../styles/bizofficer-a.css';

  
  export default function Execute(props) {
	const mySelectedCourses = useSelector(state => state.mySelectedCourses);
	const selectedCourse = useSelector(state => state.selectedCourse);

	const userObj = useSelector(state => state.userDetails);
	const childRef = React.useRef();
	const childRefStartTest = React.useRef();
	const [testDetail, setTestDetail] = React.useState({});
	const [currentRunningTestTitle, setCurrentRunningTestTitle] = React.useState("");
	const [currentRunningTestSession, setCurrentRunningTestSession] = React.useState("");

	function startMyTest(){
		///alert("aaaa");
		if(selectedCourse>=0 && mySelectedCourses[selectedCourse].organisationId!=null && userObj.studentId!=null){
			axios.get(API_URL+'/testcurrentrunning?organisationId='+mySelectedCourses[selectedCourse].organisationId+'&studentId='+userObj.studentId)
				.then(response => {
					///console.log("Just Checking >> "+response.data);
					if(response.data.responseTxt=="OK"){
						setCurrentRunningTestTitle(response.data.testName);
						setCurrentRunningTestSession(response.data.testSession);
						childRefStartTest.current.handleClickOpen();
					}else{
						window.location.href='testsimulator?classTestId='+testDetail.scheduleId+'&testType=4';
					}			 				
			}).catch((error) => {
				console.log("AXIOS ERROR: ", error);
			})
		}		
	}
	function deleteCurrentStartNew(){		
		if(selectedCourse>=0 && mySelectedCourses[selectedCourse].organisationId!=null && userObj.studentId!=null){
			axios.get(API_URL+'/testrunningdelete?organisationId='+mySelectedCourses[selectedCourse].organisationId+'&studentId='+userObj.studentId)
				.then(response => {
					///console.log("Just Checking >> "+response.data);
					if(response.data.responseTxt=="OK"){
					}else{
					}			 				
			}).catch((error) => {
				console.log("AXIOS ERROR: ", error);
			})		
			window.location.href='testsimulator?classTestId='+testDetail.scheduleId+'&testType=4';
		}
	}	
	function continueCurrentTest(){	
		window.location.href='testsimulator?testSession='+currentRunningTestSession+'&testType=4';
	}

	function showDetails(obj){
		if(obj){
			setTestDetail(obj);
			childRef.current.handleClickOpen();	
		}	
	}
	

	return (
		<div> 
				
				{(props.clasTestList && props.clasTestList!=null)?
				<Box mt={1}>
						<Grid container spacing={1} >
						{props.clasTestList.map((myCT,index)=>(	
							<Grid key={'lt'+index} item md={12} xs={12} onClick={()=>{showDetails(myCT)}} >
								<div className='dasbordlive'>
									<div className='colone'><i className='fa fa-play-circle' /></div>
									<div className='coltwo'>									
										<h3>LIVE: {myCT.testTitle}</h3>
										<p>
											Subject: {myCT.subject}, Time: {moment(myCT.testDateTime).format('DD-MM-YYYY HH:mm')}, Duration: {myCT.totalTime} min
										</p>
									</div>
								</div>
							</Grid>
						))}
						</Grid>
				</Box>
  				:null}	

				<DialogClassTestDetails toCallStartTest={startMyTest} testDetail={testDetail} ref={childRef} />
				<DialogTestStart toCallDeleteCurrentStartNew={deleteCurrentStartNew} toCallContinueCurrentTest={continueCurrentTest} currentRunningTestTitle={currentRunningTestTitle} ref={childRefStartTest}  />							

		</div>	
	);
  }