import * as React from 'react';
import TextField from '@mui/material/TextField';
import Autocomplete from '@mui/material/Autocomplete';
import { createFilterOptions } from '@material-ui/lab/Autocomplete';
import { makeStyles } from "@material-ui/core/styles";

const useStyles = makeStyles({
    paper: {
      fontSize: '12px !important',    
    }
  });

export default function Asynchronous(props) {
  const classes = useStyles();

  function selectedValue(obj){
    if(obj){
        props.toCallParentMethod(props.flag,obj);
    }    
  }

  const filterOptions = createFilterOptions({
    matchFrom: 'start',
    stringify: option => option.title,
  });

  return (
    <>    
    <Autocomplete
									onChange={(event, myObj) => selectedValue(myObj)}
                  sx={{ width: 300 }}
                  classes={{ paper: classes.paper }}
                  disablePortal
									id="combobox"
									popupIcon={""}
                  filterOptions={filterOptions}
                  isOptionEqualToValue={(option, value) => option.title === value.title}
                  getOptionLabel={(option) => option.title}
									options={props.options}                  
									renderInput={(params) => <TextField {...params} label={props.label} fullWidth  />}
		/>	
    </>
  );
}

