import React from 'react';
import clsx from 'clsx';
import { makeStyles } from '@material-ui/core/styles';
import SwipeableDrawer from '@material-ui/core/SwipeableDrawer';
import Button from '@material-ui/core/Button';
import Divider from '@material-ui/core/Divider';
import Collapse from '@mui/material/Collapse';
import List from '@mui/material/List';
import ListItemButton from '@mui/material/ListItemButton';
import ListItem from '@material-ui/core/ListItem';
import ListItemIcon from '@material-ui/core/ListItemIcon';
import ListItemText from '@material-ui/core/ListItemText';
import MenuIcon from '@material-ui/icons/Menu';
import ArrowRightIcon from '@mui/icons-material/ArrowRight';
// import CircularProgress from '@mui/material/CircularProgress';
import ExpandLess from '@mui/icons-material/ExpandLess';
import ExpandMore from '@mui/icons-material/ExpandMore';
import AssessmentIcon from '@material-ui/icons/Assessment';
import LibraryBooksIcon from '@material-ui/icons/LibraryBooks';
import AssignmentIcon from '@material-ui/icons/Assignment';
import DescriptionIcon from '@mui/icons-material/Description';
import LogoutIcon from '@mui/icons-material/Logout';
//import AccountCircleIcon from '@mui/icons-material/AccountCircle';
import PaymentsIcon from '@mui/icons-material/Payments';
import AutoAwesomeIcon from '@mui/icons-material/AutoAwesome';
import LiveTvIcon from '@mui/icons-material/LiveTv';
//import Avatar from '@mui/material/Avatar';
import Stack from '@mui/material/Stack';
import { useDispatch, useSelector } from 'react-redux';
// import axios from 'axios';
// import {API_URL} from '../utils/EnvVars';
import Cookies from 'js-cookie';
import { addUser } from '../store/user.actions';
import { selectCourse } from '../store/course.actions';
import { setMyCourses } from '../store/mycourses.actions';
import { setTopicTree, setTopicList, setKeywordList, setTopicTreeLearning, setTopicListLearning, setKeywordListLearning, setTopicTreeTest, setTopicListTest, setSmartLearning, setMockTest } from '../store/data.actions';

const useStyles = makeStyles({
  list: {
    width: 250,
  },
  fullList: {
    width: 'auto',
  },
});

export default function SwipeableTemporaryDrawer() {
  const dispatch = useDispatch();
  const userObj = useSelector(state => state.userDetails);
  const mySelectedCourses = useSelector(state => state.mySelectedCourses);

  const selectedCourse = useSelector(state => state.selectedCourse);

  // const [loader, setLoader] = React.useState(false);
  // const [newIndex, setNewIndex] = React.useState(0);
  const [openSubList, setOpenSubList] = React.useState(false);
  // const [openCourseList, setOpenCourseList] = React.useState(false);
  const [selectedIndex, setSelectedIndex] = React.useState(0);

  const [openStudyRoom, setOpenStudyRoom] = React.useState(false);

  const [dashboardNav, setDashboardNav] = React.useState(0);
  const [smartLearningNav, setSmartLearningNav] = React.useState(0);
  const [selfTestNav, setSelfTestNav] = React.useState(0);
  const [topicTestNav, setTopicTestNav] = React.useState(0);
  const [mockTestNav, setMockTestNav] = React.useState(0);
  const [classTestNav, setClassTestNav] = React.useState(0);
  const [reportNav, setReportNav] = React.useState(0);
  const [teacherHelpNav, setTeacherHelpNav] = React.useState(0);
  const [organisationList, setOrganisationList] = React.useState([]);

  const classes = useStyles();
  const [state, setState] = React.useState({
    top: false,
    left: false,
    bottom: false,
    right: false,
  });

  function handleClickSubList(){    
    setOpenSubList(!openSubList);
  };

  // function handleClickCourseList(){    
  //   setOpenCourseList(!openCourseList);
  // };

  function handleStudyRoom(){    
    setOpenStudyRoom(!openStudyRoom);
  };
  
  const toggleDrawer = (anchor, open) => (event) => {
    if (event && event.type === 'keydown' && (event.key === 'Tab' || event.key === 'Shift')) {
      return;
    }
    setState({ ...state, [anchor]: open });
  };

  function goToLocation(url){
    window.location=url;
  }

  function logout(){ 
    // dispatch(addUser(null));
    // dispatch(setMyCourses(null));
    // dispatch(selectCourse(null));
    // dispatch(setTopicList(null));
    // dispatch(setKeywordList(null));
    // dispatch(setTopicTree(null));
    // dispatch(setTopicTreeLearning(null));
    // dispatch(setTopicListLearning(null));
    // dispatch(setKeywordListLearning(null));
    // dispatch(setTopicTreeTest(null));
    // dispatch(setTopicListTest(null));
    // dispatch(setSmartLearning(null));
    // dispatch(setMockTest(null));
    
    Cookies.remove('isloggedin');
    window.location.href='logout';
  }

  // function switchCourse(index){
  //   if(selectedIndex!==index){
  //     if(loader===false){    
  //       dispatch(selectCourse(index));
  //       setNewIndex(index);
  //     }
  //     setLoader(true);
      
  //     let axiosHeader = {
	// 			headers: {
	// 				'Content-Type': 'multipart/mixed',
	// 			}
	// 		};
  //     const data = new FormData();
	// 		data.append('id', userObj.sid);
	// 		data.append('openedCourseIndex', index);
	// 		axios.post(API_URL+'/lastopenedcourse', data, axiosHeader)
	// 		.then((response) => { 
  //       if(response.data.responseTxt==="success"){ 
  //           if(mySelectedCourses[index].templateId && mySelectedCourses[index].templateId>0){
  //             getApiDataLastOpenedCourseUpdate(mySelectedCourses[index].templateId);
  //           }
  //       }  
  //     })
  //     .catch((error) => {
  //       console.log("AXIOS ERROR: ", error);
  //     })

  //   }
  // }

//   async function getApiDataLastOpenedCourseUpdate(templateId){
//     axios.get(API_URL+'/templatecache?templateId='+templateId)
//        .then(response => {
//        ///console.log("Just Checking >> "+response.data);  
//       if(response && response.data && response.data.responseTxt==="success"){
// 			    if(response.data.topicList && response.data.topicList.length>0){
//               dispatch(setTopicList(JSON.parse(response.data.topicList)));
//           }else{
//               dispatch(setTopicList([]));
//           }
//           if(response.data.keywordList && response.data.keywordList.length>0){
//               dispatch(setKeywordList(JSON.parse(response.data.keywordList)));
//           }else{
//               dispatch(setKeywordList([]));
//           }
//           if(response.data.topicTree && response.data.topicTree.length>0){
//               dispatch(setTopicTree(JSON.parse(response.data.topicTree)));
//           }else{
//               dispatch(setTopicTree([]));
//           }
//           if(response.data.topicTreeLearning && response.data.topicTreeLearning.length>0){
//               dispatch(setTopicTreeLearning(JSON.parse(response.data.topicTreeLearning)));
//           }else{
//               dispatch(setTopicTreeLearning([]));
//           }
//           if(response.data.topicListLearning && response.data.topicListLearning.length>0){
//               dispatch(setTopicListLearning(JSON.parse(response.data.topicListLearning)));
//           }else{
//               dispatch(setTopicListLearning([]));
//           }
//           if(response.data.keywordListLearning && response.data.keywordListLearning.length>0){
//               dispatch(setKeywordListLearning(JSON.parse(response.data.keywordListLearning)));
//           }else{
//               dispatch(setKeywordListLearning([]));
//           }
//           if(response.data.topicTreeTest && response.data.topicTreeTest.length>0){
//               dispatch(setTopicTreeTest(JSON.parse(response.data.topicTreeTest)));
//           }else{
//               dispatch(setTopicTreeTest([]));
//           }
//           if(response.data.topicListTest && response.data.topicListTest.length>0){
//               dispatch(setTopicListTest(JSON.parse(response.data.topicListTest)));
//           }else{
//               dispatch(setTopicListTest([]));
//           }
//           if(response.data.smartLearningJson && response.data.smartLearningJson.length>0){
//               dispatch(setSmartLearning(JSON.parse(response.data.smartLearningJson)));
//           }else{
//               dispatch(setSmartLearning([]));
//           }
//           if(response.data.mockTestJson && response.data.mockTestJson.length>0){
//               dispatch(setMockTest(JSON.parse(response.data.mockTestJson)));
//           }else{
//               dispatch(setMockTest([]));
//           }
  
//           const mydtmout = setTimeout(
//             function () {
//               setLoader(false);
//               clearTimeout(mydtmout);
//               window.location.href='dashboard';							
//             }
//           , 6000);

//       } 

//     })
//  }


  React.useEffect(() => {
		if(selectedCourse!==null && selectedCourse>=0 && mySelectedCourses!==null && mySelectedCourses[0]!==null){
      setOrganisationList(mySelectedCourses);
      setSelectedIndex(selectedCourse);

      if(mySelectedCourses[selectedCourse].dashboard===1){
        setDashboardNav(1);
      }
      if(mySelectedCourses[selectedCourse].smartLearning===1){
        setSmartLearningNav(1);
      }
      if(mySelectedCourses[selectedCourse].selfTest===1){
        setSelfTestNav(1);
      }
      if(mySelectedCourses[selectedCourse].topicTest===1){
        setTopicTestNav(1);
      }
      if(mySelectedCourses[selectedCourse].mockTest===1){
        setMockTestNav(1);
      }
      if(mySelectedCourses[selectedCourse].classTest===1 && userObj.schools && userObj.schools[0] && userObj.schools[0].schoolId>0){
        setClassTestNav(1);
      }
      if(mySelectedCourses[selectedCourse].report===1){
        setReportNav(1);
      }
      if(mySelectedCourses[selectedCourse].teacherHelp===1){
        setTeacherHelpNav(1);
      }

      
		}
	}, [mySelectedCourses, selectedCourse]); 

  // function validTillDateFormat(val,stype,corseTitle){    
  //   let rtrn = '';
  //   if(val && stype==='PAID'){
  //     let valArr = val.split("-");
  //     let myDate = valArr[2]+'-'+valArr[1]+'-'+valArr[0];
  //     rtrn = 'PRIME, '+myDate;
  //   }else if(stype==='FREE' && corseTitle.indexOf("FREE FOREVER")>-1){
  //     rtrn = 'FREE';  
  //   }else{
  //     rtrn = 'FREE TRIAL';
  //   }
  //   return rtrn;
  // }

  // function upgrade(corseDate,stype,corseTitle){    
  //     let rtrn = 1;
  //     if(stype==='PAID'){
  //       let d1 = new Date();
  //       let d2 = new Date(corseDate);
  //       d2.setDate(d2.getDate() + 1);
  //       if(d1>d2){
  //         rtrn = 2;
  //       }else{
  //         rtrn = 0;
  //       }  
  //     }else if(stype==='FREE' && corseTitle.indexOf("FREE FOREVER")>-1){
  //       rtrn = 0;
  //     }
  //   return rtrn;
  // }

  // function goToCourseBuy(cid){
  //   window.location='selectcourse?cid='+cid;
  // }

  // function expired(corseDate){
  //     let d1 = new Date();
  //     let d2 = new Date(corseDate);
  //     d2.setDate(d2.getDate() + 1);
  //     if(d1>d2){
  //         return 1;
  //     }
  //     return 0;
  // }

  
  const list = (anchor) => (
    <div
      className={clsx(classes.list, {
        [classes.fullList]: anchor === 'top' || anchor === 'bottom',
      })}
      role="presentation"      
      // onClick={toggleDrawer(anchor, false)}
      // onKeyDown={toggleDrawer(anchor, false)}
    >
      <Stack direction="row" spacing={2} style={{margin: 10, justifyContent:'center'}} >
          <img src="./company-logo.png" height={50} />
      </Stack>
      {/* <Stack direction="row" spacing={2} style={{margin: 20}} >
        <Avatar onClick={()=>{goToLocation('profile')}} style={{cursor:'pointer'}} alt={userObj.studentName} src="/static/images/avatar/1.jpg" sx={{ width: 29, height: 29, marginRight:1 }} />
        <span onClick={()=>{goToLocation('profile')}} style={{cursor:'pointer', marginTop: 1, fontSize: 14}} >{userObj.studentName}</span>
      </Stack> */}
      <Divider />

      {/* <ListItemButton onClick={()=>{handleClickCourseList();toggleDrawer('left', true)}} >
        <ListItemIcon>
          <AutoAwesomeIcon />
        </ListItemIcon>
        <ListItemText primary="My Courses" />
        {openCourseList ? <ExpandLess /> : <ExpandMore />}
      </ListItemButton>
      <Collapse in={openCourseList} timeout="auto" unmountOnExit>
        <List component="div" disablePadding>
        {(organisationList && organisationList.length>0)?organisationList.map((myRow,index)=>(          
          (index===selectedIndex)?
          <ListItemButton key={'lib'+index} onClick={()=>{switchCourse(index)}} sx={{pl: 4,backgroundColor:'#c2e4fc',color:'#1f407a'}}>
            <ListItemIcon>{(loader && newIndex===index)?<CircularProgress size={25} />:<ArrowRightIcon />}</ListItemIcon>
            <ListItemText primary={<div onClick={()=>{switchCourse(index)}} className="corstitle" >{myRow.organisationName}</div>} secondary={<div><div>{validTillDateFormat(myRow.validTillDate,myRow.subscriptionType,myRow.organisationName)}</div><div>{(upgrade(myRow.validTillDate,myRow.subscriptionType,myRow.organisationName)>0)?<Button onClick={()=>{goToCourseBuy(myRow.courseId)}} style={{textTransform:'none',height:20,backgroundColor:'#008140',color:'#FFF'}} size='small' variant='contained' >{(upgrade(myRow.validTillDate,myRow.subscriptionType,myRow.organisationName)===2)?<>Renew</>:<>Upgrade</>}</Button>:null}</div></div>}  />
          </ListItemButton>
          :
          <ListItemButton key={'lib'+index} onClick={()=>{switchCourse(index)}} sx={{pl: 4}}>
            <ListItemIcon>{(loader && newIndex===index)?<CircularProgress size={25} />:<ArrowRightIcon />}</ListItemIcon>
            <ListItemText primary={<div onClick={()=>{switchCourse(index)}} className="corstitle" >{myRow.organisationName}</div>} secondary={<div><div>{validTillDateFormat(myRow.validTillDate,myRow.subscriptionType,myRow.organisationName)}</div><div>{(upgrade(myRow.validTillDate,myRow.subscriptionType,myRow.organisationName)>0)?<Button onClick={()=>{goToCourseBuy(myRow.courseId)}} style={{textTransform:'none',height:20,backgroundColor:'#008140',color:'#FFF'}} size='small' variant='contained' >{(upgrade(myRow.validTillDate,myRow.subscriptionType,myRow.organisationName)===2)?<>Renew</>:<>Upgrade</>}</Button>:null}</div></div>} />
          </ListItemButton>
        )):null}
          <ListItemButton onClick={()=>{goToLocation('selectcourse')}} sx={{pl: 4}}>
            <ListItemIcon><ArrowRightIcon /></ListItemIcon>
            <ListItemText primary="All Courses" /> 
          </ListItemButton>
        </List>
      </Collapse> */}

      {dashboardNav===1?
      <ListItem button onClick={()=>{goToLocation('/dashboard')}} >
            <ListItemIcon><AssessmentIcon /></ListItemIcon>
            <ListItemText primary="Dashboard" sx={{ fontSize: 12 }} />
      </ListItem>
      :null}

      {(smartLearningNav===1 || selfTestNav===1 || classTestNav===1)?
      <>
      <ListItemButton onClick={()=>{handleStudyRoom();toggleDrawer('left', true)}} >
        <ListItemIcon>
          <LibraryBooksIcon />
        </ListItemIcon>
        <ListItemText primary="My Study Room" />
        {openStudyRoom ? <ExpandLess /> : <ExpandMore />}
      </ListItemButton>
      <Collapse in={openStudyRoom} timeout="auto" unmountOnExit>
        <List component="div" disablePadding>
        {smartLearningNav===1?  
          <ListItemButton onClick={()=>{goToLocation('studymaterials')}} sx={{pl: 4}}>
            <ListItemIcon><ArrowRightIcon /></ListItemIcon>
            <ListItemText primary="Smart Learning" />
          </ListItemButton>
        :null}  
        {selfTestNav===1?  
          <ListItemButton onClick={()=>{goToLocation('selfassessor')}} sx={{pl: 4}}>
            <ListItemIcon><ArrowRightIcon /></ListItemIcon>
            <ListItemText primary="Self Assessor" />
          </ListItemButton>
        :null}  
        {classTestNav===1?
          <ListItemButton onClick={()=>{goToLocation('selectclasstest')}} sx={{ pl: 4 }}>
            <ListItemIcon><ArrowRightIcon /></ListItemIcon>
            <ListItemText primary="Class Test" />
          </ListItemButton>
        :null}
        </List>
      </Collapse>
      </>:null}    

      {(topicTestNav===1 || mockTestNav===1)?
      <>
      <ListItemButton onClick={()=>{handleClickSubList();toggleDrawer('left', true)}} >
        <ListItemIcon>
          <AssignmentIcon />
        </ListItemIcon>
        <ListItemText primary="My Exam Prep" />
        {openSubList ? <ExpandLess /> : <ExpandMore />}
      </ListItemButton>
      <Collapse in={openSubList} timeout="auto" unmountOnExit>
        <List component="div" disablePadding>        
          {topicTestNav===1?
          <ListItemButton onClick={()=>{goToLocation('selecttopictest')}} sx={{ pl: 4 }}>
            <ListItemIcon><ArrowRightIcon /></ListItemIcon>
            <ListItemText primary="Topic Test" />
          </ListItemButton>
          :null}
          {mockTestNav===1?
          <ListItemButton onClick={()=>{goToLocation('selectmocktest')}} sx={{ pl: 4 }}>
            <ListItemIcon><ArrowRightIcon /></ListItemIcon>
            <ListItemText primary="Exam Test" />
          </ListItemButton>
          :null}
        </List>
      </Collapse>
      </>
      :null}

      {reportNav===1?
      <ListItem button onClick={()=>{goToLocation('report')}} >
            <ListItemIcon><DescriptionIcon /></ListItemIcon>
            <ListItemText primary="Report & Analytics" />
      </ListItem>
      :null} 

      <ListItem button onClick={()=>{goToLocation('payments')}} >
            <ListItemIcon><PaymentsIcon /></ListItemIcon>
            <ListItemText primary="Payments" />
      </ListItem>

      {teacherHelpNav===1?  
      <ListItem button onClick={()=>{goToLocation('liveclass')}} >
            <ListItemIcon><LiveTvIcon /></ListItemIcon>
            <ListItemText primary="My Teacher Help" />
      </ListItem>
      :null}

      <ListItem button onClick={()=>{goToLocation('selectcourse')}} >
            <ListItemIcon><AutoAwesomeIcon /></ListItemIcon>
            <ListItemText primary="All Courses" />
      </ListItem>
       
      <ListItem button onClick={()=>{logout()}} >
            <ListItemIcon><LogoutIcon /></ListItemIcon>
            <ListItemText primary="Logout" />
      </ListItem>
      
    </div>
  );

  return (
    <div>
          <Button style={{color:'#FFFFFF'}} onClick={toggleDrawer('left', true)}><MenuIcon /></Button>
          <SwipeableDrawer
            anchor='left'
            open={state['left']}
            onClose={toggleDrawer('left', false)}
            onOpen={toggleDrawer('left', true)}
          >
            {list('left')}
          </SwipeableDrawer>
    </div>
  );
}
