import React, { useState, useRef, useEffect, useImperativeHandle, forwardRef } from 'react';
//import { Button } from 'reactstrap';
///const { forwardRef, useRef } = React;

//export default function Timer (props, ref) {
	const Timer = forwardRef((props, ref) => {	

	// We need ref in this, because we are dealing
	// with JS setInterval to keep track of it and
	// stop it when needed
	const Ref = useRef(null);

	// The state for our timer
	const [timer, setTimer] = useState('00:00:00');


	const getTimeRemaining = (e) => {
		const total = Date.parse(e) - Date.parse(new Date());
		setRemainingTestTime(Math.floor(total / (1000 * 60)));
		const seconds = Math.floor((total / 1000) % 60);
		const minutes = Math.floor((total / (1000 * 60)) % 60);
		const hours = Math.floor((total / (1000 * 60 * 60)) % 24);
		return {
			total, hours, minutes, seconds
		};
	}

	function setRemainingTestTime(testTime){
		props.toCallParentSetRemainingTime(testTime);
	}
	
	const timeIsFinished = () => {
		props.toCallParentMethod();
	}

	const startTimer = (e) => {
		let { total, hours, minutes, seconds }
					= getTimeRemaining(e);
		if (total >= 0) {
			// update the timer
			// check if less than 10 then we need to
			// add '0' at the begining of the variable
			setTimer(
				(hours > 9 ? hours : '0' + hours) + ':' +
				(minutes > 9 ? minutes : '0' + minutes) + ':'
				+ (seconds > 9 ? seconds : '0' + seconds)
			)
				
		}else{
			timeIsFinished();
            ////alert('Time limit has been finished.');
        }
	}


	const clearTimer = (e) => {

		// If you adjust it you should also need to
		// adjust the Endtime formula we are about
		// to code next	
		///setTimer('00:00:10');

		// If you try to remove this line the
		// updating of timer Variable will be
		// after 1000ms or 1sec
		if (Ref.current) clearInterval(Ref.current);
		const id = setInterval(() => {
			startTimer(e);
		}, 1000)
		Ref.current = id;
	}

	const getDeadTime = () => {
		let dateObj = new Date();
		///alert("endtime >>> " + props.endtime);
		// This is where you need to adjust if
		// you entend to add more time
        dateObj.setMinutes(dateObj.getMinutes()+parseInt(props.endtime));
		return dateObj;
	}

	// We can use useEffect so that when the component
	// mount the timer will start as soon as possible

	// We put empty array to act as componentDid
	// mount only
	useEffect(() => {
		clearTimer(getDeadTime());
	}, []);

	// Another way to call the clearTimer() to start
	// the countdown is via action event from the
	// button first we create function to be called
	// by the button
	//  function resetTimer(){
	//  	clearTimer(getDeadTime());
	//  }

	 useImperativeHandle(ref, () => ({

		resetTimer(){
			clearTimer(getDeadTime());
		}
	
	  }));
{/* <Button onClick={()=>{timeIsFinished()}} >Time Finished</Button> */}
	return ( <>{timer}</> )
});

export default Timer;