import React from 'react';
import { styled } from '@mui/material/styles';
import {Box, Grid} from '@material-ui/core';
import LinearProgress, { linearProgressClasses } from '@mui/material/LinearProgress';
import Tab from '@mui/material/Tab';
import TabContext from '@mui/lab/TabContext';
import TabList from '@mui/lab/TabList';
import TabPanel from '@mui/lab/TabPanel';
import Highcharts, { Point } from 'highcharts';
import HighchartsReact from 'highcharts-react-official';
import Table from '@mui/material/Table';
import TableBody from '@mui/material/TableBody';
import TableCell from '@mui/material/TableCell';
import TableContainer from '@mui/material/TableContainer';
//import TableHead from '@mui/material/TableHead';
import TableRow from '@mui/material/TableRow';
import Paper from '@mui/material/Paper';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import Cookies from 'js-cookie';
import { useSelector } from 'react-redux';
import {API_URL} from '../utils/EnvVars';
import Header from "./HeaderMy";
import '../styles/bizofficer-a.css';

// const chartAbc = {          
// 	series: [70],
// 	options: {
// 	  colors:['#279411'],	
// 	  chart: {
// 		height: 350,
// 		type: 'radialBar',
// 	  },
// 	  plotOptions: {
// 		radialBar: {
// 		  hollow: {
// 			size: '70%',
// 		  }
// 		},
// 	  },
// 	  labels: ['Correct Answer: 7/30'],
// 	},
//   };

const BorderLinearProgress = styled(LinearProgress)(({ theme }) => ({
	height: 10,
	borderRadius: 5,
	[`&.${linearProgressClasses.colorPrimary}`]: {
	  backgroundColor: theme.palette.grey[theme.palette.mode === 'light' ? 200 : 800],
	},
	[`& .${linearProgressClasses.bar}`]: {
	  borderRadius: 5,
	  backgroundColor: theme.palette.mode === 'light' ? '#1a90ff' : '#308fe8',
	},
  }));  
  

  export default function Execute() {
	const userObj = useSelector(state => state.userDetails);
	const isloggedin = Cookies.get('isloggedin');
	const [myData, setMyData] = React.useState([]); 

	const [chartOneData, setChartOneData] = React.useState({credits: false,chart:{type: 'pie',height: 325},title:{text: ''},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartTwoData, setChartTwoData] = React.useState({credits: false,chart: {type: 'column',height: 325},title: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ''},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + '' : this.y + ''}}}},series: [{showInLegend: false,name: '',title:null,data: []}]});
	const [chartThreeData, setChartThreeData] = React.useState({credits: false,chart: {type: 'column',height: 325},title: {text: ''},caption: {text: ''},tooltip: {formatter: function () { var time = this.y; var hours=Math.floor(time/3600); if(hours<10){hours='0'+hours;} var mins=Math.floor(time % 3600 / 60); if(mins<10){mins='0'+mins;} var secs=Math.floor(time % 3600 % 60); if(secs<10){secs='0'+secs;} return this.x+" "+hours+':'+mins+':'+secs; }},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function () { var time = this.y; var hours=Math.floor(time/3600); if(hours<10){hours='0'+hours;} var mins=Math.floor(time % 3600 / 60); if(mins<10){mins='0'+mins;} var secs=Math.floor(time % 3600 % 60); if(secs<10){secs='0'+secs;} return hours+':'+mins+':'+secs; }}}},series: [{showInLegend: false,name: '',title:null, data: []}]});
	const [chartFourData, setChartFourData] = React.useState({credits: false,chart:{type: 'pie',height: 325},title:{text: 'Time'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartFiveData, setChartFiveData] = React.useState({credits: false,chart: {type: 'column',height: 325},title: {text: 'Average Time'},caption: {text: ''},tooltip: {formatter: function () { var time = this.y; var hours=Math.floor(time/3600); if(hours<10){hours='0'+hours;} var mins=Math.floor(time % 3600 / 60); if(mins<10){mins='0'+mins;} var secs=Math.floor(time % 3600 % 60); if(secs<10){secs='0'+secs;} return this.x+" "+hours+':'+mins+':'+secs; }},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function () { var time = this.y; var hours=Math.floor(time/3600); if(hours<10){hours='0'+hours;} var mins=Math.floor(time % 3600 / 60); if(mins<10){mins='0'+mins;} var secs=Math.floor(time % 3600 % 60); if(secs<10){secs='0'+secs;} return hours+':'+mins+':'+secs; }}}},series: [{showInLegend: false,name: '',title:null, data: []}]});
	const [chartSixData, setChartSixData] = React.useState({credits: false,chart:{type: 'pie',height: 325},title:{text: 'Correctly attempted questions wise'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartSevenData, setChartSevenData] = React.useState({credits: false,chart:{type: 'pie',height: 325},title:{text: 'Marks wise'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartEightData, setChartEightData] = React.useState({credits: false,chart:{type: 'pie',height: 300},title:{text: ''},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});


	const authResult = new URLSearchParams(window.location.search); 
	const testId = authResult.get('testId');
	const [value, setValue] = React.useState('1');

	// check if logged in
	React.useEffect(() => {
		if(!isloggedin){
			window.location.href='login';
		}
	}, [isloggedin]);

	const handleChange = (event, newValue) => { //taboneboxid
		if(newValue==1){
		  document.getElementById('taboneboxid').style.display="";
		  document.getElementById('tabtwoboxid').style.display="none";
		  document.getElementById('tabthreeboxid').style.display="none";
		}else if(newValue==2){
		  document.getElementById('taboneboxid').style.display="none";
		  document.getElementById('tabtwoboxid').style.display="";
		  document.getElementById('tabthreeboxid').style.display="none";
		}else if(newValue==3){
		  document.getElementById('taboneboxid').style.display="none";
		  document.getElementById('tabtwoboxid').style.display="none";
		  document.getElementById('tabthreeboxid').style.display="";
		}else if(newValue==4){
		  window.location.href="testview?testId=st"+testId;
		}	
		setValue(newValue);
	  };
  

	React.useEffect(() => {		
		if(userObj.studentId){
			getApiData(userObj.studentId);
		}
	}, [userObj]); 

	async function getApiData(studentId){
		axios.get(API_URL+'/analytics?testSession='+testId+'&studentId='+studentId) 
		   .then(response => {
			
				setMyData(response.data[0]);

				setChartOneData({ series: [{ data: response.data[0].overallPerformanceList }] });
				setChartTwoData({ xAxis: [{ categories: ["Total Marks","Marks Obtained"] }] });
				setChartTwoData({ series: [{ data: [{"y":response.data[0].fullMarks,"color":"#46d39a"},{"y":response.data[0].marksObtain,"color":"#e55759"}] }] });
				setChartThreeData({ xAxis: [{ categories: ["Total Time","Time Spent","Remaining Time"] }] });
				setChartThreeData({ series: [{ data: [{"y":response.data[0].totalTimeSeconds,"color":"#46d39a"},{"y":response.data[0].timeSpent,"color":"#e55759"},{"y":response.data[0].timeRemaining,"color":"#4198d7"}] }] });

				setChartFourData({ series: [{ data: [{"y":response.data[0].timeTakenPercent,"name":"Time Taken","color":"#46d39a"},{"y":response.data[0].timeRemainingPercent,"name":"Time Ramaining","color":"#e55759"}] }] });
				setChartFiveData({ xAxis: [{ categories: ["Available Time","Time taken on attempted questions"] }] });
				setChartFiveData({ series: [{ data: [{"y":response.data[0].totalTimeSeconds,"color":"#46d39a"},{"y":response.data[0].timeSpent,"color":"#e55759"}] }] });

				setChartSixData({ series: [{ data: [{"y":response.data[0].questionWiseKnowledgeUnknown,"name":"Unknown","color":"#e55759"},{"y":response.data[0].questionWiseKnowledgeKnown,"name":"Known to you","color":"#46d39a"}] }] });
				setChartSevenData({ series: [{ data: [{"y":response.data[0].marksWiseKnowledgeUnknown,"name":"Unknown","color":"#e55759"},{"y":response.data[0].marksWiseKnowledgeKnown,"name":"Known to you","color":"#46d39a"}] }] });
				setChartEightData({ series: [{ data: [{"y":response.data[0].percentageCorrectAttemptedQuestions,"name":"Correct Questions","color":"#46d39a"},{"y":response.data[0].percentageIncorrectAttemptedQuestions,"name":"Incorrect Questions","color":"#e55759"}] }] });
				
	   })

	}


	return (
		<div> 
				<MetaTags>
            		<title>Analytics</title>
          		</MetaTags>
				
				<Header />
				{(document.readyState!="complete")?<LinearProgress />:null}
				
				<Box style={{marginBottom:150, marginLeft:20, marginRight:20}}>	

					<Box mt={1}>
							<Grid container spacing={2}>
								<Grid item md={6} sm={12} xs={12}>
									<h3 className="heading" >{myData.testName}</h3>
									<h4 style={{color:'#f50057'}}>Date: {myData.startDate}</h4>
								</Grid>
								<Grid item md={6} sm={12} xs={12}>
									<Grid container spacing={2}>
										<Grid item md={4} xs={4} className='correctmarksbox' >
											{myData.correctMarks}<br/>
											Correct Mark
										</Grid>
										<Grid item md={4} xs={4} className='incorrectmarksbox' >
											{myData.incorrectMarks}<br/>
											Incorrect Mark
										</Grid>
										<Grid item md={4} xs={4} className='notanswermarksbox' >
											{myData.notAnsweredMarks}<br/>
											Not Answer Mark
										</Grid>
									</Grid>
								</Grid>
							</Grid>
					</Box>

					<Box mt={1} className='anylyticbox' >
							<Grid container spacing={2}>

							
								<Grid item md={12} xs={12}>
								{(myData.testType!=null && myData.testType!=1)?
									<h2>Dear {myData.studentName}, You got <i>{myData.rank}</i> rank among <i>{myData.totalStudent}</i> students</h2>
								:<br/>}	
								</Grid>							

								<Grid item md={4} sm={12} xs={12} className='lrpadding' >
									<Grid container spacing={2}>
										<Grid item md={6} sm={6} xs={6} >
											<h3>MARKS SCORED</h3>
										</Grid>
										<Grid item md={6} sm={6} xs={6} className='rightalign' >
											<h3>{myData.marksObtain}/{myData.fullMarks}</h3>
										</Grid>	
									</Grid>
									<BorderLinearProgress variant="determinate" value={myData.percentageMarks} />
									<h3>{myData.percentageMarks}%</h3>
								</Grid>

								<Grid item md={4} sm={12} xs={12} className='lrpadding' >
									<Grid container spacing={2}>
										<Grid item md={6} sm={6} xs={6} >
											<h3>PERCENTILE</h3>
										</Grid>
										<Grid item md={6} sm={6} xs={6} className='rightalign' >
											<h3>{myData.percentile}%</h3>
										</Grid>	
									</Grid>
									<BorderLinearProgress variant="determinate" value={myData.percentile} />
									<h3>{myData.percentile}%</h3>
								</Grid>
								
								<Grid item md={4} sm={12} xs={12} className='lrpadding' >
									<Grid container spacing={2}>
										<Grid item md={8} sm={8} xs={8} >
											<h3>TIME SPENT (Min)</h3>
										</Grid>
										<Grid item md={4} sm={4} xs={4} className='rightalign' >
											<h3>{myData.timeSpentMinutes}/{myData.totalTime}</h3>
										</Grid>	
									</Grid>
									<BorderLinearProgress variant="determinate" value={myData.percentageTime} />
									<h3>{myData.percentageTime}%</h3>
								</Grid>

							</Grid>
					</Box>


					<Box mt={1} sx={{ width: '100%', typography: 'body1' }}>
						<TabContext value={value}>
							<Box sx={{ borderBottom: 1, borderColor: 'divider' }}>
							<TabList onChange={handleChange} centered variant="scrollable" scrollButtons="auto" aria-label="lab API tabs example">
								<Tab label="Overall Performance" value="1" />
								<Tab label="View Details" value="4" />
								<Tab label="Time Management" value="2" />
								<Tab label="Inferences" value="3" />
								
							</TabList>
							</Box>
							<TabPanel value="1"></TabPanel>
							<TabPanel value="2"></TabPanel>
							<TabPanel value="3"></TabPanel>
						</TabContext>
					</Box>



					{/********************  Self Test ****************************/}
					{/********************  Overall Performance ****************************/}
					<Box id="taboneboxid" mt={1}>
						<Grid container spacing={2}>												
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartOneData}
								/>							
							</Grid>
							<Grid item   md={4} xs={12} >
								{<HighchartsReact
									highcharts={Highcharts}
									options={chartTwoData}
								/>}
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartThreeData}
								/>
							</Grid>

						</Grid>

					</Box>

					{/********************  Time Management ****************************/}
					<Box id="tabtwoboxid" style={{display:'none'}} mt={1}>
						<Grid container spacing={2}>												
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartFourData}
								/>								
							</Grid>
							<Grid item   md={4} xs={12} >
								{<HighchartsReact
									highcharts={Highcharts}
									options={chartFiveData}
								/>}
							</Grid>
							<Grid item   md={4} xs={12} >
								<TableContainer component={Paper}>
									<Table aria-label="simple table">
										<TableBody>										
											<TableRow>
												<TableCell >Total time</TableCell>
												<TableCell >{myData.totalTimeLabel}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Time taken</TableCell>
												<TableCell >{myData.spentTimeLabel}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Time remaining</TableCell>
												<TableCell >{myData.remainingTimeLabel}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Avg available time</TableCell>
												<TableCell >{myData.averageTimePerQuestionLabel}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Avg. Speed per Question</TableCell>
												<TableCell >{myData.averageSpeedPerQuestionLabel}</TableCell>
											</TableRow>
										</TableBody>
									</Table>
								</TableContainer>
							</Grid>

						</Grid>
					</Box>

					{/********************  Inferences ****************************/}
					<Box id="tabthreeboxid" style={{display:'none'}} mt={1}>
						<Grid container spacing={2}>		
							<Grid item   md={12} xs={12} >
								<h2 style={{textAlign:'center',textTransform:'uppercase'}} >Overall Knowledge</h2>	
							</Grid>										
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSixData}
								/>	
							</Grid>
							<Grid item   md={4} xs={12} >
								{<HighchartsReact
									highcharts={Highcharts}
									options={chartSevenData}
								/>}
							</Grid>
							<Grid item   md={4} xs={12} >
								<TableContainer component={Paper}>
									<Table aria-label="simple table">
										<TableBody>										
											<TableRow>
												<TableCell >Total Questions</TableCell>
												<TableCell >{myData.totalQuestion}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Question Corrected</TableCell>
												<TableCell >{myData.correctAnswers}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Full Marks</TableCell>
												<TableCell >{myData.fullMarks}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Marks Obtained</TableCell>
												<TableCell >{myData.marksObtain}</TableCell>
											</TableRow>
										</TableBody>
									</Table>
								</TableContainer>
							</Grid>

						</Grid>


						<Grid container spacing={2}>		
							<Grid item   md={12} xs={12} >
								<h2 style={{textAlign:'center',textTransform:'uppercase'}} >Accuracy of Attempted</h2>	
							</Grid>										
							<Grid item   md={6} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartEightData}
								/>	
							</Grid>
							<Grid item   md={6} xs={12} >
								<TableContainer component={Paper}>
									<Table aria-label="simple table">
										<TableBody>										
											<TableRow>
												<TableCell >Attempted Questions</TableCell>
												<TableCell >{myData.attemptedQuestions}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Correct Questions</TableCell>
												<TableCell >{myData.correctAnswers}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Incorrect Questions</TableCell>
												<TableCell >{myData.incorrectAnswers}</TableCell>
											</TableRow>
										</TableBody>
									</Table>
								</TableContainer>
							</Grid>

						</Grid>


					</Box>

				</Box>

		</div>	
	);
  }