import React from 'react';
import { makeStyles } from '@material-ui/core/styles';
import {Box, Container, Grid, Link, Button} from '@material-ui/core';
import Header from "./Header";
import Footer from "./Footer";
import Breadcrumbs from "../components/Breadcrumbs";
import '../styles/bizofficer.css';
import 'font-awesome/css/font-awesome.min.css';
import Moment from 'moment';

const useStyles = makeStyles((theme) => ({
	root: {
		background: 'linear-gradient(45deg, #33ccff 30%, #0000ff 90%)',
		border: 0,
		borderRadius: 22,
		boxShadow: '0 3px 5px 2px rgba(255, 105, 135, .3)',
		color: 'white',
		height: 48,
		padding: '0 30px',
		marginTop: '30px',
	  },
	  sectionDesktop: {
	  display: 'none',
	  [theme.breakpoints.up('md')]: {
		display: 'flex',
	  },
	},
	sectionMobile: {
	  display: 'flex',
	  [theme.breakpoints.up('md')]: {
		display: 'none',
	  },
	},
  }));

  const resultSet = [
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill. convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill. convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill. convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},
	  					{'title':'How to Exercise at Home','image':'health.jpg','date':'2020-10-10','summary':'Who needs a gym membership? You can work out from the comfort and convenience of your home, and you have a lot of options besides hopping on a stationary bike or treadmill.'},

					]

  export default function HomePage() {

	const classes = useStyles();

		return (
			<div>
				<Header />
				<Container>

					<div className="list-box">
						
						{resultSet.map(myRow => ( 
							<Link href="#">
								<Box mt={4} >
									<Grid container spacing={2} >
										<Grid md={2} xs={2} style={{textAlign:'center'}} >
											<img src={process.env.PUBLIC_URL + '/'+myRow.image} alt="image" />
										</Grid>	
										<Grid md={8} xs={10}> 
											<h4>{myRow.title}</h4>
											<p className="text-line-3">{myRow.summary}</p>
											<p>{Moment(myRow.date).format('DD-MMM-YYYY')}</p>
										</Grid>	
										<Grid md={2} className={classes.sectionDesktop} >
											<Button className={classes.root} size="small">View Detail</Button>					
										</Grid>
									</Grid>
								</Box>	
							</Link>
						))}
					</div>




				</Container>
				<Footer />
			</div>
		);
 
}