import React from 'react';
import {Box, Grid } from '@material-ui/core';
import Highcharts from 'highcharts';
import HighchartsReact from 'highcharts-react-official';
import LinearProgress from '@mui/material/LinearProgress';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import Cookies from 'js-cookie';
import ClassTestDashboard from '../components/ClassTestDashboard';
import { useSelector } from 'react-redux';
import {API_URL} from '../utils/EnvVars';
import Header from "./HeaderMy";
import 'font-awesome/css/font-awesome.min.css';
import '../styles/bizofficer-a.css';



  export default function Execute() {	
	const selectedCourse = useSelector(state => state.selectedCourse); 
	const mySelectedCourses = useSelector(state => state.mySelectedCourses);
	const userObj = useSelector(state => state.userDetails); 	
	const isloggedin = Cookies.get('isloggedin');
	const [pageLoader, setPageLoader] = React.useState(true);
	const [redirect, setRedirect] = React.useState(false);
	const [selfTestData, setSelfTestData] = React.useState([]);
	const [topicTestData, setTopicTestData] = React.useState([]);
	const [mockTestData, setMockTestData] = React.useState([]);
	const [classTestData, setClassTestData] = React.useState([]);
	const [clasTestList, setClasTestList] = React.useState([]);

	const [chartSelfAssessorOneData, setChartSelfAssessorOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartSelfAssessorTwoData, setChartSelfAssessorTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{cursor: 'pointer',point: {events: {click: function () {window.location.href = this.options.testDetails; }}},showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartSelfAssessorThreeData, setChartSelfAssessorThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	const [chartTopicTestOneData, setChartTopicTestOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartTopicTestTwoData, setChartTopicTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{cursor: 'pointer',point: {events: {click: function () {window.location.href = this.options.testDetails; }}},showInLegend: false,name: 'Marks',title:null, data: []}]});
	///	const [chartTopicTestTwoData, setChartTopicTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartTopicTestThreeData, setChartTopicTestThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	const [chartMockTestOneData, setChartMockTestOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: ' '},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartMockTestTwoData, setChartMockTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{cursor: 'pointer',point: {events: {click: function () {window.location.href = this.options.testDetails; }}},showInLegend: false,name: 'Marks',title:null, data: []}]});
	///const [chartMockTestTwoData, setChartMockTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartMockTestThreeData, setChartMockTestThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	const [chartClassTestOneData, setChartClassTestOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: ' '},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartClassTestTwoData, setChartClassTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{cursor: 'pointer',point: {events: {click: function () {window.location.href = this.options.testDetails; }}},showInLegend: false,name: 'Marks',title:null, data: []}]});
	///	const [chartClassTestTwoData, setChartClassTestTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartClassTestThreeData, setChartClassTestThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	////console.log("AA studentName >>> "+userObj.studentName);
	// check if logged in
	React.useEffect(() => {
		if(!isloggedin){
			window.location.href='login';
		}
		// else if(redirect){
		// 	////window.location.href='selfassessor';
		// }
	}, [isloggedin]); 

	React.useEffect(() => {
		if(mySelectedCourses && selectedCourse>=0 && mySelectedCourses!=null && mySelectedCourses[selectedCourse].organisationId){
			getApiData(mySelectedCourses[selectedCourse].organisationId,userObj.studentId,userObj.token);	
		}
		if(userObj && userObj!=null && userObj.schools!=null && userObj.schools[0]!=null && userObj.schools[0].schoolId>0){
			getApiDataClassTest(userObj.schools[0].schoolId,userObj.schools[0].className);	
		}
	}, [mySelectedCourses, selectedCourse]); 
	
	async function getApiData(organisationId,studentId,token){
		if(organisationId && studentId && token){
			try {
				let axiosHeader = {
					headers:{
						'Content-Type': 'multipart/mixed',
						'studentId': studentId,
						'token': token,
					}
				};
				axios.get(API_URL+'/dashboard?organisationId='+organisationId+'&studentId='+studentId, axiosHeader) ///dashboard?organisationId=71&studentId=iit_demot
					.then(response => {
						setPageLoader(false);
						///console.log("Data: "+response.data.list);
					if(response && response.data && response.data.responseTxt==="success" && response.data.list && response.data.list.length>0){
								setRedirect(false);						
								if(response.data.list[0] && response.data.list[0]!==null && response.data.list[0].testType!==null && response.data.list[0].testLastReport!==null){
									///console.log("B testType => "+response.data[0].testType);
									setSelfTestData(response.data.list[0]);
									setChartSelfAssessorOneData({ series: [{ data: response.data.list[0].testLastReport }] });
									setChartSelfAssessorOneData({ subtitle: { text: response.data.list[0].testLastTopic } });
									setChartSelfAssessorTwoData({ xAxis: [{ categories: response.data.list[0].testLastTestsX }] });
									setChartSelfAssessorTwoData({ series: [{ data: response.data.list[0].testLastTestsY }] });
									setChartSelfAssessorTwoData({ title: { text: response.data.list[0].lastPerformance } });
									setChartSelfAssessorThreeData({ series: [{ data: response.data.list[0].testAccuracy }] });
									setChartSelfAssessorThreeData({ subtitle: { text: response.data.list[0].testLastTopic } });
								}

								if(response.data.list[1] && response.data.list[1]!==null && response.data.list[1].testType!==null && response.data.list[1].testLastReport!==null){
									///console.log("D testType => "+response.data.list[1].testType);
									setTopicTestData(response.data.list[1]);
									setChartTopicTestOneData({ series: [{ data: response.data.list[1].testLastReport }] });
									setChartTopicTestOneData({ subtitle: { text: response.data.list[1].testLastTopic } });
									setChartTopicTestTwoData({ xAxis: [{ categories: response.data.list[1].testLastTestsX }] });
									setChartTopicTestTwoData({ series: [{ data: response.data.list[1].testLastTestsY }] });
									setChartTopicTestTwoData({ title: { text: response.data.list[1].lastPerformance } });
									setChartTopicTestThreeData({ series: [{ data: response.data.list[1].testAccuracy }] });
									setChartTopicTestThreeData({ subtitle: { text: response.data.list[1].testLastTopic } });
								}

								if(response.data.list[2] && response.data.list[2]!==null && response.data.list[2].testType!==null && response.data.list[2].testLastReport!==null){
									///console.log("F testType => "+response.data.list[2].testType);
									setMockTestData(response.data.list[2]);
									setChartMockTestOneData({ series: [{ data: response.data.list[2].testLastReport }] });
									setChartMockTestOneData({ subtitle: { text: response.data.list[2].testLastTopic } });
									setChartMockTestTwoData({ xAxis: [{ categories: response.data.list[2].testLastTestsX }] });
									setChartMockTestTwoData({ series: [{ data: response.data.list[2].testLastTestsY }] });
									setChartMockTestTwoData({ title: { text: response.data.list[2].lastPerformance } });
									setChartMockTestThreeData({ series: [{ data: response.data.list[2].testAccuracy }] });
									setChartMockTestThreeData({ subtitle: { text: response.data.list[2].testLastTopic } });
								}
								
								if(response.data.list[3] && response.data.list[3]!==null && response.data.list[3].testType!==null && response.data.list[3].testLastReport!==null){
									///console.log("H testType => "+response.data.list[3].testType);
									setClassTestData(response.data.list[3]);
									setChartClassTestOneData({ series: [{ data: response.data.list[3].testLastReport }] });
									setChartClassTestOneData({ subtitle: { text: response.data.list[3].testLastTopic } });
									setChartClassTestTwoData({ xAxis: [{ categories: response.data.list[3].testLastTestsX }] });
									setChartClassTestTwoData({ series: [{ data: response.data.list[3].testLastTestsY }] });
									setChartClassTestTwoData({ title: { text: response.data.list[3].lastPerformance } });
									setChartClassTestThreeData({ series: [{ data: response.data.list[3].testAccuracy }] });
									setChartClassTestThreeData({ subtitle: { text: response.data.list[3].testLastTopic } });
								}

					}else if(response && response.data && response.data.responseTxt==="unauthorized"){
					   Cookies.remove('isloggedin');
					   window.location.href='logout';

					}else{
						setRedirect(true);
						///setMessage("No data available");
					}

				})
			} catch (error) {
				const { response } = error;
				const { request, ...errorObject } = response; // take everything but 'request'
				console.log(errorObject);
			}
		}	
	}

	async function getApiDataClassTest(schoolId,className){
		axios.get(API_URL+'/classtestlist?schoolId='+schoolId+'&className='+className)
			   .then(response => {
			 	if(response && response.data && response.data.length>0){
					setRedirect(false);  
				 	setClasTestList(response.data);
				}				 				
		})
	}
	
		return (
			<div> 
				<MetaTags>
            		<title>Dashboard</title>
          		</MetaTags>				
				<Header />
				{pageLoader?<LinearProgress />:null}
				<Box style={{marginBottom:100, marginLeft:20, marginRight:20}}>		
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12}>
								<h3 className="heading" >Dashboard</h3>
							</Grid>
						</Grid>
				</Box>

				<ClassTestDashboard clasTestList={clasTestList} />

				

			{redirect?
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item md={12} xs={12} style={{textAlign:'center'}}>
								<a href="selfassessor"><img src="/graph-gray.png" /></a><br/>
								<a href="selfassessor" style={{fontSize:14}}>Start to build your dashboard</a>
							</Grid>
						</Grid>
				</Box>	
			:null}				

			{(selfTestData && selfTestData!=null && selfTestData.testType!=null)?
				<>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >{selfTestData.testType}</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>	
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSelfAssessorTwoData}
								/>
							</Grid>											
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSelfAssessorOneData}
								/>								
							</Grid>							
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSelfAssessorThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}	



			{(topicTestData && topicTestData!=null && topicTestData.testType!=null)?
				<>  
				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >{topicTestData.testType}</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartTopicTestTwoData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartTopicTestOneData}
								/>
							</Grid>							
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartTopicTestThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}		


			{(mockTestData && mockTestData!=null && mockTestData.testType!=null)?
				<>  
				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >{mockTestData.testType}</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartMockTestTwoData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartMockTestOneData}
								/>
							</Grid>							
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartMockTestThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}	



			{(classTestData && classTestData!=null && classTestData.testType!=null)?
				<>  
				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >{classTestData.testType}</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartClassTestTwoData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartClassTestOneData}
								/>
							</Grid>							
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartClassTestThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}	


				</Box>
				
				

			</div>
		);
 
}