import React from 'react';
import {Box, Container, Grid} from '@material-ui/core';
import CircularProgress from '@mui/material/CircularProgress';
import axios from 'axios';
import {MetaTags} from 'react-meta-tags';
import {API_URL} from '../utils/EnvVars';
import Cookies from 'js-cookie';
import '../styles/bizofficer-a.css';
import 'font-awesome/css/font-awesome.min.css';
import { useDispatch } from 'react-redux';
import { addUser } from '../store/user.actions';
import { selectCourse } from '../store/course.actions';
import { setMyCourses } from '../store/mycourses.actions';
import { setTopicTree, setTopicList, setKeywordList, setTopicTreeLearning, setTopicListLearning, setKeywordListLearning, setTopicTreeTest, setTopicListTest, setSmartLearning, setMockTest } from '../store/data.actions';

  export default function Execute() {
	//const isloggedin = Cookies.get('isloggedin');
	const dispatch = useDispatch();

	const authResult = new URLSearchParams(window.location.search); 
	const loginKey = authResult.get('loginKey');

	///console.log("loginKey >> " + loginKey);

	// if(isloggedin){
	//  	window.location.href='dashboard';
	// }

	React.useEffect(() => {
		login();	
	}, []); 


	function login(){
		///alert('Login Now');
			let axiosHeader = {
				headers: {
					'Content-Type': 'multipart/mixed',
				}
			};		  
			const data = new FormData();
			data.append('loginKey', loginKey);
			axios.post(API_URL+'/loginmultiorg', data, axiosHeader)
			.then((response) => {
				//console.log("RESPONSE RECEIVED: ", response);
				if(response && response.data && response.data.responseTxt==="OK"){					
					dispatch(addUser(response.data));
					dispatch(setMyCourses(response.data.organisations));
					
					if(response.data.openedCourse!=null && response.data.openedCourse>0){
						dispatch(selectCourse(response.data.openedCourse));
					}else{
						dispatch(selectCourse(0));
					}

					if(response.data.topicList && response.data.topicList.length>0){
						dispatch(setTopicList(JSON.parse(response.data.topicList)));
					}else{
						dispatch(setTopicList([]));
					}
					if(response.data.keywordList && response.data.keywordList.length>0){
						dispatch(setKeywordList(JSON.parse(response.data.keywordList)));
					}else{
						dispatch(setKeywordList([]));
					}
					if(response.data.topicTree && response.data.topicTree.length>0){
						dispatch(setTopicTree(JSON.parse(response.data.topicTree)));
					}else{
						dispatch(setTopicTree([]));
					}
					if(response.data.topicTreeLearning && response.data.topicTreeLearning.length>0){
						dispatch(setTopicTreeLearning(JSON.parse(response.data.topicTreeLearning)));
					}else{
						dispatch(setTopicTreeLearning([]));
					}
					if(response.data.topicListLearning && response.data.topicListLearning.length>0){
						dispatch(setTopicListLearning(JSON.parse(response.data.topicListLearning)));
					}else{
						dispatch(setTopicListLearning([]));
					}
					if(response.data.keywordListLearning && response.data.keywordListLearning.length>0){
						dispatch(setKeywordListLearning(JSON.parse(response.data.keywordListLearning)));
					}else{
						dispatch(setKeywordListLearning([]));
					}
					if(response.data.topicTreeTest && response.data.topicTreeTest.length>0){
						dispatch(setTopicTreeTest(JSON.parse(response.data.topicTreeTest)));
					}else{
						dispatch(setTopicTreeTest([]));
					}
					if(response.data.topicListTest && response.data.topicListTest.length>0){
						dispatch(setTopicListTest(JSON.parse(response.data.topicListTest)));
					}else{
						dispatch(setTopicListTest([]));
					}
					if(response.data.smartLearningJson && response.data.smartLearningJson.length>0){
						dispatch(setSmartLearning(JSON.parse(response.data.smartLearningJson)));
					}else{
						dispatch(setSmartLearning([]));
					}
					if(response.data.mockTestJson && response.data.mockTestJson.length>0){
						dispatch(setMockTest(JSON.parse(response.data.mockTestJson)));
					}else{
						dispatch(setMockTest([]));
					}

					Cookies.set('isloggedin', 1, { expires: new Date(new Date().getTime() + 3600000*24*400) });
					window.location.href="dashboard";
				}else{
					window.location.href="login";
				}
			})
			.catch((error) => {
				console.log("AXIOS ERROR: ", error);
			})
		
	}
	

		return (
			<div> 
				<MetaTags>
            		<title>Login - Smart E-Learning Platform </title>
            		<meta name="description" content="Login" />
          		</MetaTags>
				
				<Container className="loginBGImg" style={{backgroundImage:"url('/student_login_bg.jpg')", backgroundPosition: 'center', height: '100vh', overflow: 'hidden'}}>					

				<Box>
						<Grid container style={{justifyContent: 'center'}} spacing={2}>
							<Grid item className="dhslogin" md={6} xs={12}>

							
								<Grid className="flex-container loginbox">								
									
									<h2 style={{color:'#FFF',marginTop:'16%'}}>
										Please wait...<br/>
										<CircularProgress style={{'color': 'yellow'}} />
									</h2>
								</Grid>
							

							</Grid>
											

						</Grid>
				</Box>




				</Container>
				
			</div>
		);
 
}