import React from 'react';
import { DataGrid } from '@mui/x-data-grid';
import {Box, Grid} from '@material-ui/core';
import {Stack} from '@mui/material';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import Cookies from 'js-cookie';
import {API_URL} from '../utils/EnvVars';
import { useSelector } from 'react-redux';
import Header from "./HeaderMy";
import '../styles/bizofficer-a.css';
///import 'font-awesome/css/font-awesome.min.css';

  
  
const columns = [
	{ field: 'id', headerName: 'No.', type: 'number', width: 40 },
	{ field: 'courseName', headerName: 'Course Name', width: 240 },
	{ field: 'amount', headerName: 'Amount', flex: 1 },
	{ field: 'referenceNumber', headerName: 'Reference Number', flex: 1 },
	{ field: 'createdDateTime', headerName: 'Date', width: 160 }
	/*
	{
	  field: 'age',
	  headerName: 'Age',
	  type: 'number',
	  width: 130,
	},
	{
	  field: 'fullName',
	  headerName: 'Full name',
	  description: 'This column has a value getter and is not sortable.',
	  sortable: false,
	  width: 160,
	  valueGetter: (params) =>
		`${params.getValue(params.id, 'firstName') || ''} ${
		  params.getValue(params.id, 'lastName') || ''
		}`,
	},
	*/
  ];
  
  export default function Execute() {
	const [rows, setRows] = React.useState([]);
	const userObj = useSelector(state => state.userDetails);
	const isloggedin = Cookies.get('isloggedin');

	// check if logged in
	React.useEffect(() => {
		if(!isloggedin){
			window.location.href='login';
		}
	}, [isloggedin]);
	
	React.useEffect(() => {
		if(userObj.studentId){
			getApiData(userObj.studentId, userObj.token);	
		}
	}, [userObj]); // testId currentQuestion (Math.floor(Math.random() * 10) + 1)

	async function getApiData(studentId, token){
			let axiosHeader = {
				headers:{
					'Content-Type': 'multipart/mixed',
					'studentId': studentId,
					'token': token,
				}
			};
			axios.get(API_URL+'/paymenttransactions', axiosHeader)
			   .then(response => {
			 	if(response && response.data && response.data.responseTxt==="success"){  
				 	setRows(response.data.dataList);
				}else if(response && response.data && response.data.responseTxt==="unauthorized"){
					Cookies.remove('isloggedin');
					window.location.href='logout';
 
				}

			})
	}

	// function goToDetail(obj){
	// 	if(obj && rows[obj.id-1]){
	// 		///window.location.href="testsimulator?testId="+rows[obj.id-1].testSessionId;
	// 	}
	// }

	return (
		<div> 
				<MetaTags>
            		<title>Payments</title>
          		</MetaTags>
				
				<Header />
				<Box style={{marginBottom:100, marginLeft:20, marginRight:20}}>	

					<Box mt={1}>
							<Grid container spacing={2}>
								<Grid item md={12} xs={12}>
									<h3 className="heading" >Payments</h3>
									{/* <h4 style={{color:'#f50057'}}>Click on any row for details</h4> */}
								</Grid>
							</Grid>
					</Box>

					<div className="tblReport" style={{height: '200vh', width: '100%' }}>
						<DataGrid
							rows={rows}
							columns={columns}
							pageSize={50}
							rowsPerPageOptions={[50]}		
							style={{fontSize:12}}	
							components={{
								NoRowsOverlay: () => (
								  <Stack style={{marginTop:150}} alignItems="center" justifyContent="center">
									<span style={{color:'#FF0000',fontWeight:'bold'}}>No payment found!</span>
								  </Stack>
								)}}	
						/>

						{/* onRowClick={itm => goToDetail(itm)}			 */}

					</div>

				</Box>

		</div>	
	);
  }