import React from "react";
import {
  BrowserRouter as Router,
  Switch,
  Route
} from "react-router-dom";

import Profile from "./pages/Profile";
///import Orders from "./pages/Orders";
import ForgotPassword from "./pages/ForgotPassword";
import ResetPassword from "./pages/ResetPassword";
import Login from "./pages/Login"; 
import SelectClass from "./pages/SelectClass";
import DashboardTeacher from "./pages/DashboardTeacher";
import DashboardTest from "./pages/DashboardTest";
import ScheduledTest from "./pages/ScheduledTest";
import StudentReport from "./pages/StudentReport";
import Analytics from "./pages/Analytics";
import AnalyticsSelfTest from "./pages/AnalyticsSelfTest";
import SelectClassTest from "./pages/SelectClassTest";
import TestViewClass from "./pages/TestViewClass";
import TestViewDetails from "./pages/TestViewDetails";
import ClassWiseAnalytics from "./pages/ClassWiseAnalytics";
import StudentWiseAnalytics from "./pages/StudentWiseAnalytics";
import LiveClasses from "./pages/LiveClasses";
import ClassesList from "./pages/ClassesList";
import Subjects from "./pages/Subjects";
import StudentsList from "./pages/StudentsList";


const getBasename = () => {
  ///return '/'+process.env.PUBLIC_URL.split('/').pop();
  ///return "/reacteasetolearn";
  return "";
};

function App() {

  return (
    <Router basename={getBasename()} >
      <div>
        {/* A <Switch> looks through its children <Route>s and
            renders the first one that matches the current URL. */}
        <Switch> 
          <Route exact path="/selectclass" component={SelectClass} />
          
          <Route exact path="/classtestview" component={TestViewClass} />
          <Route exact path="/testview" component={TestViewDetails} />  
          <Route exact path="/selectclasstest" component={SelectClassTest} />          
          <Route exact path="/studentreport" component={StudentReport} />
          <Route exact path="/analytics" component={Analytics} />
          <Route exact path="/testanalytics" component={AnalyticsSelfTest} />    
          
          <Route exact path="/dashboard" component={DashboardTeacher} />          
          <Route exact path="/dashboardtest" component={DashboardTest} />
          <Route exact path="/scheduledtest" component={ScheduledTest} />
          <Route exact path="/classwiseanalytics" component={ClassWiseAnalytics} />
          <Route exact path="/studentwiseanalytics" component={StudentWiseAnalytics} />
          <Route exact path="/liveclasses" component={LiveClasses} />
          
          <Route exact path="/classes" component={ClassesList} />
          <Route exact path="/subjects" component={Subjects} />
          <Route exact path="/students" component={StudentsList} />
                     
          <Route exact path="/forgotpassword" component={ForgotPassword} />
          <Route exact path="/resetpassword" component={ResetPassword} />  
          <Route exact path="/profile" component={Profile} />  

          <Route exact path="/login" component={Login} />  
          <Route exact path="/" component={Login} />  
          
          
        </Switch>
      </div>
    </Router>
  );
}

export default App;
