import React from 'react';
///import { DataGrid } from '@mui/x-data-grid';
import { styled } from '@mui/material/styles';
import {Box, Container, Grid, Link} from '@material-ui/core';
import LinearProgress, { linearProgressClasses } from '@mui/material/LinearProgress';
import Tab from '@mui/material/Tab';
import TabContext from '@mui/lab/TabContext';
import TabList from '@mui/lab/TabList';
import TabPanel from '@mui/lab/TabPanel';
import Highcharts from 'highcharts';
import HighchartsReact from 'highcharts-react-official';
import Table from '@mui/material/Table';
import TableBody from '@mui/material/TableBody';
import TableCell from '@mui/material/TableCell';
import TableContainer from '@mui/material/TableContainer';
import TableHead from '@mui/material/TableHead';
import TableRow from '@mui/material/TableRow';
import Paper from '@mui/material/Paper';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import Cookies from 'js-cookie';
import {API_URL} from '../utils/EnvVars';
import Header from "./HeaderMy";
import '../styles/bizofficer-a.css';

const BorderLinearProgress = styled(LinearProgress)(({ theme }) => ({
	height: 10,
	borderRadius: 5,
	[`&.${linearProgressClasses.colorPrimary}`]: {
	  backgroundColor: theme.palette.grey[theme.palette.mode === 'light' ? 200 : 800],
	},
	[`& .${linearProgressClasses.bar}`]: {
	  borderRadius: 5,
	  backgroundColor: theme.palette.mode === 'light' ? '#1a90ff' : '#308fe8',
	},
  }));  
  

  export default function Execute() {
	const isloggedin = Cookies.get('isteachloggedin');
	const [myData, setMyData] = React.useState([]);
	const [backButtonShow, setBackButtonShow] = React.useState(0);
	const [parentTopicsDetails, setParentTopicsDetails] = React.useState([]);
	const [topicsDetails, setTopicsDetails] = React.useState([]);
	const [chartOneData, setChartOneData] = React.useState({credits: false,chart:{type: 'pie',height: 325},title:{text: ''},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y}%'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartTwoData, setChartTwoData] = React.useState({credits: false,chart: {type: 'column',height: 325},title: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' '},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' ' : this.y + ' '}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartThreeData, setChartThreeData] = React.useState({credits: false,chart:{type: 'pie',height: 325},title:{text: 'Time'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y}%'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartFourData, setChartFourData] = React.useState({credits: false,chart: {type: 'column',height: 230},title: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Score',title:null, data: []}]});
	const [chartFiveData, setChartFiveData] = React.useState({credits: false,chart: {type: 'column',height: 325},title: {text: 'Average Time'},caption: {text: ''},tooltip: {formatter: function () { var time = this.y; var hours=Math.floor(time/3600); if(hours<10){hours='0'+hours;} var mins=Math.floor(time % 3600 / 60); if(mins<10){mins='0'+mins;} var secs=Math.floor(time % 3600 % 60); if(secs<10){secs='0'+secs;} return this.x+" "+hours+':'+mins+':'+secs; }},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function () { var time = this.y; var hours=Math.floor(time/3600); if(hours<10){hours='0'+hours;} var mins=Math.floor(time % 3600 / 60); if(mins<10){mins='0'+mins;} var secs=Math.floor(time % 3600 % 60); if(secs<10){secs='0'+secs;} return hours+':'+mins+':'+secs; }}}},series: [{showInLegend: false,name: '',title:null, data: []}]});

	const authResult = new URLSearchParams(window.location.search); 
	const testId = authResult.get('testId');
	const [value, setValue] = React.useState('1');
	
	// check if logged in
	React.useEffect(() => {
		if(!isloggedin){
			window.location.href='login';
		}
	}, [isloggedin]);

	function getParent(){
		if(parentTopicsDetails && parentTopicsDetails.length>1){
			setBackButtonShow(1);
			setTopicsDetails(parentTopicsDetails[parentTopicsDetails.length-1]);
			setParentTopicsDetails(parentTopicsDetails => [parentTopicsDetails.splice(parentTopicsDetails.length-1, 1)]);	
		}else{
			setParentTopicsDetails([]);
			setBackButtonShow(0);
			setTopicsDetails(myData.sectionSet);
		}	
	}
	function getChildren(backObj,nextObj){
		if(nextObj!=null){
			setBackButtonShow(1);
			setParentTopicsDetails(parentTopicsDetails => [...parentTopicsDetails, backObj]);
			setTopicsDetails(nextObj);				
		}
	}	

	const handleChange = (event, newValue) => { //taboneboxid
	  if(newValue==1){
		document.getElementById('taboneboxid').style.display="";
		document.getElementById('tabtwoboxid').style.display="none";
		document.getElementById('tabthreeboxid').style.display="none";
		document.getElementById('tabfourboxid').style.display="none";
	  }else if(newValue==2){
		document.getElementById('taboneboxid').style.display="none";
		document.getElementById('tabtwoboxid').style.display="";
		document.getElementById('tabthreeboxid').style.display="none";
		document.getElementById('tabfourboxid').style.display="none";
	  }else if(newValue==3){
		document.getElementById('taboneboxid').style.display="none";
		document.getElementById('tabtwoboxid').style.display="none";
		document.getElementById('tabthreeboxid').style.display="";
		document.getElementById('tabfourboxid').style.display="none";
	  }else if(newValue==4){
		document.getElementById('taboneboxid').style.display="none";
		document.getElementById('tabtwoboxid').style.display="none";
		document.getElementById('tabthreeboxid').style.display="none";
		document.getElementById('tabfourboxid').style.display="";
	  }else if(newValue==5){
		window.location.href="testview?testId=mt"+testId;
	  }	
	  setValue(newValue);
	};

	React.useEffect(() => {		
		if(testId){
			getApiData(testId);
		}
	}, [testId]); 

	async function getApiData(testId){
		axios.get(API_URL+'/analytics?testSession='+testId)
		   .then(response => {
		   
			if(response!=null && response.data!=null && response.data.length>0){
				setMyData(response.data[0]);	
				setTopicsDetails(response.data[0].sectionSet);

				setChartOneData({ series: [{ data: response.data[0].overallPerformanceList }] });
				setChartTwoData({ xAxis: [{ categories: response.data[0].sectionList }] }); 
				setChartTwoData({ series: response.data[0].sectionPerformanceList }); 
				setChartThreeData({ series: [{ data: [{y: response.data[0].timeTakenPercent, name: "Time Taken", color: "#4198d7"}, {y: response.data[0].timeRemainingPercent, name: "Time Remaining", color: "#e55759" }] }] });
				
				setChartFourData({ xAxis: [{ categories: ['You',response.data[0].topperCompare[0].title,'Avg'] }] }); 
				setChartFourData({ series: [{data: [{"y": response.data[0].percentageMarks, "color": "#574fc5"},{"y": response.data[0].topperCompare[0].scorePercentage,"color": "#29bf28"},{"y": response.data[0].topperCompare[1].scorePercentage,"color": "#f04951"}]}] }); 

				setChartFiveData({ xAxis: [{ categories: ['Available time','Time taken on attempted questions'] }] }); 
				setChartFiveData({ series: [{data: [{"y": response.data[0].totalTimeSeconds, "color": "#574fc5"},{"y": response.data[0].timeSpent,"color": "#29bf28"}]}] }); 
			}

	   })

	}

	return (
		<div> 
				<MetaTags>
            		<title>Analytics</title>
          		</MetaTags>
				
				<Header />
				{(document.readyState!=="complete" || !myData)?<LinearProgress />:null}

			{myData?	
				<Container style={{marginBottom:150}}>	

					<Box mt={1}>
							<Grid container spacing={2}>
								<Grid item md={12} xs={12}>
									<h3 className="heading" >{myData.testName}</h3>
									<h4 style={{color:'#f50057'}}>{myData.startDate?<span>Date:{myData.startDate}</span>:null}</h4>
								</Grid>
							</Grid>
					</Box>

					<Box mt={1} className='anylyticbox' >
							<Grid container spacing={2}>
								<Grid item md={12} xs={12}>
									<h2>Dear {myData.studentName}, You got <i>{myData.rank}</i> rank among <i>{myData.totalStudent}</i> Students</h2>
								</Grid>

								<Grid item md={4} sm={12} xs={12} className='lrpadding' >
									<Grid container spacing={2}>
										<Grid item md={6} sm={6} xs={6} >
											<h3>MARKS SCORED</h3>
										</Grid>
										<Grid item md={6} sm={6} xs={6} className='rightalign' >
											<h3>{myData.marksObtain}/{myData.fullMarks}</h3>
										</Grid>	
									</Grid>
									<BorderLinearProgress variant="determinate" value={myData.percentageMarks} />
									<h3>{myData.percentageMarks}%</h3>
								</Grid>

								<Grid item md={4} sm={12} xs={12} className='lrpadding' >
									<Grid container spacing={2}>
										<Grid item md={6} sm={6} xs={6} >
											<h3>PERCENTILE</h3>
										</Grid>
										<Grid item md={6} sm={6} xs={6} className='rightalign' >
											<h3>{myData.percentile}%</h3>
										</Grid>	
									</Grid>
									<BorderLinearProgress variant="determinate" value={myData.percentile} />
									<h3>{myData.percentile}%</h3>
								</Grid>
								
								<Grid item md={4} sm={12} xs={12} className='lrpadding' >
									<Grid container spacing={2}>
										<Grid item md={8} sm={8} xs={8} >
											<h3>TIME SPENT (Min)</h3>
										</Grid>
										<Grid item md={4} sm={4} xs={4} className='rightalign' >
											<h3>{myData.timeSpentMinutes}/{myData.totalTime}</h3>
										</Grid>	
									</Grid>
									<BorderLinearProgress variant="determinate" value={myData.percentageTime} />
									<h3>{myData.percentageTime}%</h3>
								</Grid>

							</Grid>
					</Box>

					<Box mt={1} sx={{ width: '100%', typography: 'body1' }}>
						<TabContext value={value}>
							<Box sx={{ borderBottom: 1, borderColor: 'divider' }}>
							<TabList onChange={handleChange} centered variant="scrollable" scrollButtons="auto" aria-label="lab API tabs example">
								<Tab label="Overall Performance" value="1" />
								<Tab label="Performance in Detail" value="2" />
								<Tab label="Time Management" value="3" />
								<Tab label="Compare with Topper" value="4" />
								<Tab label="View Details" value="5" />
							</TabList>
							</Box>
							<TabPanel value="1"></TabPanel>
							<TabPanel value="2"></TabPanel>
							<TabPanel value="3"></TabPanel>
							<TabPanel value="4"></TabPanel>
						</TabContext>
					</Box>

					
					{/********************  Overall Performance ****************************/}
					<Box id="taboneboxid" style={{marginTop:-30}} >
						<Grid container spacing={2}>												
									<Grid item md={4} xs={12} >
										<HighchartsReact
											highcharts={Highcharts}
											options={chartOneData}
										/>								
									</Grid>
									<Grid item md={8} xs={12} >
										<HighchartsReact
											highcharts={Highcharts}
											options={chartTwoData}
										/>
									</Grid>
						</Grid>
					</Box>

					{/********************  Performance in Detail ****************************/}
					<Box id="tabtwoboxid" style={{display:'none',marginTop:-30}} >						
						<h4 style={{color:'#1572e8'}}>Drill Down Your Performance</h4>
						<TableContainer component={Paper}>						
						<Table sx={{ minWidth: 650 }} aria-label="simple table">
							<TableHead>
							<TableRow style={{backgroundColor:'#aad7f7'}}>
								<TableCell style={{fontWeight:'bold',width:150}} >
									{backButtonShow?<><Link href="javascript:;" onClick={()=>{getParent()}} style={{color:'#fe3000'}} >Back</Link> Topic Name</>:<>Section Name</>}									
								</TableCell>
								<TableCell style={{fontWeight:'bold'}} align="center">Full Marks</TableCell>
								<TableCell style={{fontWeight:'bold'}} align="center">Marks Obtained</TableCell>
								<TableCell style={{fontWeight:'bold',width:400}} align="center">Percentage</TableCell>
								<TableCell style={{fontWeight:'bold'}} align="center"></TableCell>
							</TableRow>
							</TableHead>
							<TableBody>
							{topicsDetails?topicsDetails.map((myRow,index) => (
								<TableRow	
								key={'tbr'+index}							
								sx={{ '&:last-child td, &:last-child th': { border: 0 } }}
								>
								<TableCell style={{backgroundColor:'#edf6fc'}} >
									{(myRow.children!=null && myRow.children[0]!=null)?<Link href="javascript:;" onClick={()=>{getChildren(topicsDetails, myRow.children)}} >{myRow.sectionName}</Link>:myRow.sectionName}
								</TableCell>
								<TableCell align="center" style={{fontWeight:'bold'}}>{myRow.sectionTotalScore}</TableCell>
								<TableCell align="center" style={{fontWeight:'bold'}}>{myRow.sectionScore} </TableCell>
								<TableCell align="center">
									<table width={'100%'}>
										<tr>
											<td>&nbsp;{myRow.percentage<0?<div style={{fontSize:9,fontWeight:'bold',backgroundColor:'#ff3c4e',padding:6,width:-myRow.percentage+'%',height:15,marginLeft:'auto',marginRight:'55%'}} ></div>:null}</td>
											<td>&nbsp;{myRow.percentage>0?<div style={{fontSize:9,fontWeight:'bold',backgroundColor:'#4be64b',padding:6,width:myRow.percentage+'%',height:15}} ></div>:null}</td>
										</tr>	
									</table>
								</TableCell>
								<TableCell align="center" style={{fontWeight:'bold'}}>{(myRow.percentage!=null && myRow.percentage>0)?<span style={{color:'#0000FF'}}>{myRow.percentage}%</span>:<span style={{color:'#FF0000'}}>{myRow.percentage}%</span>}</TableCell>
								</TableRow>
							)):null} 
							</TableBody>
						</Table>
						</TableContainer>
						<br/>
						<TableContainer component={Paper}>						
						<Table sx={{ minWidth: 650 }} aria-label="simple table">
							<TableHead>
							<TableRow style={{backgroundColor:'#aad7f7'}}>
								<TableCell style={{fontWeight:'bold',width:150}} >
									{backButtonShow?<>Topic Name</>:<>Section Name</>}									
								</TableCell>
								<TableCell style={{fontWeight:'bold'}} align="center">Correct Questions</TableCell>
								<TableCell style={{fontWeight:'bold'}} align="center">Incorrect Questions</TableCell>
								<TableCell style={{fontWeight:'bold'}} align="center">Un-attempted Questions</TableCell>
								<TableCell style={{fontWeight:'bold'}} align="center">Total</TableCell>
								<TableCell style={{fontWeight:'bold',width:400}} align="center">Percentage</TableCell>

							</TableRow>
							</TableHead>
							<TableBody>
							{topicsDetails?topicsDetails.map((myRow,index) => (
								<TableRow	
								key={'tbr'+index}							
								sx={{ '&:last-child td, &:last-child th': { border: 0 } }}
								>
								<TableCell style={{backgroundColor:'#edf6fc'}} >
									{myRow.sectionName}
								</TableCell>
								<TableCell align="center" style={{color:'#12a812',fontWeight:'bold'}} >{myRow.correctQuestions}</TableCell>
								<TableCell align="center" style={{color:'#ff3c4e',fontWeight:'bold'}} >{myRow.incorrectQuestions}</TableCell>
								<TableCell align="center" style={{color:'#9e3ef2',fontWeight:'bold'}} >{myRow.unattemptedQuestions}</TableCell>
								<TableCell align="center" style={{fontWeight:'bold'}}>{myRow.totalQuestion}</TableCell>
								<TableCell align="center">
									<table width={'100%'}>
										<tr>
											<td style={{fontSize:9,fontWeight:'bold',backgroundColor:'#4be64b',padding:6,width:myRow.correctQuestionsPercentage+'%',height:15}}>&nbsp;{myRow.correctQuestionsPercentage}%</td>
											<td style={{fontSize:9,fontWeight:'bold',backgroundColor:'#ff3c4e',padding:6,width:myRow.incorrectQuestionsPercentage+'%',height:15}}>&nbsp;{myRow.incorrectQuestionsPercentage}%</td>
											<td style={{fontSize:9,fontWeight:'bold',backgroundColor:'#c693f2',padding:6,width:myRow.unattemptedQuestionsPercentage+'%',height:15}}>&nbsp;{myRow.unattemptedQuestionsPercentage}%</td>
										</tr>	
									</table>
								</TableCell>

								</TableRow>
							)):null} 
							</TableBody>
						</Table>
						</TableContainer>

					</Box>

					{/********************  Time Management ****************************/}
					<Box id="tabthreeboxid" style={{display:'none',marginTop:-30}} >
						<Grid container spacing={2} style={{justifyContent:'center',marginTop:40}} >
							<Grid item md={4} xs={12}  >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartThreeData}
								/>
							</Grid>
							<Grid item md={4} xs={12}  >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartFiveData}
								/>
							</Grid>
							<Grid item md={4} xs={12}  >
							<TableContainer component={Paper}>
									<Table aria-label="simple table">
										<TableBody>										
											<TableRow>
												<TableCell >Total Time</TableCell>
												<TableCell >{myData.totalTimeLabel}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Time Taken</TableCell>
												<TableCell >{myData.spentTimeLabel}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Remaining Time</TableCell>
												<TableCell >{myData.remainingTimeLabel}</TableCell>
											</TableRow>
											<TableRow>
												<TableCell >Avg. Speed per Question</TableCell>
												<TableCell >{myData.averageSpeedPerQuestionLabel}</TableCell>
											</TableRow>
										</TableBody>
									</Table>
								</TableContainer>
							</Grid>
						</Grid>	
					</Box>

					{/********************  Compare with Topper ****************************/}
					<Box mt={1} id="tabfourboxid" style={{display:'none',marginTop:-30}} >
						<Grid container spacing={2}>												
							<Grid item md={8} sm={12} xs={12} >
								<TableContainer component={Paper}>
								<Table sx={{ minWidth: 650 }} aria-label="simple table">
									<TableHead>
									<TableRow>
										<TableCell className='tblcelltop'></TableCell>
										<TableCell className='tblcelltop' >Score</TableCell>
										<TableCell className='tblcelltop' >Correct Questions</TableCell>
										<TableCell className='tblcelltop' >Incorrect Questions</TableCell>
										<TableCell className='tblcelltop' >Un-attempted Questions</TableCell>
										<TableCell className='tblcelltop' >Time Spent (Minutes)</TableCell>
									</TableRow>
									</TableHead>
									<TableBody>
										<TableRow sx={{ '&:last-child td, &:last-child th': { border: 0 } }} >
											<TableCell className='tblcelltopyou' component="th" scope="row" >You</TableCell>
											<TableCell className='tblcelltopyou' >{myData.marksObtain}/{myData.fullMarks}</TableCell>
											<TableCell className='tblcelltopyou' >{myData.correctAnswers}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopyou' >{myData.incorrectAnswers}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopyou' >{myData.notAnswers}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopyou' >{myData.timeSpentMinutes}</TableCell>
										</TableRow>
										{(myData.topperCompare && myData.topperCompare[0])? 
										<TableRow sx={{ '&:last-child td, &:last-child th': { border: 0 } }} >
											<TableCell className='tblcelltopper' component="th" scope="row" >{myData.topperCompare[0].title}</TableCell>
											<TableCell className='tblcelltopper' >{myData.topperCompare[0].score}/{myData.fullMarks}</TableCell>
											<TableCell className='tblcelltopper' >{myData.topperCompare[0].correctQuestions}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopper' >{myData.topperCompare[0].incorrectQuestions}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopper' >{myData.topperCompare[0].unattemptedQuestions}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopper' >{myData.topperCompare[0].timeSpent}</TableCell>
										</TableRow>
  										:null}
										{(myData.topperCompare && myData.topperCompare[1])?  
										<TableRow sx={{ '&:last-child td, &:last-child th': { border: 0 } }} >
											<TableCell className='tblcelltopavg' component="th" scope="row" >Avg</TableCell>
											<TableCell className='tblcelltopavg' >{myData.topperCompare[1].score}/{myData.fullMarks}</TableCell>
											<TableCell className='tblcelltopavg' >{myData.topperCompare[1].correctQuestions}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopavg' >{myData.topperCompare[1].incorrectQuestions}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopavg' >{myData.topperCompare[1].unattemptedQuestions}/{myData.totalQuestion}</TableCell>
											<TableCell className='tblcelltopavg' >{myData.topperCompare[1].timeSpent}</TableCell>
										</TableRow>
										:null}
									</TableBody>
								</Table>
								</TableContainer>
							</Grid>
							<Grid item md={4} sm={12} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartFourData}
								/>
							</Grid>
						</Grid>
					</Box>


				</Container>
			:null}
		</div>	
	);
  }