import React from 'react';
import {Box, Container, Grid } from '@material-ui/core';
import Highcharts from 'highcharts';
import HighchartsReact from 'highcharts-react-official';
import LinearProgress from '@mui/material/LinearProgress';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import Cookies from 'js-cookie';
import { useSelector } from 'react-redux';
import {API_URL} from '../utils/EnvVars';
import Header from "./HeaderMy";
import '../styles/bizofficer-a.css';



  export default function Execute() {
	const userObj = useSelector(state => state.teacherDetails);	
	const isloggedin = Cookies.get('isteachloggedin');
	const [redirect, setRedirect] = React.useState(false);
	const [selfTestData, setSelfTestData] = React.useState([]);
	const [topicTestData, setTopicTestData] = React.useState([]);
	const [mockTestData, setMockTestData] = React.useState([]);
	const [testTypeOne, setTestTypeOne] = React.useState("");
	const [testTypeTwo, setTestTypeTwo] = React.useState("");
	const [testTypeThree, setTestTypeThree] = React.useState("");
	const [chartOneData, setChartOneData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'My Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartTwoData, setChartTwoData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'My Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartThreeData, setChartThreeData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartFourData, setChartFourData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'My Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartFiveData, setChartFiveData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'My Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartSixData, setChartSixData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: ' %'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartSevenData, setChartSevenData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'My Last Report'},subtitle: {text: 'ATOMIC STRUCTURE'},caption: {text: ''},tooltip: {valueSuffix: ' '},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});
	const [chartEightData, setChartEightData] = React.useState({credits: false,chart: {type: 'column'},title: {text: 'My Last 5 Performance'},caption: {text: ''},tooltip: {valueSuffix: ' %'},xAxis: {categories: [],},yAxis: {title: {text: ''},},plotOptions:{column: {	threshold: 0, dataLabels: {enabled: true,formatter: function() {return this.y < 0 ? -(this.y) + ' %' : this.y + ' %'}}}},series: [{showInLegend: false,name: 'Marks',title:null, data: []}]});
	const [chartNineData, setChartNineData] = React.useState({credits: false,chart:{type: 'pie'},title:{text: 'Accuracy of Attempted Questions'},subtitle: {text: ''},caption: {text: ''},tooltip: {valueSuffix: '%'},plotOptions : {pie: {allowPointSelect: true,cursor: 'pointer',dataLabels: {distance:-30,style: {fontSize: '12px',textOutline: 0},enabled: true,format: '{point.y} %'}}},series: [{showInLegend: true,name: '',data: []}]});

	////console.log("AA studentName >>> "+userObj.studentName);
	// check if logged in
	React.useEffect(() => {
		if(!isloggedin){
			window.location.href='login';
		}else if(redirect){
			window.location.href='selfassessor';
		}
	}, [isloggedin,redirect]); 

	React.useEffect(() => {
		if(userObj && userObj.organisationId){
			getApiData(userObj.organisationId,userObj.studentId);	
		}
	}, [userObj]); 
	
	async function getApiData(organisationId,studentId){
		if(organisationId && studentId){
			try {
				axios.get(API_URL+'/dashboard?organisationId='+organisationId+'&studentId='+studentId) ///dashboard?organisationId=71&studentId=iit_demot
					.then(response => {
						
					if(response && response.data!=null && response.data[0]!=null){	
						if(response.data[0]!=null && response.data[0].testType && response.data[0].testLastReport){
							setTestTypeOne(response.data[0].testType);
							setSelfTestData(response.data[0].testLastReport[0]);
							setChartOneData({ series: [{ data: response.data[0].testLastReport }] });
							setChartOneData({ subtitle: { text: response.data[0].testLastTopic } });
							setChartTwoData({ xAxis: [{ categories: response.data[0].testLastTestsX }] });
							setChartTwoData({ series: [{ data: response.data[0].testLastTestsY }] });
							setChartTwoData({ title: { text: response.data[0].lastPerformance } });
							setChartThreeData({ series: [{ data: response.data[0].testAccuracy }] });
							setChartThreeData({ subtitle: { text: response.data[0].testLastTopic } });
						}

						if(response.data[1]!=null && response.data[1].testType && response.data[1].testLastReport){
							setTestTypeTwo(response.data[1].testType);
							setTopicTestData(response.data[1].testLastReport[0]);
							setChartFourData({ series: [{ data: response.data[1].testLastReport }] });
							setChartFourData({ subtitle: { text: response.data[1].testLastTopic } });
							setChartFiveData({ xAxis: [{ categories: response.data[1].testLastTestsX }] });
							setChartFiveData({ series: [{ data: response.data[1].testLastTestsY }] });
							setChartFiveData({ title: { text: response.data[1].lastPerformance } });
							setChartSixData({ series: [{ data: response.data[1].testAccuracy }] });
							setChartSixData({ subtitle: { text: response.data[1].testLastTopic } });
						}

						if(response.data[2]!=null && response.data[2].testType && response.data[2].testLastReport){
							setTestTypeThree(response.data[2].testType);	
							setMockTestData(response.data[2].testLastReport[0]);
							setChartSevenData({ series: [{ data: response.data[2].testLastReport }] });
							setChartSevenData({ subtitle: { text: response.data[2].testLastTopic } });
							setChartEightData({ xAxis: [{ categories: response.data[2].testLastTestsX }] });
							setChartEightData({ series: [{ data: response.data[2].testLastTestsY }] });
							setChartEightData({ title: { text: response.data[2].lastPerformance } });
							setChartNineData({ series: [{ data: response.data[2].testAccuracy }] });
							setChartNineData({ subtitle: { text: response.data[2].testLastTopic } });
						}

					}else{
						setRedirect(true);
						///setMessage("No data available");
					}

				})
			} catch (error) {
				const { response } = error;
				const { request, ...errorObject } = response; // take everything but 'request'
				console.log(errorObject);
			}
		}	
	}
	
		return (
			<div> 
				<MetaTags>
            		<title>Dashboard</title>
          		</MetaTags>				
				<Header />
				{(document.readyState!="complete")?<LinearProgress />:null}
				<Container style={{marginBottom:100}}>		
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12}>
								<h3 className="heading" >Dashboard</h3>
							</Grid>
						</Grid>
				</Box>				

				{/* {message?
					<Box mt={1}>
					<Grid container spacing={2}>
						<Grid item   md={12} xs={12}>
							<h3 style={{color:'#FF0000' ,textAlign:'center'}} >{message}</h3>
						</Grid>
					</Grid>
					</Box>
				:null} */}

			{(testTypeOne && selfTestData)?
				<>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >{testTypeOne}</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>												
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartOneData}
								/>								
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartTwoData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartThreeData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}	



			{(testTypeTwo && topicTestData)?
				<>  
				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >{testTypeTwo}</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartFourData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartFiveData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSixData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}		


			{(testTypeThree && mockTestData)?
				<>  
				<Box mt={10}>
						<Grid container spacing={2}>
							<Grid item   md={12} xs={12} style={{borderBottom:'1px solid #000'}} >
								<h3 className="heading" style={{textAlign:'center'}} >{testTypeThree}</h3>
							</Grid>
						</Grid>
				</Box>
				<Box mt={1}>
						<Grid container spacing={2}>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartSevenData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartEightData}
								/>
							</Grid>
							<Grid item   md={4} xs={12} >
								<HighchartsReact
									highcharts={Highcharts}
									options={chartNineData}
								/>
							</Grid>

						</Grid>
				</Box>
				</>:null
  			}	



				</Container>
				
				

			</div>
		);
 
}