import React from 'react';
import { makeStyles } from '@material-ui/core/styles';
import {Box, Container, Grid, Link, Button} from '@material-ui/core';
import {MetaTags} from 'react-meta-tags';
//import {LocalHospital, LocationCity, Security, Healing} from '@material-ui/icons';
//import Typography from '@material-ui/core/Typography';
//import Box from '@material-ui/core/Box';
import Header from "./Header";
import TopBanner from "./TopBanner";
import Footer from "./Footer";
import '../styles/bizofficer.css';
import 'font-awesome/css/font-awesome.min.css';

const useStyles = makeStyles((theme) => ({
	root: {
		background: 'linear-gradient(45deg, #33ccff 30%, #0000ff 90%)',
		border: 0,
		borderRadius: 22,
		boxShadow: '0 3px 5px 2px rgba(255, 105, 135, .3)',
		color: 'white',
		height: 48,
		padding: '0 30px',
		marginTop: '30px',
	  },
	  sectionDesktop: {
	  display: 'none',
	  [theme.breakpoints.up('md')]: {
		display: 'flex',
	  },
	},
	sectionMobile: {
	  display: 'flex',
	  [theme.breakpoints.up('md')]: {
		display: 'none',
	  },
	},
  }));


  export default function HomePage() {

	const classes = useStyles();

		return (
			<div> 
				<MetaTags>
            		<title>Medicos: Find doctors near you for your health issue</title>
            		<meta name="description" content="Medicos Some description." />
					<meta name="keywords" content="Doctors Delhi" />
            		<meta property="og:title" content="Medicos MyApp" />
					<meta property="og:description " content="Find doctors near you" />
					<meta property="og:locale" content="en" />
          		</MetaTags>
				
				<Header />
				<Container>					
					<TopBanner />
					<Box mt={4} justifyContent="center">
						<Grid container spacing={2}>
							<Grid item md={2} xs={6}>
								<Link href="search" style={{textDecoration:'none'}}>
									<Box m={1} className='category-box' >
										<i className="fa fa-plus-square"></i>
										<h4>Doctors</h4>
										<h5>Book Appointment</h5>
									</Box>
								</Link>
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search" style={{textDecoration:'none'}}>
									<Box m={1} className='category-box' >
										<i className="fa fa-stethoscope"></i>
										<h4>Diagnostics</h4>
										<h5>Test &amp; Health Checkup</h5>
									</Box>  
								</Link>
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search" style={{textDecoration:'none'}} >
									<Box m={1} className='category-box' >
										<i className="fa fa-hospital-o"></i>
										<h4>Hospitals</h4>
										<h5>Search Top Hospitals</h5>
									</Box> 
								</Link> 
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search" style={{textDecoration:'none'}} >
									<Box m={1} className='category-box' >
										<i className="fa fa-medkit"></i>
										<h4>Pharmacy</h4>
										<h5>Order medicines</h5>
									</Box> 
								</Link> 
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search" style={{textDecoration:'none'}} >
									<Box m={1} className='category-box' >
										<i className="fa fa-shield"></i>
										<h4>Insurance</h4>
										<h5>Protect yourself</h5>
									</Box>  
								</Link>	
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search" style={{textDecoration:'none'}} >
									<Box m={1} className='category-box' >
										<i className="fa fa-headphones"></i>
										<h4>eConsultation</h4>
										<h5>Get tele consult with us</h5>
									</Box>  
								</Link>
							</Grid>
						</Grid>
					</Box>

					

					<Box mt={4} display="flex" justifyContent="center" className="speciality-box" >
						<Grid container spacing={2}>
							<Grid item md={12} xs={12} >
								<Link title="Click to view all" href="search"><h1>Specialities</h1></Link>
								<h3>Consult with top doctors across specialities</h3>
								<Link title="Click to view all" href="search"><h5>Click to view all</h5></Link>
							</Grid>
							<Grid item md={2} xs={6} >
								<Link href="search">
									<p><img src={process.env.PUBLIC_URL + '/Gynaecology.png'}  /></p>
									<p>Gynaecology</p>
								</Link>
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search">
									<p><img src={process.env.PUBLIC_URL + '/Sexology.png'}  /></p>
									<p>Sexology</p>
								</Link>	
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search">
									<p><img src={process.env.PUBLIC_URL + '/General-Physician.png'}  /></p>
									<p>General Physician</p>
								</Link>	
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search">
									<p><img src={process.env.PUBLIC_URL + '/Dermatology.png'}  /></p>
									<p>Dermatology</p>
								</Link>	
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search">
									<p><img src={process.env.PUBLIC_URL + '/Psychiatry.png'}  /></p>
									<p>Psychiatry</p>
								</Link>	
							</Grid>
							<Grid item md={2} xs={6}>
								<Link href="search">
									<p><img src={process.env.PUBLIC_URL + '/Stomach-and-digestion.png'}  /></p>
									<p>Stomach and digestion</p>
								</Link>	
							</Grid>

						</Grid>
					</Box>	

					<div className="health-issue-box">
						<Box mt={4}  >
							<Grid container spacing={2} >
								<Grid item md={12} xs={12} >
									<Link title="Click to view all" href="search"><h1>Common Health Concerns</h1></Link>
									<h3>Consult a doctor online for any health issue</h3>
									<Link title="Click to view all" href="search"><h5>Click to view all</h5></Link>
								</Grid>
								<Grid item md={2} xs={6} >
									<Link href="search">
										<p><img src={process.env.PUBLIC_URL + '/Cough-Cold.jpg'}  /></p>
										<p>Cough &amp; Cold</p>
									</Link>
								</Grid>
								<Grid item md={2} xs={6}>
									<Link href="search">
										<p><img src={process.env.PUBLIC_URL + '/Period-Problem.jpg'}  /></p>
										<p>Period Problem</p>
									</Link>	
								</Grid>
								<Grid item md={2} xs={6}>
									<Link href="search">
										<p><img src={process.env.PUBLIC_URL + '/Performance-issues-bed.jpg'}  /></p>
										<p>Performance issues in bed</p>
									</Link>	
								</Grid>
								<Grid item md={2} xs={6}>
									<Link href="search">
										<p><img src={process.env.PUBLIC_URL + '/Skin-problems.jpg'}  /></p>
										<p>Skin problems</p>
									</Link>	
								</Grid>
								<Grid item md={2} xs={6} className={classes.sectionDesktop} >
									<Link href="search">
										<p><img src={process.env.PUBLIC_URL + '/Depression-anxiety.jpg'}  /></p>
										<p>Depression or anxiety</p>
									</Link>	
								</Grid>

								<Grid item md={2} xs={6} className={classes.sectionDesktop} >
									<Link href="search">
										<p><img src={process.env.PUBLIC_URL + '/Overweight-Obesity.jpg'}  /></p>
										<p>Overweight and Obesity</p>
									</Link>	
								</Grid>

							</Grid>
						</Box>	
					</div>


					<div className="article-box">
						<Box mt={4}  >

							<Grid container spacing={2} >
								<Grid item md={12} xs={12} >
									<Link title="Click to view all" href="articles"><h1>Top Health Articles</h1></Link>
									<h3>Trending tips from doctors &amp; health experts</h3>
									<Link title="Click to view all" href="articles"><h5>Click to view all</h5></Link>
								</Grid>
							</Grid>

							<Grid container spacing={2} >
								<Grid item md={2} xs={6} >
									<div className="article-content-box" >
										<Link href="articles">
											<img src={process.env.PUBLIC_URL + '/covid.jpg'}  />
											<p className="text-line-4">We are together in the fight We are together in the fight against COVID-19. We are together in the fight against COVID-19. We are together in the fight against COVID-19</p>
										</Link>
									</div>	
								</Grid>
								<Grid item md={2} xs={6} >
									<div className="article-content-box" >
										<Link href="articles">
											<p><img src={process.env.PUBLIC_URL + '/covid.jpg'}  /></p>
											<p className="text-line-4">We are together in the fight We are together in the fight against COVID-19. We are together in the fight against COVID-19. We are together in the fight against COVID-19</p>
										</Link>
									</div>	
								</Grid>
								<Grid item md={2} xs={6} >
									<div className="article-content-box" >
										<Link href="articles">
											<p><img src={process.env.PUBLIC_URL + '/covid.jpg'}  /></p>
											<p className="text-line-4">We are together in the fight We are together in the fight against COVID-19. We are together in the fight against COVID-19. We are together in the fight against COVID-19</p>
										</Link>
									</div>	
								</Grid>
								<Grid item md={2} xs={6} >
									<div className="article-content-box" >
										<Link href="articles">
											<p><img src={process.env.PUBLIC_URL + '/covid.jpg'}  /></p>
											<p className="text-line-4">We are together in the fight We are together in the fight against COVID-19. We are together in the fight against COVID-19. We are together in the fight against COVID-19</p>
										</Link>	
									</div>
								</Grid>
								<Grid item md={2} xs={6} className={classes.sectionDesktop} >
									<div className="article-content-box" >
										<Link href="articles">
											<p><img src={process.env.PUBLIC_URL + '/covid.jpg'}  /></p>
											<p className="text-line-4">We are together in the fight We are together in the fight against COVID-19. We are together in the fight against COVID-19. We are together in the fight against COVID-19</p>
										</Link>	
									</div>
								</Grid>

								<Grid item md={2} xs={6} className={classes.sectionDesktop} >
									<div className="article-content-box" >
										<Link href="articles">
											<p><img src={process.env.PUBLIC_URL + '/covid.jpg'}  /></p>
											<p className="text-line-4">We are together in the fight We are together in the fight against COVID-19. We are together in the fight against COVID-19. We are together in the fight against COVID-19</p>
										</Link>	
									</div>
								</Grid>

							</Grid>
						</Box>	
					</div>


					<Box mt={3} className="city-box" >
						<Grid container spacing={4} justifyContent="center" >
							<Grid item md={1} xs={4} >
								<Link href="#">
									<p><img src={process.env.PUBLIC_URL + '/Ahmedabad.png'}  /></p>
									<p>Ahmedabad</p>
								</Link>	
							</Grid>
							<Grid item md={1} xs={4}>
								<Link href="#">	
									<p><img src={process.env.PUBLIC_URL + '/Bangalore.png'}  /></p>
									<p>Bangalore</p>
								</Link>	
							</Grid>
							<Grid item md={1} xs={4}>
								<Link href="#">	
									<p><img src={process.env.PUBLIC_URL + '/Chennai.png'}  /></p>
									<p>Chennai</p>
								</Link>	
							</Grid>
							<Grid item md={1} xs={4}>
								<Link href="#">	
									<p><img src={process.env.PUBLIC_URL + '/Gurgaon.png'}  /></p>
									<p>Gurgaon</p>
								</Link>	
							</Grid>
							<Grid item md={1} xs={4}>
								<Link href="#">	
									<p><img src={process.env.PUBLIC_URL + '/Kolkata.png'}  /></p>
									<p>Kolkata</p>
								</Link>	
							</Grid>
							<Grid item md={1} xs={4}>
								<Link href="#">	
									<p><img src={process.env.PUBLIC_URL + '/Mumbai.png'}  /></p>
									<p>Mumbai</p>
								</Link>	
							</Grid>
							<Grid item md={1} xs={4}>
								<Link href="#">
									<p><img src={process.env.PUBLIC_URL + '/New-Delhi.png'}  /></p>
									<p>New Delhi</p>
								</Link>	
							</Grid>
							<Grid item md={1} xs={4}>
								<Link href="#">
									<p><img src={process.env.PUBLIC_URL + '/Noida.png'}  /></p>
									<p>Noida</p>
								</Link>
							</Grid>
							<Grid item md={1} xs={4}>
								<Link href="#">	
									<p><img src={process.env.PUBLIC_URL + '/Hyderabad.png'}  /></p>
									<p>Hyderabad</p>
								</Link>	
							</Grid>

						</Grid>
					</Box>	


		<Box display="flex" className="app-form-box" justifyContent="center" mt={5} p={2} >
			<Box className={classes.sectionDesktop}>
				<img src={process.env.PUBLIC_URL + '/couple-using-laptop.jpg'}  />
			</Box>
			<Box p={2} >
				<h3>Download the app</h3>
				<h5>Access video consultation with India's top doctors on the app. Connect with doctors.</h5>
				<p>
					<span style={{marginRight:'20px'}}>
						<Button className={classes.root} size="large"><i className="fa fa-play"></i> &nbsp; Google Play</Button>
					</span>
					<span>
						<Button className={classes.root} size="large"><i className="fa fa-apple"></i> &nbsp; App Store</Button>					
					</span>
				</p>

			</Box>
		</Box>


				</Container>
				<Footer />
			</div>
		);
 
}