import React,{useRef} from 'react';
///import { makeStyles } from '@material-ui/core/styles';
import {Box, Container, Grid, Button} from '@material-ui/core';
import Alert from '@mui/material/Alert';
import Stack from '@mui/material/Stack';
import Snackbar from '@mui/material/Snackbar';
import {MetaTags} from 'react-meta-tags';
import axios from 'axios';
import Cookies from 'js-cookie';
import LinearProgress from '@mui/material/LinearProgress';
import { useSelector } from 'react-redux';
import { MathComponent } from 'mathjax-react';
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import '../styles/bizofficer.css';
import {API_URL} from '../utils/EnvVars';
import 'font-awesome/css/font-awesome.min.css';

  ///sectionLock = No_Lock,Partially_Lock,Complete_Lock

  export default function Execute() { 
	const resetTimerRef = useRef();
	const userObj = useSelector(state => state.teacherDetails);
	const isloggedin = Cookies.get('isteachloggedin');
	const [testSet, setTestSet] = React.useState([]); 
	const [currentQuestion, setCurrentQuestion] = React.useState(0);
	const [agreeToJumpQuestion, setAgreeToJumpQuestion] = React.useState(0);
	const [currentSection, setCurrentSection] = React.useState(1);
	const [totalQuestion, setTotalQuestion] = React.useState(0);
	const [showAlert, setShowAlert] = React.useState(false);
	const [alertMessage, setAlertMessage] = React.useState("");
	const [sectionDialogShow, setSectionDialogShow] = React.useState(false);
	const [seconds, setSeconds] = React.useState(0);
	const alphaArr = ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'];
	
	const authResult = new URLSearchParams(window.location.search); 
	const testId = authResult.get('testId');
	const testType = authResult.get('testType');
	const questionType = authResult.get('questionType');
	const totalTestQuestions = authResult.get('totalQuestion');
	const totalTime = authResult.get('totalTime');
	const marksCorrectAnswer = authResult.get('marksCorrectAnswer');
	const marksIncorrectAnswer = authResult.get('marksIncorrectAnswer');
	const marksNotAttempted = authResult.get('marksNotAttempted');
	const searchFlag = authResult.get('searchFlag');
	const searchQuery = authResult.get('searchQuery');
	const topicId = authResult.get('topicId');
	const testSession = authResult.get('testSession');
	
	///console.log("testId >>> " + testId);
	var counterMRMT = 0, counterMCMT=0;
	var vertical='top',horizontal='center';
	///element.classList.contains(className); 

	// check if logged in
	React.useEffect(() => {
		if(!isloggedin){
			window.location.href='login';
		}
	}, [isloggedin]);

	
	function uncheckHandle(chkId){
		if(document.getElementById("hidetxt"+chkId).value===1){
			document.getElementById(chkId).checked=false;
			document.getElementById("hidetxt"+chkId).value="";
		}else if(document.getElementById(chkId).checked===true){
			let totalOptions = Object.keys(testSet[0].questionSet[currentQuestion].responseChoice).length;
			let questionId = testSet[0].questionSet[currentQuestion].questionId;
			for(let i=0; i<totalOptions; i++ ){
				document.getElementById("hidetxtans"+questionId+"a"+i).value="";
			}
			document.getElementById("hidetxt"+chkId).value=1;
		} 
	}
	function backHandle(){
		currentQuestion===0?jumpToQuestion(0):jumpToQuestion(currentQuestion-1);
		if(currentQuestion===0){
			setShowAlert(true);
			setAlertMessage("You are at first question, Click on Next button.");			
			return false;
		}
	}
	function nextHandle(){
		currentQuestion===(totalQuestion-1)?jumpToQuestion(currentQuestion):jumpToQuestion(currentQuestion+1);
		if(totalQuestion===(currentQuestion+1)){
			setShowAlert(true);
			setAlertMessage("You are at last question.");			
			return false;
		}
	}
	function changeTimeInClock(num){
		setTimeout(function() { //Start the timer
			resetTimerRef.current.resetTimer(1); //After 1 second, set render to true
		}.bind(this), 1000)
	}	
	function changeCurrentQuestion(num){
		// UPDATE SPENT TIME ON A QUESTION
		testSet[0].questionSet[currentQuestion].timeSpent=parseInt(testSet[0].questionSet[currentQuestion].timeSpent)+seconds+5;
		document.getElementById('questionBox'+currentQuestion).style.display="none";
		document.getElementById('questionBox'+num).style.display="";
		setCurrentSection(testSet[0].questionSet[num].sectionOrder);
		setCurrentQuestion(num);
		testSet[0].lastQuestionIndex=num;
		setSeconds(0); //RESET TIME FOR CURRENT QUESTION
	}
	function jumpToQuestion(num){
		if(num!==currentQuestion){
			if(checkSection(num)){
				changeCurrentQuestion(num);
			}	
		}
	}
	function checkSection(num){
		let sectionLock = testSet[0].sectionLock;
		if(sectionLock==="Complete_Lock"){
			let jumpToSection = testSet[0].questionSet[num].sectionOrder;
			if(jumpToSection!==currentSection){
				setShowAlert(true);
				setAlertMessage("You are not allowed to move another section.");
				return false;
			}
		}else if(sectionLock==="Partially_Lock"){
			let jumpToSection = testSet[0].questionSet[num].sectionOrder;
			if(jumpToSection>currentSection){
				setAgreeToJumpQuestion(num);
				setSectionDialogShow(true);
				return false;
			}else if(jumpToSection<currentSection){
				setShowAlert(true);
				setAlertMessage("You are not allowed to move previous section.");			
				return false;
			}else{
				changeTimeInClock(num);
			}
		}
		return true;
	}

	// function timeFinished(){
	// 	if(testSet && testSet[0] && testSet[0].sectionLock){
	// 		let sectionLock = testSet[0].sectionLock;
	// 		if(testSet[0].sectionSet && testSet[0].sectionSet[currentSection] && (sectionLock=="Complete_Lock" || sectionLock=="Partially_Lock")){
	// 			let num = testSet[0].sectionSet[currentSection].questionNumbers[0].questionIndex;
	// 			changeCurrentQuestion(num);
	// 			changeTimeInClock(num);
	// 		}else{
	// 			///We have to move another page after submitted test			
	// 			///alert("Your test time has been finished.\nyour test has been submitted automatically.");
	// 		}
	// 	}
	// }

	function agreeToJumpSection(){
		sectionDialogHide();
		changeCurrentQuestion(agreeToJumpQuestion);
		changeTimeInClock(agreeToJumpQuestion);
	}

	React.useEffect(() => {		
		if(userObj.emailId){
			getApiData(userObj.emailId);
		}
	}, [userObj]); 

	async function getApiData(organisationId,studentId){

		let params = '';
		if(testId!==null && testId>0){
			params='?testId='+testId;
		}else{
			params='?testId=0';
		}
		if(testType!==null){
			params+='&testType='+testType;
		}
		if(questionType!==null){
			params+='&questionType='+questionType;
		}
		if(totalTestQuestions!==null){
			params+='&totalQuestion='+totalTestQuestions;
		}
		if(totalTime!==null){
			params+='&totalTime='+totalTime;
		}
		if(marksCorrectAnswer!==null){
			params+='&marksCorrectAnswer='+marksCorrectAnswer;
		}
		if(marksIncorrectAnswer!==null){
			params+='&marksIncorrectAnswer='+marksIncorrectAnswer;
		}
		if(marksNotAttempted!==null){
			params+='&marksNotAttempted='+marksNotAttempted;
		}
		if(searchFlag!==null){
			params+='&searchFlag='+searchFlag;
		}
		if(searchQuery!==null){
			params+='&searchQuery='+searchQuery;
		}
		if(topicId!==null){
			params+='&topicId='+topicId;
		}
		let urlApiTestDetails='teacher-testdetails'+params;
		// if(testSession && organisationId && studentId){
		// 	urlApiTestDetails='testdetailexisting?testSession='+testSession+'&organisationId='+organisationId+'&studentId='+studentId;
		// }


		axios.get(API_URL+'/'+urlApiTestDetails)
			   .then(response => {
			 	///console.log("Just Checking >> "+response.data);  
			    setTestSet(response.data.list);
				 const apiResponseData = response.data.list ;
				 if(apiResponseData[0] && apiResponseData[0].questionSet){					
					setCurrentQuestion(apiResponseData[0].lastQuestionIndex); 
					if(apiResponseData[0].lastQuestionIndex>0 && document.getElementById('questionBox'+apiResponseData[0].lastQuestionIndex)){
						document.getElementById('questionBox'+apiResponseData[0].lastQuestionIndex).style.display="";
					}else if(document.getElementById('questionBox'+currentQuestion)){
						document.getElementById('questionBox'+currentQuestion).style.display="";
					}
					setTotalQuestion(Object.keys(apiResponseData[0].questionSet).length);
					resetTimerRef.current.resetTimer(1);
					if(document.getElementById('notVisitedTotalDivId')){
						document.getElementById('notVisitedTotalDivId').innerHTML=Object.keys(apiResponseData[0].questionSet).length;
					}
					/*********** POPULATE STARTING ************************/
						// let currentNotVisitedTotal=0;
						// let currentAnsweredReviewTotal=0;
						// let currentReviewTotal=0;
						// let currentNotAnsweredTotal=0;
						// let currentAnsweredTotal=0;			
						for(let i=0; i<apiResponseData[0].questionSet.length; i++){
							if(apiResponseData[0].questionSet[i].columns && apiResponseData[0].questionSet[i].questionType.toLowerCase()==='mr-matching-type'){
								let counterA=0;
								for(let j=0; j<apiResponseData[0].questionSet[i].columns[0].columnRows.length; j++){
									for(let k=0; k<apiResponseData[0].questionSet[i].columns[1].columnRows.length; k++){
										if(apiResponseData[0].questionSet[i].studentResponse && apiResponseData[0].questionSet[i].studentResponse.indexOf(alphaArr[counterA])>-1 ){
											document.getElementById("ans"+apiResponseData[0].questionSet[i].questionId+"a"+(counterA+1)).checked=true;
										}
										counterA++;
									}
								}
							}else if(apiResponseData[0].questionSet[i].responseChoice && apiResponseData[0].questionSet[i].questionType.toLowerCase()==='fill-in-blank'){					
								document.getElementById("ans"+apiResponseData[0].questionSet[i].questionId+"a").value=apiResponseData[0].questionSet[i].studentResponse;

							}else if(apiResponseData[0].questionSet[i].responseChoice){
								for(let j=0; j<apiResponseData[0].questionSet[i].responseChoice.length; j++){
									if(apiResponseData[0].questionSet[i].responseChoice[j] && apiResponseData[0].questionSet[i].responseChoice[j].responseId===apiResponseData[0].questionSet[i].studentResponse){
										document.getElementById("ans"+apiResponseData[0].questionSet[i].questionId+"a"+j).checked=true;
									}
								}
							}

							// let questionId = apiResponseData[0].questionSet[i].questionId;			
							// if(questionId && apiResponseData[0].questionSet[i].backgroundImg.indexOf('answered-review.png')>-1){
							// 	currentAnsweredReviewTotal++;
							// }else if(questionId && apiResponseData[0].questionSet[i].backgroundImg.indexOf('review.png')>-1){
							// 	currentReviewTotal++;
							// }else if(questionId && apiResponseData[0].questionSet[i].backgroundImg.indexOf('not-answered.png')>-1){
							// 	currentNotAnsweredTotal++;
							// }else if(questionId && apiResponseData[0].questionSet[i].backgroundImg.indexOf('answered.png')>-1){
							// 	currentAnsweredTotal++;
							// }else{
							// 	currentNotVisitedTotal++;
							// }
				
						}
					/*********** POPULATE ENDING ************************/
				}				
			}).catch((error) => {
				console.log("AXIOS ERROR: ", error);
			})
	}

    function openTopNav(divid) {
		document.getElementById(divid).style.width = "250px";
		document.getElementById('questionPanelId').classList.remove("questionPanelFull");
		document.getElementById('questionPanelId').classList.add("questionPanelShort");
	}
	  
	function closeTopNav(divid) {
		document.getElementById(divid).style.width = "0";
		document.getElementById('questionPanelId').classList.add("questionPanelFull");
		document.getElementById('questionPanelId').classList.remove("questionPanelShort");
	}
	  
	function hideAlert(){
		setShowAlert(false);
	}

	function sectionDialogHide(){
		setSectionDialogShow(false);
	}



	function convertToArray(str){
		let retArr = [];
		if(str.length>0){
			let strArr = str.split("<math");
			for(let i=0; i<strArr.length; i++){
				if(strArr[i].indexOf("</math>")>-1 && strArr[i].indexOf("xmlns=")>-1){
					let strZArr = strArr[i].split("</math>");
					if(strZArr[0] && strZArr[0].indexOf("xmlns=")>-1){
						retArr.push("<math "+strZArr[0]+"</math>");
					}
					if(strZArr[1]){
						retArr.push(strZArr[1]);
					}
				}else{
					retArr.push(strArr[i]);
				}
			}
		}

		return retArr;
	}

 /* RIGHT CLICK DISABLED ON THIS COMPONENT */
//  document.addEventListener("contextmenu", (event) => {
// 	event.preventDefault();
//   });

  /* CTRL KEY DISABLED ON THIS COMPONENT */
//   document.addEventListener("keydown", function (event) {
//     if (event.ctrlKey) {
//         event.preventDefault();
//     }   
//   });

  /* REFRESH PAGE DISABLED ON THIS COMPONENT */
//   if (window.performance) {
// 	if (performance.navigation.type === performance.navigation.TYPE_RELOAD) {
// 		document.addEventListener("keydown", function (event) {
// 			if ((event.which || event.keyCode) === 116 || (event.which || event.keyCode) === 17 || ((event.which || event.keyCode) === 82 )) {
// 				// Pressing F5 or Ctrl+R
// 				event.preventDefault();
// 			}   
// 		  });  
// 	} 
//   }

	function backToWindow() {
		window.location.href='/scheduledtest';
	}

	return (
			<div> 
				<MetaTags>
            		<title>Test Simulator</title>
            		<meta name="description" content="Test Simulator" />
          		</MetaTags>
				
				<Container>					
				{(document.readyState!=="complete")?<LinearProgress />:null}

		{(testSet!==null && testSet[0] && testSet[0].questionSet)?<>
				<Stack spacing={2} sx={{ width: '100%' }}>
					<Snackbar open={showAlert} autoHideDuration={6000} onClose={hideAlert} anchorOrigin={{vertical,horizontal}}  >
						<Alert onClose={hideAlert} variant="filled" severity="error" sx={{ width: '100%' }}>
							{alertMessage}
						</Alert>
					</Snackbar>
				</Stack>

				<Dialog
					open={sectionDialogShow}
					onClose={sectionDialogHide}
					aria-labelledby="alert-dialog-section-title"
					aria-describedby="alert-dialog-section-description"
				>
					<DialogTitle id="alert-dialog-section-title">
						Alert
					</DialogTitle>
					<DialogContent>
					<DialogContentText id="alert-dialog-section-description">
						Are you sure, You want to move to next section.<br/>
						You would not be able to move previous section after moving.
					</DialogContentText>
					</DialogContent>
					<DialogActions>
					<Button variant="outlined" size="small" onClick={sectionDialogHide}>Don't Move</Button>
					<Button variant="contained" size="small" color="primary" onClick={agreeToJumpSection} autoFocus>Okay, Move</Button>
					</DialogActions>
				</Dialog>
				
				<Box mt={1} className="noselect" >
						<Grid container spacing={2}>
							<Grid item   md={6} xs={12}>
							{testSet[0]?<span className='test-name' >{testSet[0].testName}</span>:null}
							</Grid>							
						</Grid>
				</Box>

		<Box id="questionPanelId" className="questionPanelShort" >	
		{(testSet[0] && testSet[0].questionSet)?testSet[0].questionSet.map((myQuestion,myqnum) => (
				<Box key={'qes'+myqnum} className="noselect" id={'questionBox'+myqnum} style={{display:'none'}}  >
						<Grid container spacing={2} >
							<Grid item md={12} xs={12} >								
								{myQuestion.sectionName?<div className='taglabelblu mr5' >Section: {myQuestion.sectionName}</div>:null}
								<div className='taglabelblu mr5' >Question Type: {myQuestion.questionTypeLabel}</div>
								<div className='taglabelblu mr5' >Question Id: {myQuestion.questionDisplayId}</div>
								<span className='taglabelgreen mr5' >Correct: {myQuestion.correctAnswerMarks}</span>
								<span className='taglabelred mr5' >Incorrect: {myQuestion.incorrectAnswerMarks}</span>
								<span className='taglabelyellow' >Not Answer: {myQuestion.notAnswerMarks}</span>	
							</Grid>
							<Grid item md={12} xs={12} className="questionBox" >
								{myQuestion.commonDataDescription?<p className="preWrap animate-zoom" >
									{
										 convertToArray(myQuestion.commonDataDescription).map((myChunk,index) => (
										 	(myChunk.indexOf("<math")>-1 && myChunk.indexOf("</math>")>-1  && myChunk.indexOf("xmlns=")>-1)?<MathComponent mathml={myChunk} />:<div key={'cddaa'+index} dangerouslySetInnerHTML={{ __html: myChunk }} />
										 ))										
									}
								</p>:null}
								<p className="preWrap animate-zoom" >
								<span className="questionNum" >Question {myqnum+1}: </span> 
								{myQuestion.questionBody?<span>
									{
										 convertToArray(myQuestion.questionBody).map((myChunk,index) => (
										 	(myChunk.indexOf("<math")>-1 && myChunk.indexOf("</math>")>-1  && myChunk.indexOf("xmlns=")>-1)?<MathComponent mathml={myChunk} />:<div key={'cddaa'+index} dangerouslySetInnerHTML={{ __html: myChunk }} />
										 ))										
									}
								</span>:null}										
								</p>
								{
									myQuestion.columns?
									<p className="animate-zoom">
										<table width="100%">
											<tr>
												{
													myQuestion.columns.map((myRow,index) => (	
														<td className="btmbdrgry pdlft10"><h3>{myRow.columnHeader}</h3></td>
													))		
  												}
											</tr>	
												<tr>
												{myQuestion.columns.map((myCol,indexCol) => (
													<td><table width="100%">{
														myCol.columnRows.map((myRow,indexrrr) => (
															<tr>
															<td key={'crwq'+indexrrr+'dd'+indexCol} className="btmbdrgry pdlft10 content-justify preWrap" >
																{myRow.rowId}.&nbsp;
																{myRow.rowName?
																 	convertToArray(myRow.rowName).map((myChunk,indexccc) => (
																 		(myChunk.indexOf("<math")>-1 && myChunk.indexOf("</math>")>-1  && myChunk.indexOf("xmlns=")>-1)?<MathComponent mathml={myChunk} />:<div key={'cddddaa'+indexccc} dangerouslySetInnerHTML={{ __html: myChunk }} />
																 	))			
																 :null														
																}
																</td>
															</tr>
														))
  														}</table>
													</td>
												))}
												</tr>
										</table>
									</p>
									:null
								}
								<p className="answerBox animate-zoom" >
								{
									myQuestion.questionType==='Matching-Type'?
										<table><span hidden>{counterMRMT=0}</span>
											<tr><th className="mrmtcol" ></th>{myQuestion.columns[1].columnRows.map((myRow,index) => (<th key={'mrmatch'+index} className="mrmtcol" >{myRow.rowId}</th>))}</tr>
											{myQuestion.columns[0].columnRows.map((myRowLeft,indexLeft) => (
												<tr key={'trmmt'+indexLeft} ><th className="mrmtcol" >{myRowLeft.rowId}</th>{myQuestion.columns[1].columnRows.map((myRowRight,indexRight) => (<td key={'mrmtchkb'+indexRight} className={(myQuestion.studentResponse && myQuestion.correctResponse && (myQuestion.correctResponse.indexOf(alphaArr[counterMRMT])>-1 && myQuestion.studentResponse.indexOf(alphaArr[counterMRMT])>-1))?"mrmtcol bggreenans":(myQuestion.studentResponse && myQuestion.correctResponse && (myQuestion.correctResponse.indexOf(alphaArr[counterMRMT])===-1 && myQuestion.studentResponse.indexOf(alphaArr[counterMRMT])>-1))?"mrmtcol bgredans":"mrmtcol"} ><input disabled type="radio" id={"ans"+myQuestion.questionId+"a"+(counterMCMT=counterMCMT+1)} value={alphaArr[counterMRMT-1]} name={"ans"+myQuestion.questionId+'tr'+indexLeft} className="inputRadio" /></td>))}</tr>
											))}
										</table>
									:myQuestion.questionType==='MR-Matching-Type'?
										<table><span hidden>{counterMRMT=0}</span>
											<tr><th className="mrmtcol" ></th>{myQuestion.columns[1].columnRows.map((myRow,index) => (<th key={'mrmatch'+index} className="mrmtcol" >{myRow.rowId}</th>))}</tr>
											{myQuestion.columns[0].columnRows.map((myRowLeft,indexLeft) => (
												<tr key={'trmmt'+indexLeft} ><th className="mrmtcol" >{myRowLeft.rowId}</th>{myQuestion.columns[1].columnRows.map((myRowRight,indexRight) => (<td key={'mrmtchkb'+indexRight} className={(myQuestion.correctResponse && (myQuestion.correctResponse.indexOf(alphaArr[counterMRMT])>-1 ))?"mrmtcol bggreenans":(myQuestion.studentResponse && myQuestion.correctResponse && (myQuestion.correctResponse.indexOf(alphaArr[counterMRMT])===-1 && myQuestion.studentResponse.indexOf(alphaArr[counterMRMT])>-1))?"mrmtcol bgredans":"mrmtcol"} ><input disabled type="checkbox" id={"ans"+myQuestion.questionId+"a"+(counterMRMT=counterMRMT+1)} value={alphaArr[counterMRMT-1]} className="inputRadio" /></td>))}</tr>
											))}
										</table>	
									:myQuestion.questionType==='Multiple-Response'?
										myQuestion.responseChoice.map((myRow,index) => (
											<p key={'qkey'+myqnum+index} id={'qmrid'+myqnum+index} >										
												<span className="inputSpan" ><input disabled type="checkbox" id={"ans"+myQuestion.questionId+"a"+index} value={myRow.responseId} className="inputRadio" /></span>	
												<span className="inputLable content-justify preWrap" >
													<label for={"ans"+myQuestion.questionId+"a"+index} >														
														{myRow.responseText?
															convertToArray(myRow.responseText).map((myChunk,indexccc) => (
																(myChunk.indexOf("<math")>-1 && myChunk.indexOf("</math>")>-1  && myChunk.indexOf("xmlns=")>-1)?<MathComponent mathml={myChunk} />:<div key={'cddddaa'+indexccc} dangerouslySetInnerHTML={{ __html: myChunk }} />
															))			
														:null														
														}
														{(myQuestion.correctResponse && myQuestion.correctResponse.indexOf(myRow.responseId)>-1)?<span className='correct-answer'><i className="fa fa-check"></i> Correct Answer</span>:null}														
														{(myQuestion.studentResponse && myQuestion.studentResponse.indexOf(myRow.responseId)>-1 && myQuestion.studentResponse!==myQuestion.correctResponse)?<span className='incorrect-answer'>You selected</span>:null}														
													</label>
												</span>
											</p>
										))
									:myQuestion.questionType==='Integer-Type'?	
										<table><tr>{	
									    myQuestion.responseChoice.map((myRow,index) => (
											<td key={'atdit'+index} className={(myRow.responseId===myQuestion.correctResponse)?"correct-answer":(myRow.responseId===myQuestion.studentResponse && myRow.responseId!==myQuestion.correctResponse)?"incorrect-answer":null} >	
												<span className="inputSpan" ><input disabled value={myRow.responseId} type="radio" id={"ans"+myQuestion.questionId+"a"+index} onClick={()=>{uncheckHandle("ans"+myQuestion.questionId+"a"+index)}} name={"ans"+myQuestion.questionId} className="inputRadio" /></span>	
												<span className="inputLableIT"><label for={"ans"+myQuestion.questionId+"a"+index} >{myRow.responseText}</label></span> 
												<input type="hidden" id={"hidetxtans"+myQuestion.questionId+"a"+index} />
											</td>
										))}
										</tr></table>
									:(myQuestion.questionType==='Fill-In-Blank' || myQuestion.questionType==='Fill-in-Blank')?	
										<table><tr>
											<td>
											<input disabled type="text" id={"ans"+myQuestion.questionId+"a"} value={myQuestion.studentResponse} placeholder="Enter your answer" />
											{(myQuestion.studentResponse && myQuestion.studentResponse===myQuestion.correctResponse)?<span className='correct-answer'><i className="fa fa-check"></i> Correct Answer</span>:(myQuestion.studentResponse && myQuestion.studentResponse!==myQuestion.correctResponse)?<span className='incorrect-answer'><i className="fa fa-times"></i> Incorrect Answer</span>:null}
											</td>
										</tr></table>
									:myQuestion.responseChoice.map((myRow,index) => (	
										<p key={'qkey'+myqnum+index} id={'qmrid'+myqnum+index} >
											<span className="inputSpan" ><input disabled value={myRow.responseId} type="radio" id={"ans"+myQuestion.questionId+"a"+index} onClick={()=>{uncheckHandle("ans"+myQuestion.questionId+"a"+index)}} name={"ans"+myQuestion.questionId} className="inputRadio" /></span>	
											<span className="inputLable content-justify preWrap" >
												<label for={"ans"+myQuestion.questionId+"a"+index} >
													{myRow.responseText?
														convertToArray(myRow.responseText).map((myChunk,indexccc) => (
															(myChunk.indexOf("<math")>-1 && myChunk.indexOf("</math>")>-1  && myChunk.indexOf("xmlns=")>-1)?<MathComponent mathml={myChunk} />:<div key={'cddddaa'+indexccc} dangerouslySetInnerHTML={{ __html: myChunk }} />
														))			
													:null														
													}
													{(myRow.responseId===myQuestion.correctResponse)?<span className='correct-answer'><i className="fa fa-check"></i> Correct Answer</span>:null}														
													{(myRow.responseId===myQuestion.studentResponse && myQuestion.studentResponse!==myQuestion.correctResponse)?<span className='incorrect-answer'><i className="fa fa-times"></i> You selected incorrect</span>:null}														
												</label>													
											</span> 
											<input type="hidden" id={"hidetxtans"+myQuestion.questionId+"a"+index} />
										</p>										
									))									
								}
								</p>

								{(myQuestion.explanations!==null && myQuestion.explanations.length>0)?<p><span className="questionNum" >Explanation: </span>{
									convertToArray(myQuestion.explanations).map((myChunk,indexccc) => (
										(myChunk.indexOf("<math")>-1 && myChunk.indexOf("</math>")>-1  && myChunk.indexOf("xmlns=")>-1)?<MathComponent mathml={myChunk} />:<div key={'cddddaa'+indexccc} dangerouslySetInnerHTML={{ __html: myChunk }} />
									))
								}</p>:null}

							</Grid>
						</Grid>
				</Box>
		)):null}
		</Box>			

			{testSet[0]?					
				<Box className='bottomBoxFixed' >
						<Grid container >
							<Grid item md={12} xs={12} className="textButtonBox" >
								{currentQuestion>0?<Button title="Previous" variant="contained" onClick={() => { backHandle() }} color="primary" >Back</Button>:null}
								<Button title="Next" variant="contained" onClick={() => { nextHandle() }} color="primary" >Next</Button>
								<Button title="Close Window" variant="contained" onClick={() => { backToWindow() }} color="secondary" >Close Window</Button>
							</Grid>
						</Grid>
				</Box>
			:null}	

				{/* Side panel starting */}
				{testSet[0]?<>
				<div className="sidepanelOpen">
					<Button className="openbtn" onClick={() => { openTopNav('mySidepanel') }} ><i className="fa fa-chevron-left"></i></Button>		
				</div>				
				<div id="mySidepanel" className="sidepanel"> 
						<Button className="closebtn" onClick={() => { closeTopNav('mySidepanel') }} ><i className="fa fa-chevron-right"></i></Button>		

					<Box className="noselect qnumBox" style={{height:'96vh'}} >
						<Grid container spacing={2}>
							<Grid item md={12} xs={12}  >
							{(testSet[0] && testSet[0].sectionSet)?testSet[0].sectionSet.map((myQus,secIndex) => (
								<>
									{myQus.sectionName?<div key={'secnm'+secIndex} className="sectionq clrboth">{myQus.sectionName}</div>:null}
									{myQus.questionNumbers.map((myQN,numIndex) => (
										<>{/*testSet[0].questionSet[myQN.questionIndex].studentResponse*/}									
										<span key={'ansnm'+numIndex} id={'ans'+myQN.questionId} hidden ></span>
										<Button key={'secbtn'+numIndex} className={testSet[0].questionSet[myQN.questionIndex].cssName} style={{background:testSet[0].questionSet[myQN.questionIndex].backgroundImg}} onClick={() => { jumpToQuestion(parseInt(myQN.questionIndex)) }} title={'Go to question: '+(parseInt(myQN.questionIndex)+1)} >{parseInt(myQN.questionIndex)+1}</Button>										
										</>
									))}
								</>
							)):null}
							</Grid>
						</Grid>
					</Box>	
									
				</div>
				</>:null}
				{/* Side panel ending */}

		</>:"Wait..."}


		</Container>

		</div>
	);
 
}




